/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import tip.node.*;

/**
 * {@code Analysis} defines the interface for node based analyses.
 * The analysis provides to maps, {@code in} and {@code out}, for
 * associating {@link Node} nodes to {@link Object} values.
 *
 * The interface is a visitor pattern.
 */
public interface Analysis {
	/**
	 * Returns the {@link Object} associated with the {@link Node} {@code node} in the {@code in} map.
	 * @return the {@link Object} associated with the {@link Node} {@code node} in the {@code in} map
	 */
    Object getIn(Node node);
    
    /**
     * Sets the {@link Object} {@code o} to be a associated with the {@link Node} {@code node} in the {@code in} map.
     * @param node the {@link Node} to which {@link Object} {@code o} is to be associated.
     * @param o the {@link Object} to be associated with the {@link Node} {@code node} in the {@code in} map
     */
    void setIn(Node node, Object o);

	/**
	 * Returns the {@link Object} associated with the {@link Node} {@code node} in the {@code out} map.
	 * @return the {@link Object} associated with the {@link Node} {@code node} in the {@code out} map
	 */
    Object getOut(Node node);

    /**
     * Sets the {@link Object} {@code o} to be a associated with the {@link Node} {@code node} in the {@code out} map.
     * @param node the {@link Node} to which {@link Object} {@code o} is to be associated.
     * @param o the {@link Object} to be associated with the {@link Node} {@code node} in the {@code out} map
     */
    void setOut(Node node, Object o);

	/**
	 * Called by the {@link Start} node from {@link Start#apply(Switch)}.
	 * @param node the calling {@link Start} node
	 */
    void caseStart(Start node);
	/**
	 * Called by the {@link AProgram} node from {@link AProgram#apply(Switch)}.
	 * @param node the calling {@link AProgram} node
	 */
    void caseAProgram(AProgram node);
	/**
	 * Called by the {@link AFuncDecl} node from {@link AFuncDecl#apply(Switch)}.
	 * @param node the calling {@link AFuncDecl} node
	 */
    void caseAFuncDecl(AFuncDecl node);
	/**
	 * Called by the {@link ALocalDecl} node from {@link ALocalDecl#apply(Switch)}.
	 * @param node the calling {@link ALocalDecl} node
	 */
    void caseALocalDecl(ALocalDecl node);
	/**
	 * Called by the {@link ABody} node from {@link ABody#apply(Switch)}.
	 * @param node the calling {@link ABody} node
	 */
    void caseABody(ABody node);
	/**
	 * Called by the {@link ABlock} node from {@link ABlock#apply(Switch)}.
	 * @param node the calling {@link ABlock} node
	 */
    void caseABlock(ABlock node);
	/**
	 * Called by the {@link APlusBinop} node from {@link APlusBinop#apply(Switch)}.
	 * @param node the calling {@link APlusBinop} node
	 */
    void caseAPlusBinop(APlusBinop node);
	/**
	 * Called by the {@link AMinusBinop} node from {@link AMinusBinop#apply(Switch)}.
	 * @param node the calling {@link AMinusBinop} node
	 */
    void caseAMinusBinop(AMinusBinop node);
	/**
	 * Called by the {@link ATimesBinop} node from {@link ATimesBinop#apply(Switch)}.
	 * @param node the calling {@link ATimesBinop} node
	 */
    void caseATimesBinop(ATimesBinop node);
	/**
	 * Called by the {@link ADivideBinop} node from {@link ADivideBinop#apply(Switch)}.
	 * @param node the calling {@link ADivideBinop} node
	 */
    void caseADivideBinop(ADivideBinop node);
	/**
	 * Called by the {@link AEqBinop} node from {@link AEqBinop#apply(Switch)}.
	 * @param node the calling {@link AEqBinop} node
	 */
    void caseAEqBinop(AEqBinop node);
	/**
	 * Called by the {@link AGtBinop} node from {@link AGtBinop#apply(Switch)}.
	 * @param node the calling {@link AGtBinop} node
	 */
    void caseAGtBinop(AGtBinop node);
	/**
	 * Called by the {@link ABinopExp} node from {@link ABinopExp#apply(Switch)}.
	 * @param node the calling {@link ABinopExp} node
	 */
    void caseABinopExp(ABinopExp node);
	/**
	 * Called by the {@link APointerExp} node from {@link APointerExp#apply(Switch)}.
	 * @param node the calling {@link APointerExp} node
	 */
    void caseAPointerExp(APointerExp node);
	/**
	 * Called by the {@link ADerefExp} node from {@link ADerefExp#apply(Switch)}.
	 * @param node the calling {@link ADerefExp} node
	 */
    void caseADerefExp(ADerefExp node);
	/**
	 * Called by the {@link AIntConstExp} node from {@link AIntConstExp#apply(Switch)}.
	 * @param node the calling {@link AIntConstExp} node
	 */
    void caseAIntConstExp(AIntConstExp node);
	/**
	 * Called by the {@link AFunctionCallExp} node from {@link AFunctionCallExp#apply(Switch)}.
	 * @param node the calling {@link AFunctionCallExp} node
	 */
    void caseAFunctionCallExp(AFunctionCallExp node);
	/**
	 * Called by the {@link AFunctionPtrCallExp} node from {@link AFunctionPtrCallExp#apply(Switch)}.
	 * @param node the calling {@link AFunctionPtrCallExp} node
	 */
    void caseAFunctionPtrCallExp(AFunctionPtrCallExp node);
	/**
	 * Called by the {@link AVarExp} node from {@link AVarExp#apply(Switch)}.
	 * @param node the calling {@link AVarExp} node
	 */
    void caseAVarExp(AVarExp node);
	/**
	 * Called by the {@link AInputExp} node from {@link AInputExp#apply(Switch)}.
	 * @param node the calling {@link AInputExp} node
	 */
    void caseAInputExp(AInputExp node);
	/**
	 * Called by the {@link AMallocExp} node from {@link AMallocExp#apply(Switch)}.
	 * @param node the calling {@link AMallocExp} node
	 */
    void caseAMallocExp(AMallocExp node);
	/**
	 * Called by the {@link ANullExp} node from {@link ANullExp#apply(Switch)}.
	 * @param node the calling {@link ANullExp} node
	 */
    void caseANullExp(ANullExp node);
	/**
	 * Called by the {@link AIfThenStm} node from {@link AIfThenStm#apply(Switch)}.
	 * @param node the calling {@link AIfThenStm} node
	 */
    void caseAIfThenStm(AIfThenStm node);
	/**
	 * Called by the {@link AIfThenElseStm} node from {@link AIfThenElseStm#apply(Switch)}.
	 * @param node the calling {@link AIfThenElseStm} node
	 */
    void caseAIfThenElseStm(AIfThenElseStm node);
	/**
	 * Called by the {@link AWhileStm} node from {@link AWhileStm#apply(Switch)}.
	 * @param node the calling {@link AWhileStm} node
	 */
    void caseAWhileStm(AWhileStm node);
	/**
	 * Called by the {@link ADeclStm} node from {@link ADeclStm#apply(Switch)}.
	 * @param node the calling {@link ADeclStm} node
	 */
    void caseADeclStm(ADeclStm node);
	/**
	 * Called by the {@link AReturnStm} node from {@link AReturnStm#apply(Switch)}.
	 * @param node the calling {@link AReturnStm} node
	 */
    void caseAReturnStm(AReturnStm node);
	/**
	 * Called by the {@link AOutputStm} node from {@link AOutputStm#apply(Switch)}.
	 * @param node the calling {@link AOutputStm} node
	 */
    void caseAOutputStm(AOutputStm node);
	/**
	 * Called by the {@link AAssignVarStm} node from {@link AAssignVarStm#apply(Switch)}.
	 * @param node the calling {@link AAssignVarStm} node
	 */
    void caseAAssignVarStm(AAssignVarStm node);
	/**
	 * Called by the {@link AAssignPtrStm} node from {@link AAssignPtrStm#apply(Switch)}.
	 * @param node the calling {@link AAssignPtrStm} node
	 */
    void caseAAssignPtrStm(AAssignPtrStm node);
	/**
	 * Called by the {@link ABlockStm} node from {@link ABlockStm#apply(Switch)}.
	 * @param node the calling {@link ABlockStm} node
	 */
    void caseABlockStm(ABlockStm node);

	/**
	 * Called by the {@link TWhiteSpace} node from {@link TWhiteSpace#apply(Switch)}.
	 * @param node the calling {@link TWhiteSpace} node
	 */
    void caseTWhiteSpace(TWhiteSpace node);
	/**
	 * Called by the {@link TCommentSingle} node from {@link TCommentSingle#apply(Switch)}.
	 * @param node the calling {@link TCommentSingle} node
	 */
    void caseTCommentSingle(TCommentSingle node);
	/**
	 * Called by the {@link TCommentBlock} node from {@link TCommentBlock#apply(Switch)}.
	 * @param node the calling {@link TCommentBlock} node
	 */
    void caseTCommentBlock(TCommentBlock node);
	/**
	 * Called by the {@link TVar} node from {@link TVar#apply(Switch)}.
	 * @param node the calling {@link TVar} node
	 */
    void caseTVar(TVar node);
	/**
	 * Called by the {@link TInput} node from {@link TInput#apply(Switch)}.
	 * @param node the calling {@link TInput} node
	 */
    void caseTInput(TInput node);
	/**
	 * Called by the {@link TOutput} node from {@link TOutput#apply(Switch)}.
	 * @param node the calling {@link TOutput} node
	 */
    void caseTOutput(TOutput node);
	/**
	 * Called by the {@link TIf} node from {@link TIf#apply(Switch)}.
	 * @param node the calling {@link TIf} node
	 */
    void caseTIf(TIf node);
	/**
	 * Called by the {@link TElse} node from {@link TElse#apply(Switch)}.
	 * @param node the calling {@link TElse} node
	 */
    void caseTElse(TElse node);
	/**
	 * Called by the {@link TWhile} node from {@link TWhile#apply(Switch)}.
	 * @param node the calling {@link TWhile} node
	 */
    void caseTWhile(TWhile node);
	/**
	 * Called by the {@link TReturn} node from {@link TReturn#apply(Switch)}.
	 * @param node the calling {@link TReturn} node
	 */
    void caseTReturn(TReturn node);
	/**
	 * Called by the {@link TMalloc} node from {@link TMalloc#apply(Switch)}.
	 * @param node the calling {@link TMalloc} node
	 */
    void caseTMalloc(TMalloc node);
	/**
	 * Called by the {@link TNull} node from {@link TNull#apply(Switch)}.
	 * @param node the calling {@link TNull} node
	 */
    void caseTNull(TNull node);
	/**
	 * Called by the {@link TLPar} node from {@link TLPar#apply(Switch)}.
	 * @param node the calling {@link TLPar} node
	 */
    void caseTLPar(TLPar node);
	/**
	 * Called by the {@link TRPar} node from {@link TRPar#apply(Switch)}.
	 * @param node the calling {@link TRPar} node
	 */
    void caseTRPar(TRPar node);
	/**
	 * Called by the {@link TLBrace} node from {@link TLBrace#apply(Switch)}.
	 * @param node the calling {@link TLBrace} node
	 */
    void caseTLBrace(TLBrace node);
	/**
	 * Called by the {@link TRBrace} node from {@link TRBrace#apply(Switch)}.
	 * @param node the calling {@link TRBrace} node
	 */
    void caseTRBrace(TRBrace node);
	/**
	 * Called by the {@link TSemicolon} node from {@link TSemicolon#apply(Switch)}.
	 * @param node the calling {@link TSemicolon} node
	 */
    void caseTSemicolon(TSemicolon node);
	/**
	 * Called by the {@link TComma} node from {@link TComma#apply(Switch)}.
	 * @param node the calling {@link TComma} node
	 */
    void caseTComma(TComma node);
	/**
	 * Called by the {@link TAssign} node from {@link TAssign#apply(Switch)}.
	 * @param node the calling {@link TAssign} node
	 */
    void caseTAssign(TAssign node);
	/**
	 * Called by the {@link TPlus} node from {@link TPlus#apply(Switch)}.
	 * @param node the calling {@link TPlus} node
	 */
    void caseTPlus(TPlus node);
	/**
	 * Called by the {@link TMinus} node from {@link TMinus#apply(Switch)}.
	 * @param node the calling {@link TMinus} node
	 */
    void caseTMinus(TMinus node);
	/**
	 * Called by the {@link TStar} node from {@link TStar#apply(Switch)}.
	 * @param node the calling {@link TStar} node
	 */
    void caseTStar(TStar node);
	/**
	 * Called by the {@link TDiv} node from {@link TDiv#apply(Switch)}.
	 * @param node the calling {@link TDiv} node
	 */
    void caseTDiv(TDiv node);
	/**
	 * Called by the {@link TAnd} node from {@link TAnd#apply(Switch)}.
	 * @param node the calling {@link TAnd} node
	 */
    void caseTAnd(TAnd node);
	/**
	 * Called by the {@link TGt} node from {@link TGt#apply(Switch)}.
	 * @param node the calling {@link TGt} node
	 */
    void caseTGt(TGt node);
	/**
	 * Called by the {@link TEq} node from {@link TEq#apply(Switch)}.
	 * @param node the calling {@link TEq} node
	 */
    void caseTEq(TEq node);
	/**
	 * Called by the {@link TIntegerConst} node from {@link TIntegerConst#apply(Switch)}.
	 * @param node the calling {@link TIntegerConst} node
	 */
    void caseTIntegerConst(TIntegerConst node);
	/**
	 * Called by the {@link TIdentifier} node from {@link TIdentifier#apply(Switch)}.
	 * @param node the calling {@link TIdentifier} node
	 */
    void caseTIdentifier(TIdentifier node);
	/**
	 * Called by the {@link EOF} node from {@link EOF#apply(Switch)}.
	 * @param node the calling {@link EOF} token
	 */
    void caseEOF(EOF node);
}
