/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import java.util.*;
import tip.node.*;

/**
 * {@code AnalysisAdapter} provides a basic implementation of {@link Analysis}.
 * {@code case}-methods for alternatives are forwarded to the {@code defaultP}-method
 * of their production superclass. {@code case}-methods for tokens are forwarded to
 * the {@link #defaultToken(Token)} method, and all {@code default-} methods are
 * forwarded to {@link #defaultNode(Node)}.
 */
public class AnalysisAdapter implements Analysis {
    private Hashtable<Node,Object> in;
    private Hashtable<Node,Object> out;

	/**
	 * Returns the {@link Object} associated with the {@link Node} {@code node} in the {@code in} map.
	 * @return the {@link Object} associated with the {@link Node} {@code node} in the {@code in} map
	 */
    public Object getIn(Node node) {
        if(this.in == null) {
            return null;
        }

        return this.in.get(node);
    }

    /**
     * Sets the {@link Object} {@code o} to be a associated with the {@link Node} {@code node} in the {@code in} map.
     * If {@code o} is {@code null} the associated object for {@code node} is removed.
     * @param node the {@link Node} to which {@link Object} {@code o} is to be associated.
     * @param o the {@link Object} to be associated with the {@link Node} {@code node} in the {@code in} map
     */
    public void setIn(Node node, Object o) {
        if(this.in == null) {
            this.in = new Hashtable<Node,Object>(1);
        }

        if(o != null) {
            this.in.put(node, o);
        } else {
            this.in.remove(node);
        }
    }

	/**
	 * Returns the {@link Object} associated with the {@link Node} {@code node} in the {@code out} map.
	 * @return the {@link Object} associated with the {@link Node} {@code node} in the {@code out} map
	 */
    public Object getOut(Node node) {
        if(this.out == null) {
            return null;
        }

        return this.out.get(node);
    }

    /**
     * Sets the {@link Object} {@code o} to be a associated with the {@link Node} {@code node} in the {@code out} map.
     * If {@code o} is {@code null} the associated object for {@code node} is removed.
     * @param node the {@link Node} to which {@link Object} {@code o} is to be associated.
     * @param o the {@link Object} to be associated with the {@link Node} {@code node} in the {@code out} map
     */
    public void setOut(Node node, Object o) {
        if(this.out == null) {
            this.out = new Hashtable<Node,Object>(1);
        }

        if(o != null) {
            this.out.put(node, o);
        } else {
            this.out.remove(node);
        }
    }

	/**
	 * Called by the {@link Start} node from {@link Start#apply(Switch)}.
	 * @param node the calling {@link Start} node
	 */
    public void caseStart(Start node)  {
        defaultNode(node);
    }

	/**
	 * Called by the {@link AProgram} node from {@link AProgram#apply(Switch)}.
	 * @param node the calling {@link AProgram} node
	 */
    public void caseAProgram(AProgram node) {
        defaultPProgram(node);
    }

	/**
	 * Called by the {@link AFuncDecl} node from {@link AFuncDecl#apply(Switch)}.
	 * @param node the calling {@link AFuncDecl} node
	 */
    public void caseAFuncDecl(AFuncDecl node) {
        defaultPDecl(node);
    }

	/**
	 * Called by the {@link ALocalDecl} node from {@link ALocalDecl#apply(Switch)}.
	 * @param node the calling {@link ALocalDecl} node
	 */
    public void caseALocalDecl(ALocalDecl node) {
        defaultPDecl(node);
    }

	/**
	 * Called by the {@link ABody} node from {@link ABody#apply(Switch)}.
	 * @param node the calling {@link ABody} node
	 */
    public void caseABody(ABody node) {
        defaultPBody(node);
    }

	/**
	 * Called by the {@link ABlock} node from {@link ABlock#apply(Switch)}.
	 * @param node the calling {@link ABlock} node
	 */
    public void caseABlock(ABlock node) {
        defaultPBlock(node);
    }

	/**
	 * Called by the {@link APlusBinop} node from {@link APlusBinop#apply(Switch)}.
	 * @param node the calling {@link APlusBinop} node
	 */
    public void caseAPlusBinop(APlusBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link AMinusBinop} node from {@link AMinusBinop#apply(Switch)}.
	 * @param node the calling {@link AMinusBinop} node
	 */
    public void caseAMinusBinop(AMinusBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link ATimesBinop} node from {@link ATimesBinop#apply(Switch)}.
	 * @param node the calling {@link ATimesBinop} node
	 */
    public void caseATimesBinop(ATimesBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link ADivideBinop} node from {@link ADivideBinop#apply(Switch)}.
	 * @param node the calling {@link ADivideBinop} node
	 */
    public void caseADivideBinop(ADivideBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link AEqBinop} node from {@link AEqBinop#apply(Switch)}.
	 * @param node the calling {@link AEqBinop} node
	 */
    public void caseAEqBinop(AEqBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link AGtBinop} node from {@link AGtBinop#apply(Switch)}.
	 * @param node the calling {@link AGtBinop} node
	 */
    public void caseAGtBinop(AGtBinop node) {
        defaultPBinop(node);
    }

	/**
	 * Called by the {@link ABinopExp} node from {@link ABinopExp#apply(Switch)}.
	 * @param node the calling {@link ABinopExp} node
	 */
    public void caseABinopExp(ABinopExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link APointerExp} node from {@link APointerExp#apply(Switch)}.
	 * @param node the calling {@link APointerExp} node
	 */
    public void caseAPointerExp(APointerExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link ADerefExp} node from {@link ADerefExp#apply(Switch)}.
	 * @param node the calling {@link ADerefExp} node
	 */
    public void caseADerefExp(ADerefExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AIntConstExp} node from {@link AIntConstExp#apply(Switch)}.
	 * @param node the calling {@link AIntConstExp} node
	 */
    public void caseAIntConstExp(AIntConstExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AFunctionCallExp} node from {@link AFunctionCallExp#apply(Switch)}.
	 * @param node the calling {@link AFunctionCallExp} node
	 */
    public void caseAFunctionCallExp(AFunctionCallExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AFunctionPtrCallExp} node from {@link AFunctionPtrCallExp#apply(Switch)}.
	 * @param node the calling {@link AFunctionPtrCallExp} node
	 */
    public void caseAFunctionPtrCallExp(AFunctionPtrCallExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AVarExp} node from {@link AVarExp#apply(Switch)}.
	 * @param node the calling {@link AVarExp} node
	 */
    public void caseAVarExp(AVarExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AInputExp} node from {@link AInputExp#apply(Switch)}.
	 * @param node the calling {@link AInputExp} node
	 */
    public void caseAInputExp(AInputExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AMallocExp} node from {@link AMallocExp#apply(Switch)}.
	 * @param node the calling {@link AMallocExp} node
	 */
    public void caseAMallocExp(AMallocExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link ANullExp} node from {@link ANullExp#apply(Switch)}.
	 * @param node the calling {@link ANullExp} node
	 */
    public void caseANullExp(ANullExp node) {
        defaultPExp(node);
    }

	/**
	 * Called by the {@link AIfThenStm} node from {@link AIfThenStm#apply(Switch)}.
	 * @param node the calling {@link AIfThenStm} node
	 */
    public void caseAIfThenStm(AIfThenStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AIfThenElseStm} node from {@link AIfThenElseStm#apply(Switch)}.
	 * @param node the calling {@link AIfThenElseStm} node
	 */
    public void caseAIfThenElseStm(AIfThenElseStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AWhileStm} node from {@link AWhileStm#apply(Switch)}.
	 * @param node the calling {@link AWhileStm} node
	 */
    public void caseAWhileStm(AWhileStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link ADeclStm} node from {@link ADeclStm#apply(Switch)}.
	 * @param node the calling {@link ADeclStm} node
	 */
    public void caseADeclStm(ADeclStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AReturnStm} node from {@link AReturnStm#apply(Switch)}.
	 * @param node the calling {@link AReturnStm} node
	 */
    public void caseAReturnStm(AReturnStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AOutputStm} node from {@link AOutputStm#apply(Switch)}.
	 * @param node the calling {@link AOutputStm} node
	 */
    public void caseAOutputStm(AOutputStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AAssignVarStm} node from {@link AAssignVarStm#apply(Switch)}.
	 * @param node the calling {@link AAssignVarStm} node
	 */
    public void caseAAssignVarStm(AAssignVarStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link AAssignPtrStm} node from {@link AAssignPtrStm#apply(Switch)}.
	 * @param node the calling {@link AAssignPtrStm} node
	 */
    public void caseAAssignPtrStm(AAssignPtrStm node) {
        defaultPStm(node);
    }

	/**
	 * Called by the {@link ABlockStm} node from {@link ABlockStm#apply(Switch)}.
	 * @param node the calling {@link ABlockStm} node
	 */
    public void caseABlockStm(ABlockStm node) {
        defaultPStm(node);
    }

	/**
	 * Base case for all {@link PProgram} nodes.
	 * @param node the calling {@link PProgram} node
	 */
	public void defaultPProgram(PProgram node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PDecl} nodes.
	 * @param node the calling {@link PDecl} node
	 */
	public void defaultPDecl(PDecl node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PBody} nodes.
	 * @param node the calling {@link PBody} node
	 */
	public void defaultPBody(PBody node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PBlock} nodes.
	 * @param node the calling {@link PBlock} node
	 */
	public void defaultPBlock(PBlock node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PBinop} nodes.
	 * @param node the calling {@link PBinop} node
	 */
	public void defaultPBinop(PBinop node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PExp} nodes.
	 * @param node the calling {@link PExp} node
	 */
	public void defaultPExp(PExp node) {
		defaultNode(node);
	}
	/**
	 * Base case for all {@link PStm} nodes.
	 * @param node the calling {@link PStm} node
	 */
	public void defaultPStm(PStm node) {
		defaultNode(node);
	}
	/**
	 * Called by the {@link TWhiteSpace} node from {@link TWhiteSpace#apply(Switch)}.
	 * @param node the calling {@link TWhiteSpace} node
	 */
    public void caseTWhiteSpace(TWhiteSpace node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TCommentSingle} node from {@link TCommentSingle#apply(Switch)}.
	 * @param node the calling {@link TCommentSingle} node
	 */
    public void caseTCommentSingle(TCommentSingle node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TCommentBlock} node from {@link TCommentBlock#apply(Switch)}.
	 * @param node the calling {@link TCommentBlock} node
	 */
    public void caseTCommentBlock(TCommentBlock node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TVar} node from {@link TVar#apply(Switch)}.
	 * @param node the calling {@link TVar} node
	 */
    public void caseTVar(TVar node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TInput} node from {@link TInput#apply(Switch)}.
	 * @param node the calling {@link TInput} node
	 */
    public void caseTInput(TInput node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TOutput} node from {@link TOutput#apply(Switch)}.
	 * @param node the calling {@link TOutput} node
	 */
    public void caseTOutput(TOutput node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TIf} node from {@link TIf#apply(Switch)}.
	 * @param node the calling {@link TIf} node
	 */
    public void caseTIf(TIf node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TElse} node from {@link TElse#apply(Switch)}.
	 * @param node the calling {@link TElse} node
	 */
    public void caseTElse(TElse node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TWhile} node from {@link TWhile#apply(Switch)}.
	 * @param node the calling {@link TWhile} node
	 */
    public void caseTWhile(TWhile node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TReturn} node from {@link TReturn#apply(Switch)}.
	 * @param node the calling {@link TReturn} node
	 */
    public void caseTReturn(TReturn node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TMalloc} node from {@link TMalloc#apply(Switch)}.
	 * @param node the calling {@link TMalloc} node
	 */
    public void caseTMalloc(TMalloc node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TNull} node from {@link TNull#apply(Switch)}.
	 * @param node the calling {@link TNull} node
	 */
    public void caseTNull(TNull node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TLPar} node from {@link TLPar#apply(Switch)}.
	 * @param node the calling {@link TLPar} node
	 */
    public void caseTLPar(TLPar node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TRPar} node from {@link TRPar#apply(Switch)}.
	 * @param node the calling {@link TRPar} node
	 */
    public void caseTRPar(TRPar node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TLBrace} node from {@link TLBrace#apply(Switch)}.
	 * @param node the calling {@link TLBrace} node
	 */
    public void caseTLBrace(TLBrace node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TRBrace} node from {@link TRBrace#apply(Switch)}.
	 * @param node the calling {@link TRBrace} node
	 */
    public void caseTRBrace(TRBrace node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TSemicolon} node from {@link TSemicolon#apply(Switch)}.
	 * @param node the calling {@link TSemicolon} node
	 */
    public void caseTSemicolon(TSemicolon node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TComma} node from {@link TComma#apply(Switch)}.
	 * @param node the calling {@link TComma} node
	 */
    public void caseTComma(TComma node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TAssign} node from {@link TAssign#apply(Switch)}.
	 * @param node the calling {@link TAssign} node
	 */
    public void caseTAssign(TAssign node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TPlus} node from {@link TPlus#apply(Switch)}.
	 * @param node the calling {@link TPlus} node
	 */
    public void caseTPlus(TPlus node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TMinus} node from {@link TMinus#apply(Switch)}.
	 * @param node the calling {@link TMinus} node
	 */
    public void caseTMinus(TMinus node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TStar} node from {@link TStar#apply(Switch)}.
	 * @param node the calling {@link TStar} node
	 */
    public void caseTStar(TStar node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TDiv} node from {@link TDiv#apply(Switch)}.
	 * @param node the calling {@link TDiv} node
	 */
    public void caseTDiv(TDiv node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TAnd} node from {@link TAnd#apply(Switch)}.
	 * @param node the calling {@link TAnd} node
	 */
    public void caseTAnd(TAnd node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TGt} node from {@link TGt#apply(Switch)}.
	 * @param node the calling {@link TGt} node
	 */
    public void caseTGt(TGt node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TEq} node from {@link TEq#apply(Switch)}.
	 * @param node the calling {@link TEq} node
	 */
    public void caseTEq(TEq node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TIntegerConst} node from {@link TIntegerConst#apply(Switch)}.
	 * @param node the calling {@link TIntegerConst} node
	 */
    public void caseTIntegerConst(TIntegerConst node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link TIdentifier} node from {@link TIdentifier#apply(Switch)}.
	 * @param node the calling {@link TIdentifier} node
	 */
    public void caseTIdentifier(TIdentifier node) {
        defaultToken(node);
    }

	/**
	 * Called by the {@link EOF} node from {@link EOF#apply(Switch)}.
	 * @param token the calling {@link EOF} token
	 */
    public void caseEOF(EOF token) {
        defaultToken(token);
    }

	/**
	 * Base case for all tokens.
	 * @param token the calling {@link Token} token
	 */
    public void defaultToken(Token token) {
		defaultNode(token);
    }
    
	/**
	 * Base case for all nodes.
	 * @param node the calling {@link Node} node
	 */
    public void defaultNode(@SuppressWarnings("unused") Node node) {
        // do nothing
    }
}
