/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import tip.node.*;

/**
 * {@code Answer} defines an interface for the abstraction of answers based
 * on a {@link Node}. The interface is a visitor pattern.
 *
 * @param <A> the type of the answers
 *
 * @author Johnni Winther, jw@brics.dk
 */
public interface Answer<A> {

	/**
	 * Called by {@link Start} from {@link Start#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
    public A caseStart(Start node);

	/**
	 * Called by {@link AProgram} from {@link AProgram#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAProgram(AProgram node);
	
	/**
	 * Called by {@link AFuncDecl} from {@link AFuncDecl#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAFuncDecl(AFuncDecl node);
	
	/**
	 * Called by {@link ALocalDecl} from {@link ALocalDecl#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseALocalDecl(ALocalDecl node);
	
	/**
	 * Called by {@link ABody} from {@link ABody#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseABody(ABody node);
	
	/**
	 * Called by {@link ABlock} from {@link ABlock#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseABlock(ABlock node);
	
	/**
	 * Called by {@link APlusBinop} from {@link APlusBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAPlusBinop(APlusBinop node);
	
	/**
	 * Called by {@link AMinusBinop} from {@link AMinusBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAMinusBinop(AMinusBinop node);
	
	/**
	 * Called by {@link ATimesBinop} from {@link ATimesBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseATimesBinop(ATimesBinop node);
	
	/**
	 * Called by {@link ADivideBinop} from {@link ADivideBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseADivideBinop(ADivideBinop node);
	
	/**
	 * Called by {@link AEqBinop} from {@link AEqBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAEqBinop(AEqBinop node);
	
	/**
	 * Called by {@link AGtBinop} from {@link AGtBinop#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAGtBinop(AGtBinop node);
	
	/**
	 * Called by {@link ABinopExp} from {@link ABinopExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseABinopExp(ABinopExp node);
	
	/**
	 * Called by {@link APointerExp} from {@link APointerExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAPointerExp(APointerExp node);
	
	/**
	 * Called by {@link ADerefExp} from {@link ADerefExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseADerefExp(ADerefExp node);
	
	/**
	 * Called by {@link AIntConstExp} from {@link AIntConstExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAIntConstExp(AIntConstExp node);
	
	/**
	 * Called by {@link AFunctionCallExp} from {@link AFunctionCallExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAFunctionCallExp(AFunctionCallExp node);
	
	/**
	 * Called by {@link AFunctionPtrCallExp} from {@link AFunctionPtrCallExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAFunctionPtrCallExp(AFunctionPtrCallExp node);
	
	/**
	 * Called by {@link AVarExp} from {@link AVarExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAVarExp(AVarExp node);
	
	/**
	 * Called by {@link AInputExp} from {@link AInputExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAInputExp(AInputExp node);
	
	/**
	 * Called by {@link AMallocExp} from {@link AMallocExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAMallocExp(AMallocExp node);
	
	/**
	 * Called by {@link ANullExp} from {@link ANullExp#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseANullExp(ANullExp node);
	
	/**
	 * Called by {@link AIfThenStm} from {@link AIfThenStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAIfThenStm(AIfThenStm node);
	
	/**
	 * Called by {@link AIfThenElseStm} from {@link AIfThenElseStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAIfThenElseStm(AIfThenElseStm node);
	
	/**
	 * Called by {@link AWhileStm} from {@link AWhileStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAWhileStm(AWhileStm node);
	
	/**
	 * Called by {@link ADeclStm} from {@link ADeclStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseADeclStm(ADeclStm node);
	
	/**
	 * Called by {@link AReturnStm} from {@link AReturnStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAReturnStm(AReturnStm node);
	
	/**
	 * Called by {@link AOutputStm} from {@link AOutputStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAOutputStm(AOutputStm node);
	
	/**
	 * Called by {@link AAssignVarStm} from {@link AAssignVarStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAAssignVarStm(AAssignVarStm node);
	
	/**
	 * Called by {@link AAssignPtrStm} from {@link AAssignPtrStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseAAssignPtrStm(AAssignPtrStm node);
	
	/**
	 * Called by {@link ABlockStm} from {@link ABlockStm#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseABlockStm(ABlockStm node);
	

	/**
	 * Called by {@link TWhiteSpace} from {@link TWhiteSpace#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTWhiteSpace(TWhiteSpace node);
	
	/**
	 * Called by {@link TCommentSingle} from {@link TCommentSingle#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTCommentSingle(TCommentSingle node);
	
	/**
	 * Called by {@link TCommentBlock} from {@link TCommentBlock#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTCommentBlock(TCommentBlock node);
	
	/**
	 * Called by {@link TVar} from {@link TVar#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTVar(TVar node);
	
	/**
	 * Called by {@link TInput} from {@link TInput#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTInput(TInput node);
	
	/**
	 * Called by {@link TOutput} from {@link TOutput#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTOutput(TOutput node);
	
	/**
	 * Called by {@link TIf} from {@link TIf#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTIf(TIf node);
	
	/**
	 * Called by {@link TElse} from {@link TElse#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTElse(TElse node);
	
	/**
	 * Called by {@link TWhile} from {@link TWhile#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTWhile(TWhile node);
	
	/**
	 * Called by {@link TReturn} from {@link TReturn#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTReturn(TReturn node);
	
	/**
	 * Called by {@link TMalloc} from {@link TMalloc#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTMalloc(TMalloc node);
	
	/**
	 * Called by {@link TNull} from {@link TNull#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTNull(TNull node);
	
	/**
	 * Called by {@link TLPar} from {@link TLPar#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTLPar(TLPar node);
	
	/**
	 * Called by {@link TRPar} from {@link TRPar#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTRPar(TRPar node);
	
	/**
	 * Called by {@link TLBrace} from {@link TLBrace#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTLBrace(TLBrace node);
	
	/**
	 * Called by {@link TRBrace} from {@link TRBrace#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTRBrace(TRBrace node);
	
	/**
	 * Called by {@link TSemicolon} from {@link TSemicolon#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTSemicolon(TSemicolon node);
	
	/**
	 * Called by {@link TComma} from {@link TComma#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTComma(TComma node);
	
	/**
	 * Called by {@link TAssign} from {@link TAssign#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTAssign(TAssign node);
	
	/**
	 * Called by {@link TPlus} from {@link TPlus#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTPlus(TPlus node);
	
	/**
	 * Called by {@link TMinus} from {@link TMinus#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTMinus(TMinus node);
	
	/**
	 * Called by {@link TStar} from {@link TStar#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTStar(TStar node);
	
	/**
	 * Called by {@link TDiv} from {@link TDiv#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTDiv(TDiv node);
	
	/**
	 * Called by {@link TAnd} from {@link TAnd#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTAnd(TAnd node);
	
	/**
	 * Called by {@link TGt} from {@link TGt#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTGt(TGt node);
	
	/**
	 * Called by {@link TEq} from {@link TEq#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTEq(TEq node);
	
	/**
	 * Called by {@link TIntegerConst} from {@link TIntegerConst#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTIntegerConst(TIntegerConst node);
	
	/**
	 * Called by {@link TIdentifier} from {@link TIdentifier#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
	public A caseTIdentifier(TIdentifier node);
		/**
	 * Called by {@link EOF} from {@link EOF#apply(Answer)}.
	 * @param node the calling node
	 * @return the answer to the call
	 */
    public A caseEOF(EOF node);

}
