/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import java.util.*;
import tip.node.*;

/**
 * {@code DepthFirstAdapter} extends the {@link AnalysisAdapter} to
 * provide a forward depth-first traversal of the AST. The {@code case}-methods
 * are overriding to implement the traversal itself. By calling the 
 * {@code in}-method for the specific node before traversing the child nodes
 * and calling the {@code out}-method for the node after traversing the child nodes,
 * {@code DepthFirstAdapter} provides a handle for each node at both the traversal
 * down and up the AST. The children of a node are traversed in the order they are defined
 * in the grammar. {@code case}-methods for tokens are not overriden, since
 * tokens have no children and thus are leaves in the AST.
 */
public class DepthFirstAdapter extends AnalysisAdapter {
	/**
	 * Called by {@link #caseStart(Start)} <em>before</em> traversing the children of {@link Start}.
	 * @param node the visited {@link Start} node
	 */
    public void inStart(Start node) {
        defaultIn(node);
    }

	/**
	 * Called by {@link #caseStart(Start)} <em>after</em> traversing the children of {@link Start}.
	 * @param node the visited {@link Start} node
	 */
    public void outStart(Start node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls.
	 * @param node the visited {@link Node}
	 */
    public void defaultIn(@SuppressWarnings("unused") Node node) {
        // Do nothing
    }

	/**
	 * Default case for {@code out}-calls.
	 * @param node the visited {@link Node}
	 */
    public void defaultOut(@SuppressWarnings("unused") Node node) {
        // Do nothing
    }

	/**
	 * Calls {@link #inStart(Start)}, traverses the children of {@link Start} in
	 * the order they are defined in the grammar, and finally calls {@link #outStart(Start)}.
	 * @param node the visited {@link Start} node
	 */
    @Override
    public void caseStart(Start node) {
        inStart(node);
        node.getProgram().apply(this);
        node.getEOF().apply(this);
        outStart(node);
    }

	/**
	 * Called by {@link #caseAProgram(AProgram)} <em>before</em> traversing the children of {@link AProgram}.
	 * @param node the visited {@link AProgram} node
	 */
    public void inAProgram(AProgram node) {
        defaultInPProgram(node);
    }

 	/**
	 * Called by {@link #caseAProgram(AProgram)} <em>after</em> traversing the children of {@link AProgram}.
	 * @param node the visited {@link AProgram} node
	 */
    public void outAProgram(AProgram node) {
        defaultOutPProgram(node);
    }

	/**
	 * Calls {@link #inAProgram(AProgram)}, traverses the children of {@link AProgram} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAProgram(AProgram)}.
	 * @param node the visited {@link AProgram} node
	 */
    @Override
    public void caseAProgram(AProgram node) {
        inAProgram(node);
        {
            List<PDecl> copy = new ArrayList<PDecl>(node.getFunctions());
            for(PDecl e : copy) {
                e.apply(this);
            }
        }
        outAProgram(node);
    }

	/**
	 * Called by {@link #caseAFuncDecl(AFuncDecl)} <em>before</em> traversing the children of {@link AFuncDecl}.
	 * @param node the visited {@link AFuncDecl} node
	 */
    public void inAFuncDecl(AFuncDecl node) {
        defaultInPDecl(node);
    }

 	/**
	 * Called by {@link #caseAFuncDecl(AFuncDecl)} <em>after</em> traversing the children of {@link AFuncDecl}.
	 * @param node the visited {@link AFuncDecl} node
	 */
    public void outAFuncDecl(AFuncDecl node) {
        defaultOutPDecl(node);
    }

	/**
	 * Calls {@link #inAFuncDecl(AFuncDecl)}, traverses the children of {@link AFuncDecl} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAFuncDecl(AFuncDecl)}.
	 * @param node the visited {@link AFuncDecl} node
	 */
    @Override
    public void caseAFuncDecl(AFuncDecl node) {
        inAFuncDecl(node);
        if(node.getName() != null) {
            node.getName().apply(this);
        }
        {
            List<PDecl> copy = new ArrayList<PDecl>(node.getFormals());
            for(PDecl e : copy) {
                e.apply(this);
            }
        }
        if(node.getBody() != null) {
            node.getBody().apply(this);
        }
        outAFuncDecl(node);
    }

	/**
	 * Called by {@link #caseALocalDecl(ALocalDecl)} <em>before</em> traversing the children of {@link ALocalDecl}.
	 * @param node the visited {@link ALocalDecl} node
	 */
    public void inALocalDecl(ALocalDecl node) {
        defaultInPDecl(node);
    }

 	/**
	 * Called by {@link #caseALocalDecl(ALocalDecl)} <em>after</em> traversing the children of {@link ALocalDecl}.
	 * @param node the visited {@link ALocalDecl} node
	 */
    public void outALocalDecl(ALocalDecl node) {
        defaultOutPDecl(node);
    }

	/**
	 * Calls {@link #inALocalDecl(ALocalDecl)}, traverses the children of {@link ALocalDecl} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outALocalDecl(ALocalDecl)}.
	 * @param node the visited {@link ALocalDecl} node
	 */
    @Override
    public void caseALocalDecl(ALocalDecl node) {
        inALocalDecl(node);
        if(node.getName() != null) {
            node.getName().apply(this);
        }
        outALocalDecl(node);
    }

	/**
	 * Called by {@link #caseABody(ABody)} <em>before</em> traversing the children of {@link ABody}.
	 * @param node the visited {@link ABody} node
	 */
    public void inABody(ABody node) {
        defaultInPBody(node);
    }

 	/**
	 * Called by {@link #caseABody(ABody)} <em>after</em> traversing the children of {@link ABody}.
	 * @param node the visited {@link ABody} node
	 */
    public void outABody(ABody node) {
        defaultOutPBody(node);
    }

	/**
	 * Calls {@link #inABody(ABody)}, traverses the children of {@link ABody} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outABody(ABody)}.
	 * @param node the visited {@link ABody} node
	 */
    @Override
    public void caseABody(ABody node) {
        inABody(node);
        if(node.getBlock() != null) {
            node.getBlock().apply(this);
        }
        outABody(node);
    }

	/**
	 * Called by {@link #caseABlock(ABlock)} <em>before</em> traversing the children of {@link ABlock}.
	 * @param node the visited {@link ABlock} node
	 */
    public void inABlock(ABlock node) {
        defaultInPBlock(node);
    }

 	/**
	 * Called by {@link #caseABlock(ABlock)} <em>after</em> traversing the children of {@link ABlock}.
	 * @param node the visited {@link ABlock} node
	 */
    public void outABlock(ABlock node) {
        defaultOutPBlock(node);
    }

	/**
	 * Calls {@link #inABlock(ABlock)}, traverses the children of {@link ABlock} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outABlock(ABlock)}.
	 * @param node the visited {@link ABlock} node
	 */
    @Override
    public void caseABlock(ABlock node) {
        inABlock(node);
        {
            List<PStm> copy = new ArrayList<PStm>(node.getStatements());
            for(PStm e : copy) {
                e.apply(this);
            }
        }
        outABlock(node);
    }

	/**
	 * Called by {@link #caseAPlusBinop(APlusBinop)} <em>before</em> traversing the children of {@link APlusBinop}.
	 * @param node the visited {@link APlusBinop} node
	 */
    public void inAPlusBinop(APlusBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseAPlusBinop(APlusBinop)} <em>after</em> traversing the children of {@link APlusBinop}.
	 * @param node the visited {@link APlusBinop} node
	 */
    public void outAPlusBinop(APlusBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inAPlusBinop(APlusBinop)}, traverses the children of {@link APlusBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAPlusBinop(APlusBinop)}.
	 * @param node the visited {@link APlusBinop} node
	 */
    @Override
    public void caseAPlusBinop(APlusBinop node) {
        inAPlusBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outAPlusBinop(node);
    }

	/**
	 * Called by {@link #caseAMinusBinop(AMinusBinop)} <em>before</em> traversing the children of {@link AMinusBinop}.
	 * @param node the visited {@link AMinusBinop} node
	 */
    public void inAMinusBinop(AMinusBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseAMinusBinop(AMinusBinop)} <em>after</em> traversing the children of {@link AMinusBinop}.
	 * @param node the visited {@link AMinusBinop} node
	 */
    public void outAMinusBinop(AMinusBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inAMinusBinop(AMinusBinop)}, traverses the children of {@link AMinusBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAMinusBinop(AMinusBinop)}.
	 * @param node the visited {@link AMinusBinop} node
	 */
    @Override
    public void caseAMinusBinop(AMinusBinop node) {
        inAMinusBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outAMinusBinop(node);
    }

	/**
	 * Called by {@link #caseATimesBinop(ATimesBinop)} <em>before</em> traversing the children of {@link ATimesBinop}.
	 * @param node the visited {@link ATimesBinop} node
	 */
    public void inATimesBinop(ATimesBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseATimesBinop(ATimesBinop)} <em>after</em> traversing the children of {@link ATimesBinop}.
	 * @param node the visited {@link ATimesBinop} node
	 */
    public void outATimesBinop(ATimesBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inATimesBinop(ATimesBinop)}, traverses the children of {@link ATimesBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outATimesBinop(ATimesBinop)}.
	 * @param node the visited {@link ATimesBinop} node
	 */
    @Override
    public void caseATimesBinop(ATimesBinop node) {
        inATimesBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outATimesBinop(node);
    }

	/**
	 * Called by {@link #caseADivideBinop(ADivideBinop)} <em>before</em> traversing the children of {@link ADivideBinop}.
	 * @param node the visited {@link ADivideBinop} node
	 */
    public void inADivideBinop(ADivideBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseADivideBinop(ADivideBinop)} <em>after</em> traversing the children of {@link ADivideBinop}.
	 * @param node the visited {@link ADivideBinop} node
	 */
    public void outADivideBinop(ADivideBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inADivideBinop(ADivideBinop)}, traverses the children of {@link ADivideBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outADivideBinop(ADivideBinop)}.
	 * @param node the visited {@link ADivideBinop} node
	 */
    @Override
    public void caseADivideBinop(ADivideBinop node) {
        inADivideBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outADivideBinop(node);
    }

	/**
	 * Called by {@link #caseAEqBinop(AEqBinop)} <em>before</em> traversing the children of {@link AEqBinop}.
	 * @param node the visited {@link AEqBinop} node
	 */
    public void inAEqBinop(AEqBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseAEqBinop(AEqBinop)} <em>after</em> traversing the children of {@link AEqBinop}.
	 * @param node the visited {@link AEqBinop} node
	 */
    public void outAEqBinop(AEqBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inAEqBinop(AEqBinop)}, traverses the children of {@link AEqBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAEqBinop(AEqBinop)}.
	 * @param node the visited {@link AEqBinop} node
	 */
    @Override
    public void caseAEqBinop(AEqBinop node) {
        inAEqBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outAEqBinop(node);
    }

	/**
	 * Called by {@link #caseAGtBinop(AGtBinop)} <em>before</em> traversing the children of {@link AGtBinop}.
	 * @param node the visited {@link AGtBinop} node
	 */
    public void inAGtBinop(AGtBinop node) {
        defaultInPBinop(node);
    }

 	/**
	 * Called by {@link #caseAGtBinop(AGtBinop)} <em>after</em> traversing the children of {@link AGtBinop}.
	 * @param node the visited {@link AGtBinop} node
	 */
    public void outAGtBinop(AGtBinop node) {
        defaultOutPBinop(node);
    }

	/**
	 * Calls {@link #inAGtBinop(AGtBinop)}, traverses the children of {@link AGtBinop} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAGtBinop(AGtBinop)}.
	 * @param node the visited {@link AGtBinop} node
	 */
    @Override
    public void caseAGtBinop(AGtBinop node) {
        inAGtBinop(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        outAGtBinop(node);
    }

	/**
	 * Called by {@link #caseABinopExp(ABinopExp)} <em>before</em> traversing the children of {@link ABinopExp}.
	 * @param node the visited {@link ABinopExp} node
	 */
    public void inABinopExp(ABinopExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseABinopExp(ABinopExp)} <em>after</em> traversing the children of {@link ABinopExp}.
	 * @param node the visited {@link ABinopExp} node
	 */
    public void outABinopExp(ABinopExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inABinopExp(ABinopExp)}, traverses the children of {@link ABinopExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outABinopExp(ABinopExp)}.
	 * @param node the visited {@link ABinopExp} node
	 */
    @Override
    public void caseABinopExp(ABinopExp node) {
        inABinopExp(node);
        if(node.getLeft() != null) {
            node.getLeft().apply(this);
        }
        if(node.getBinop() != null) {
            node.getBinop().apply(this);
        }
        if(node.getRight() != null) {
            node.getRight().apply(this);
        }
        outABinopExp(node);
    }

	/**
	 * Called by {@link #caseAPointerExp(APointerExp)} <em>before</em> traversing the children of {@link APointerExp}.
	 * @param node the visited {@link APointerExp} node
	 */
    public void inAPointerExp(APointerExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAPointerExp(APointerExp)} <em>after</em> traversing the children of {@link APointerExp}.
	 * @param node the visited {@link APointerExp} node
	 */
    public void outAPointerExp(APointerExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAPointerExp(APointerExp)}, traverses the children of {@link APointerExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAPointerExp(APointerExp)}.
	 * @param node the visited {@link APointerExp} node
	 */
    @Override
    public void caseAPointerExp(APointerExp node) {
        inAPointerExp(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getIdentifier() != null) {
            node.getIdentifier().apply(this);
        }
        outAPointerExp(node);
    }

	/**
	 * Called by {@link #caseADerefExp(ADerefExp)} <em>before</em> traversing the children of {@link ADerefExp}.
	 * @param node the visited {@link ADerefExp} node
	 */
    public void inADerefExp(ADerefExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseADerefExp(ADerefExp)} <em>after</em> traversing the children of {@link ADerefExp}.
	 * @param node the visited {@link ADerefExp} node
	 */
    public void outADerefExp(ADerefExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inADerefExp(ADerefExp)}, traverses the children of {@link ADerefExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outADerefExp(ADerefExp)}.
	 * @param node the visited {@link ADerefExp} node
	 */
    @Override
    public void caseADerefExp(ADerefExp node) {
        inADerefExp(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getExp() != null) {
            node.getExp().apply(this);
        }
        outADerefExp(node);
    }

	/**
	 * Called by {@link #caseAIntConstExp(AIntConstExp)} <em>before</em> traversing the children of {@link AIntConstExp}.
	 * @param node the visited {@link AIntConstExp} node
	 */
    public void inAIntConstExp(AIntConstExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAIntConstExp(AIntConstExp)} <em>after</em> traversing the children of {@link AIntConstExp}.
	 * @param node the visited {@link AIntConstExp} node
	 */
    public void outAIntConstExp(AIntConstExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAIntConstExp(AIntConstExp)}, traverses the children of {@link AIntConstExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAIntConstExp(AIntConstExp)}.
	 * @param node the visited {@link AIntConstExp} node
	 */
    @Override
    public void caseAIntConstExp(AIntConstExp node) {
        inAIntConstExp(node);
        if(node.getIntegerConst() != null) {
            node.getIntegerConst().apply(this);
        }
        outAIntConstExp(node);
    }

	/**
	 * Called by {@link #caseAFunctionCallExp(AFunctionCallExp)} <em>before</em> traversing the children of {@link AFunctionCallExp}.
	 * @param node the visited {@link AFunctionCallExp} node
	 */
    public void inAFunctionCallExp(AFunctionCallExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAFunctionCallExp(AFunctionCallExp)} <em>after</em> traversing the children of {@link AFunctionCallExp}.
	 * @param node the visited {@link AFunctionCallExp} node
	 */
    public void outAFunctionCallExp(AFunctionCallExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAFunctionCallExp(AFunctionCallExp)}, traverses the children of {@link AFunctionCallExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAFunctionCallExp(AFunctionCallExp)}.
	 * @param node the visited {@link AFunctionCallExp} node
	 */
    @Override
    public void caseAFunctionCallExp(AFunctionCallExp node) {
        inAFunctionCallExp(node);
        if(node.getIdentifier() != null) {
            node.getIdentifier().apply(this);
        }
        {
            List<PExp> copy = new ArrayList<PExp>(node.getArgs());
            for(PExp e : copy) {
                e.apply(this);
            }
        }
        outAFunctionCallExp(node);
    }

	/**
	 * Called by {@link #caseAFunctionPtrCallExp(AFunctionPtrCallExp)} <em>before</em> traversing the children of {@link AFunctionPtrCallExp}.
	 * @param node the visited {@link AFunctionPtrCallExp} node
	 */
    public void inAFunctionPtrCallExp(AFunctionPtrCallExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAFunctionPtrCallExp(AFunctionPtrCallExp)} <em>after</em> traversing the children of {@link AFunctionPtrCallExp}.
	 * @param node the visited {@link AFunctionPtrCallExp} node
	 */
    public void outAFunctionPtrCallExp(AFunctionPtrCallExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAFunctionPtrCallExp(AFunctionPtrCallExp)}, traverses the children of {@link AFunctionPtrCallExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAFunctionPtrCallExp(AFunctionPtrCallExp)}.
	 * @param node the visited {@link AFunctionPtrCallExp} node
	 */
    @Override
    public void caseAFunctionPtrCallExp(AFunctionPtrCallExp node) {
        inAFunctionPtrCallExp(node);
        if(node.getExp() != null) {
            node.getExp().apply(this);
        }
        {
            List<PExp> copy = new ArrayList<PExp>(node.getArgs());
            for(PExp e : copy) {
                e.apply(this);
            }
        }
        outAFunctionPtrCallExp(node);
    }

	/**
	 * Called by {@link #caseAVarExp(AVarExp)} <em>before</em> traversing the children of {@link AVarExp}.
	 * @param node the visited {@link AVarExp} node
	 */
    public void inAVarExp(AVarExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAVarExp(AVarExp)} <em>after</em> traversing the children of {@link AVarExp}.
	 * @param node the visited {@link AVarExp} node
	 */
    public void outAVarExp(AVarExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAVarExp(AVarExp)}, traverses the children of {@link AVarExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAVarExp(AVarExp)}.
	 * @param node the visited {@link AVarExp} node
	 */
    @Override
    public void caseAVarExp(AVarExp node) {
        inAVarExp(node);
        if(node.getIdentifier() != null) {
            node.getIdentifier().apply(this);
        }
        outAVarExp(node);
    }

	/**
	 * Called by {@link #caseAInputExp(AInputExp)} <em>before</em> traversing the children of {@link AInputExp}.
	 * @param node the visited {@link AInputExp} node
	 */
    public void inAInputExp(AInputExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAInputExp(AInputExp)} <em>after</em> traversing the children of {@link AInputExp}.
	 * @param node the visited {@link AInputExp} node
	 */
    public void outAInputExp(AInputExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAInputExp(AInputExp)}, traverses the children of {@link AInputExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAInputExp(AInputExp)}.
	 * @param node the visited {@link AInputExp} node
	 */
    @Override
    public void caseAInputExp(AInputExp node) {
        inAInputExp(node);
        outAInputExp(node);
    }

	/**
	 * Called by {@link #caseAMallocExp(AMallocExp)} <em>before</em> traversing the children of {@link AMallocExp}.
	 * @param node the visited {@link AMallocExp} node
	 */
    public void inAMallocExp(AMallocExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseAMallocExp(AMallocExp)} <em>after</em> traversing the children of {@link AMallocExp}.
	 * @param node the visited {@link AMallocExp} node
	 */
    public void outAMallocExp(AMallocExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inAMallocExp(AMallocExp)}, traverses the children of {@link AMallocExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAMallocExp(AMallocExp)}.
	 * @param node the visited {@link AMallocExp} node
	 */
    @Override
    public void caseAMallocExp(AMallocExp node) {
        inAMallocExp(node);
        outAMallocExp(node);
    }

	/**
	 * Called by {@link #caseANullExp(ANullExp)} <em>before</em> traversing the children of {@link ANullExp}.
	 * @param node the visited {@link ANullExp} node
	 */
    public void inANullExp(ANullExp node) {
        defaultInPExp(node);
    }

 	/**
	 * Called by {@link #caseANullExp(ANullExp)} <em>after</em> traversing the children of {@link ANullExp}.
	 * @param node the visited {@link ANullExp} node
	 */
    public void outANullExp(ANullExp node) {
        defaultOutPExp(node);
    }

	/**
	 * Calls {@link #inANullExp(ANullExp)}, traverses the children of {@link ANullExp} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outANullExp(ANullExp)}.
	 * @param node the visited {@link ANullExp} node
	 */
    @Override
    public void caseANullExp(ANullExp node) {
        inANullExp(node);
        outANullExp(node);
    }

	/**
	 * Called by {@link #caseAIfThenStm(AIfThenStm)} <em>before</em> traversing the children of {@link AIfThenStm}.
	 * @param node the visited {@link AIfThenStm} node
	 */
    public void inAIfThenStm(AIfThenStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAIfThenStm(AIfThenStm)} <em>after</em> traversing the children of {@link AIfThenStm}.
	 * @param node the visited {@link AIfThenStm} node
	 */
    public void outAIfThenStm(AIfThenStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAIfThenStm(AIfThenStm)}, traverses the children of {@link AIfThenStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAIfThenStm(AIfThenStm)}.
	 * @param node the visited {@link AIfThenStm} node
	 */
    @Override
    public void caseAIfThenStm(AIfThenStm node) {
        inAIfThenStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getCondition() != null) {
            node.getCondition().apply(this);
        }
        if(node.getBody() != null) {
            node.getBody().apply(this);
        }
        outAIfThenStm(node);
    }

	/**
	 * Called by {@link #caseAIfThenElseStm(AIfThenElseStm)} <em>before</em> traversing the children of {@link AIfThenElseStm}.
	 * @param node the visited {@link AIfThenElseStm} node
	 */
    public void inAIfThenElseStm(AIfThenElseStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAIfThenElseStm(AIfThenElseStm)} <em>after</em> traversing the children of {@link AIfThenElseStm}.
	 * @param node the visited {@link AIfThenElseStm} node
	 */
    public void outAIfThenElseStm(AIfThenElseStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAIfThenElseStm(AIfThenElseStm)}, traverses the children of {@link AIfThenElseStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAIfThenElseStm(AIfThenElseStm)}.
	 * @param node the visited {@link AIfThenElseStm} node
	 */
    @Override
    public void caseAIfThenElseStm(AIfThenElseStm node) {
        inAIfThenElseStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getCondition() != null) {
            node.getCondition().apply(this);
        }
        if(node.getThenBody() != null) {
            node.getThenBody().apply(this);
        }
        if(node.getElseBody() != null) {
            node.getElseBody().apply(this);
        }
        outAIfThenElseStm(node);
    }

	/**
	 * Called by {@link #caseAWhileStm(AWhileStm)} <em>before</em> traversing the children of {@link AWhileStm}.
	 * @param node the visited {@link AWhileStm} node
	 */
    public void inAWhileStm(AWhileStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAWhileStm(AWhileStm)} <em>after</em> traversing the children of {@link AWhileStm}.
	 * @param node the visited {@link AWhileStm} node
	 */
    public void outAWhileStm(AWhileStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAWhileStm(AWhileStm)}, traverses the children of {@link AWhileStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAWhileStm(AWhileStm)}.
	 * @param node the visited {@link AWhileStm} node
	 */
    @Override
    public void caseAWhileStm(AWhileStm node) {
        inAWhileStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getCondition() != null) {
            node.getCondition().apply(this);
        }
        if(node.getBody() != null) {
            node.getBody().apply(this);
        }
        outAWhileStm(node);
    }

	/**
	 * Called by {@link #caseADeclStm(ADeclStm)} <em>before</em> traversing the children of {@link ADeclStm}.
	 * @param node the visited {@link ADeclStm} node
	 */
    public void inADeclStm(ADeclStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseADeclStm(ADeclStm)} <em>after</em> traversing the children of {@link ADeclStm}.
	 * @param node the visited {@link ADeclStm} node
	 */
    public void outADeclStm(ADeclStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inADeclStm(ADeclStm)}, traverses the children of {@link ADeclStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outADeclStm(ADeclStm)}.
	 * @param node the visited {@link ADeclStm} node
	 */
    @Override
    public void caseADeclStm(ADeclStm node) {
        inADeclStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        {
            List<PDecl> copy = new ArrayList<PDecl>(node.getDecl());
            for(PDecl e : copy) {
                e.apply(this);
            }
        }
        outADeclStm(node);
    }

	/**
	 * Called by {@link #caseAReturnStm(AReturnStm)} <em>before</em> traversing the children of {@link AReturnStm}.
	 * @param node the visited {@link AReturnStm} node
	 */
    public void inAReturnStm(AReturnStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAReturnStm(AReturnStm)} <em>after</em> traversing the children of {@link AReturnStm}.
	 * @param node the visited {@link AReturnStm} node
	 */
    public void outAReturnStm(AReturnStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAReturnStm(AReturnStm)}, traverses the children of {@link AReturnStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAReturnStm(AReturnStm)}.
	 * @param node the visited {@link AReturnStm} node
	 */
    @Override
    public void caseAReturnStm(AReturnStm node) {
        inAReturnStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getExp() != null) {
            node.getExp().apply(this);
        }
        outAReturnStm(node);
    }

	/**
	 * Called by {@link #caseAOutputStm(AOutputStm)} <em>before</em> traversing the children of {@link AOutputStm}.
	 * @param node the visited {@link AOutputStm} node
	 */
    public void inAOutputStm(AOutputStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAOutputStm(AOutputStm)} <em>after</em> traversing the children of {@link AOutputStm}.
	 * @param node the visited {@link AOutputStm} node
	 */
    public void outAOutputStm(AOutputStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAOutputStm(AOutputStm)}, traverses the children of {@link AOutputStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAOutputStm(AOutputStm)}.
	 * @param node the visited {@link AOutputStm} node
	 */
    @Override
    public void caseAOutputStm(AOutputStm node) {
        inAOutputStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getExp() != null) {
            node.getExp().apply(this);
        }
        outAOutputStm(node);
    }

	/**
	 * Called by {@link #caseAAssignVarStm(AAssignVarStm)} <em>before</em> traversing the children of {@link AAssignVarStm}.
	 * @param node the visited {@link AAssignVarStm} node
	 */
    public void inAAssignVarStm(AAssignVarStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAAssignVarStm(AAssignVarStm)} <em>after</em> traversing the children of {@link AAssignVarStm}.
	 * @param node the visited {@link AAssignVarStm} node
	 */
    public void outAAssignVarStm(AAssignVarStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAAssignVarStm(AAssignVarStm)}, traverses the children of {@link AAssignVarStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAAssignVarStm(AAssignVarStm)}.
	 * @param node the visited {@link AAssignVarStm} node
	 */
    @Override
    public void caseAAssignVarStm(AAssignVarStm node) {
        inAAssignVarStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getIdentifier() != null) {
            node.getIdentifier().apply(this);
        }
        if(node.getExp() != null) {
            node.getExp().apply(this);
        }
        outAAssignVarStm(node);
    }

	/**
	 * Called by {@link #caseAAssignPtrStm(AAssignPtrStm)} <em>before</em> traversing the children of {@link AAssignPtrStm}.
	 * @param node the visited {@link AAssignPtrStm} node
	 */
    public void inAAssignPtrStm(AAssignPtrStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseAAssignPtrStm(AAssignPtrStm)} <em>after</em> traversing the children of {@link AAssignPtrStm}.
	 * @param node the visited {@link AAssignPtrStm} node
	 */
    public void outAAssignPtrStm(AAssignPtrStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inAAssignPtrStm(AAssignPtrStm)}, traverses the children of {@link AAssignPtrStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outAAssignPtrStm(AAssignPtrStm)}.
	 * @param node the visited {@link AAssignPtrStm} node
	 */
    @Override
    public void caseAAssignPtrStm(AAssignPtrStm node) {
        inAAssignPtrStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getLeft() != null) {
            node.getLeft().apply(this);
        }
        if(node.getRight() != null) {
            node.getRight().apply(this);
        }
        outAAssignPtrStm(node);
    }

	/**
	 * Called by {@link #caseABlockStm(ABlockStm)} <em>before</em> traversing the children of {@link ABlockStm}.
	 * @param node the visited {@link ABlockStm} node
	 */
    public void inABlockStm(ABlockStm node) {
        defaultInPStm(node);
    }

 	/**
	 * Called by {@link #caseABlockStm(ABlockStm)} <em>after</em> traversing the children of {@link ABlockStm}.
	 * @param node the visited {@link ABlockStm} node
	 */
    public void outABlockStm(ABlockStm node) {
        defaultOutPStm(node);
    }

	/**
	 * Calls {@link #inABlockStm(ABlockStm)}, traverses the children of {@link ABlockStm} in
	 * the order they are defined in the grammar, and finally
	 * calls {@link #outABlockStm(ABlockStm)}.
	 * @param node the visited {@link ABlockStm} node
	 */
    @Override
    public void caseABlockStm(ABlockStm node) {
        inABlockStm(node);
        if(node.getToken() != null) {
            node.getToken().apply(this);
        }
        if(node.getBlock() != null) {
            node.getBlock().apply(this);
        }
        outABlockStm(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PProgram} nodes.
	 * @param node the visited {@link PProgram} node
	 */
    public void defaultInPProgram(PProgram node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePProgram(PProgram)} is overridden.
	 * @param node the visited {@link PProgram} node
	 */
	@Override public final void defaultPProgram(@SuppressWarnings("unused") PProgram node) {}

	/**
	 * Default case for {@code out}-calls from {@link PProgram} nodes.
	 * @param node the visited {@link PProgram} node
	 */
    public void defaultOutPProgram(PProgram node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PDecl} nodes.
	 * @param node the visited {@link PDecl} node
	 */
    public void defaultInPDecl(PDecl node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePDecl(PDecl)} is overridden.
	 * @param node the visited {@link PDecl} node
	 */
	@Override public final void defaultPDecl(@SuppressWarnings("unused") PDecl node) {}

	/**
	 * Default case for {@code out}-calls from {@link PDecl} nodes.
	 * @param node the visited {@link PDecl} node
	 */
    public void defaultOutPDecl(PDecl node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PBody} nodes.
	 * @param node the visited {@link PBody} node
	 */
    public void defaultInPBody(PBody node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePBody(PBody)} is overridden.
	 * @param node the visited {@link PBody} node
	 */
	@Override public final void defaultPBody(@SuppressWarnings("unused") PBody node) {}

	/**
	 * Default case for {@code out}-calls from {@link PBody} nodes.
	 * @param node the visited {@link PBody} node
	 */
    public void defaultOutPBody(PBody node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PBlock} nodes.
	 * @param node the visited {@link PBlock} node
	 */
    public void defaultInPBlock(PBlock node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePBlock(PBlock)} is overridden.
	 * @param node the visited {@link PBlock} node
	 */
	@Override public final void defaultPBlock(@SuppressWarnings("unused") PBlock node) {}

	/**
	 * Default case for {@code out}-calls from {@link PBlock} nodes.
	 * @param node the visited {@link PBlock} node
	 */
    public void defaultOutPBlock(PBlock node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PBinop} nodes.
	 * @param node the visited {@link PBinop} node
	 */
    public void defaultInPBinop(PBinop node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePBinop(PBinop)} is overridden.
	 * @param node the visited {@link PBinop} node
	 */
	@Override public final void defaultPBinop(@SuppressWarnings("unused") PBinop node) {}

	/**
	 * Default case for {@code out}-calls from {@link PBinop} nodes.
	 * @param node the visited {@link PBinop} node
	 */
    public void defaultOutPBinop(PBinop node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PExp} nodes.
	 * @param node the visited {@link PExp} node
	 */
    public void defaultInPExp(PExp node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePExp(PExp)} is overridden.
	 * @param node the visited {@link PExp} node
	 */
	@Override public final void defaultPExp(@SuppressWarnings("unused") PExp node) {}

	/**
	 * Default case for {@code out}-calls from {@link PExp} nodes.
	 * @param node the visited {@link PExp} node
	 */
    public void defaultOutPExp(PExp node) {
        defaultOut(node);
    }

	/**
	 * Default case for {@code in}-calls from {@link PStm} nodes.
	 * @param node the visited {@link PStm} node
	 */
    public void defaultInPStm(PStm node) {
        defaultIn(node);
    }
    
	/**
	 * Not invoked since {@link #casePStm(PStm)} is overridden.
	 * @param node the visited {@link PStm} node
	 */
	@Override public final void defaultPStm(@SuppressWarnings("unused") PStm node) {}

	/**
	 * Default case for {@code out}-calls from {@link PStm} nodes.
	 * @param node the visited {@link PStm} node
	 */
    public void defaultOutPStm(PStm node) {
        defaultOut(node);
    }
}
