/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import tip.node.*;

/**
 * {@code Question} defines an interface for the abstraction of questions
 * based on a {@link Node}. The interface is a visitor pattern.
 *
 * @param <Q> the type of the questions
 *
 * @author Johnni Winther, jw@brics.dk
 */
public interface Question<Q> {

	/**
	 * Called by {@link Start} from {@link Start#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
    public void caseStart(Start node, Q question);

	/**
	 * Called by {@link AProgram} from {@link AProgram#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAProgram(AProgram node, Q question);
	
	/**
	 * Called by {@link AFuncDecl} from {@link AFuncDecl#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAFuncDecl(AFuncDecl node, Q question);
	
	/**
	 * Called by {@link ALocalDecl} from {@link ALocalDecl#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseALocalDecl(ALocalDecl node, Q question);
	
	/**
	 * Called by {@link ABody} from {@link ABody#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseABody(ABody node, Q question);
	
	/**
	 * Called by {@link ABlock} from {@link ABlock#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseABlock(ABlock node, Q question);
	
	/**
	 * Called by {@link APlusBinop} from {@link APlusBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAPlusBinop(APlusBinop node, Q question);
	
	/**
	 * Called by {@link AMinusBinop} from {@link AMinusBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAMinusBinop(AMinusBinop node, Q question);
	
	/**
	 * Called by {@link ATimesBinop} from {@link ATimesBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseATimesBinop(ATimesBinop node, Q question);
	
	/**
	 * Called by {@link ADivideBinop} from {@link ADivideBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseADivideBinop(ADivideBinop node, Q question);
	
	/**
	 * Called by {@link AEqBinop} from {@link AEqBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAEqBinop(AEqBinop node, Q question);
	
	/**
	 * Called by {@link AGtBinop} from {@link AGtBinop#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAGtBinop(AGtBinop node, Q question);
	
	/**
	 * Called by {@link ABinopExp} from {@link ABinopExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseABinopExp(ABinopExp node, Q question);
	
	/**
	 * Called by {@link APointerExp} from {@link APointerExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAPointerExp(APointerExp node, Q question);
	
	/**
	 * Called by {@link ADerefExp} from {@link ADerefExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseADerefExp(ADerefExp node, Q question);
	
	/**
	 * Called by {@link AIntConstExp} from {@link AIntConstExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAIntConstExp(AIntConstExp node, Q question);
	
	/**
	 * Called by {@link AFunctionCallExp} from {@link AFunctionCallExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAFunctionCallExp(AFunctionCallExp node, Q question);
	
	/**
	 * Called by {@link AFunctionPtrCallExp} from {@link AFunctionPtrCallExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAFunctionPtrCallExp(AFunctionPtrCallExp node, Q question);
	
	/**
	 * Called by {@link AVarExp} from {@link AVarExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAVarExp(AVarExp node, Q question);
	
	/**
	 * Called by {@link AInputExp} from {@link AInputExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAInputExp(AInputExp node, Q question);
	
	/**
	 * Called by {@link AMallocExp} from {@link AMallocExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAMallocExp(AMallocExp node, Q question);
	
	/**
	 * Called by {@link ANullExp} from {@link ANullExp#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseANullExp(ANullExp node, Q question);
	
	/**
	 * Called by {@link AIfThenStm} from {@link AIfThenStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAIfThenStm(AIfThenStm node, Q question);
	
	/**
	 * Called by {@link AIfThenElseStm} from {@link AIfThenElseStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAIfThenElseStm(AIfThenElseStm node, Q question);
	
	/**
	 * Called by {@link AWhileStm} from {@link AWhileStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAWhileStm(AWhileStm node, Q question);
	
	/**
	 * Called by {@link ADeclStm} from {@link ADeclStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseADeclStm(ADeclStm node, Q question);
	
	/**
	 * Called by {@link AReturnStm} from {@link AReturnStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAReturnStm(AReturnStm node, Q question);
	
	/**
	 * Called by {@link AOutputStm} from {@link AOutputStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAOutputStm(AOutputStm node, Q question);
	
	/**
	 * Called by {@link AAssignVarStm} from {@link AAssignVarStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAAssignVarStm(AAssignVarStm node, Q question);
	
	/**
	 * Called by {@link AAssignPtrStm} from {@link AAssignPtrStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseAAssignPtrStm(AAssignPtrStm node, Q question);
	
	/**
	 * Called by {@link ABlockStm} from {@link ABlockStm#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseABlockStm(ABlockStm node, Q question);
	

	/**
	 * Called by {@link TWhiteSpace} from {@link TWhiteSpace#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTWhiteSpace(TWhiteSpace node, Q question);
	
	/**
	 * Called by {@link TCommentSingle} from {@link TCommentSingle#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTCommentSingle(TCommentSingle node, Q question);
	
	/**
	 * Called by {@link TCommentBlock} from {@link TCommentBlock#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTCommentBlock(TCommentBlock node, Q question);
	
	/**
	 * Called by {@link TVar} from {@link TVar#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTVar(TVar node, Q question);
	
	/**
	 * Called by {@link TInput} from {@link TInput#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTInput(TInput node, Q question);
	
	/**
	 * Called by {@link TOutput} from {@link TOutput#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTOutput(TOutput node, Q question);
	
	/**
	 * Called by {@link TIf} from {@link TIf#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTIf(TIf node, Q question);
	
	/**
	 * Called by {@link TElse} from {@link TElse#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTElse(TElse node, Q question);
	
	/**
	 * Called by {@link TWhile} from {@link TWhile#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTWhile(TWhile node, Q question);
	
	/**
	 * Called by {@link TReturn} from {@link TReturn#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTReturn(TReturn node, Q question);
	
	/**
	 * Called by {@link TMalloc} from {@link TMalloc#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTMalloc(TMalloc node, Q question);
	
	/**
	 * Called by {@link TNull} from {@link TNull#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTNull(TNull node, Q question);
	
	/**
	 * Called by {@link TLPar} from {@link TLPar#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTLPar(TLPar node, Q question);
	
	/**
	 * Called by {@link TRPar} from {@link TRPar#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTRPar(TRPar node, Q question);
	
	/**
	 * Called by {@link TLBrace} from {@link TLBrace#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTLBrace(TLBrace node, Q question);
	
	/**
	 * Called by {@link TRBrace} from {@link TRBrace#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTRBrace(TRBrace node, Q question);
	
	/**
	 * Called by {@link TSemicolon} from {@link TSemicolon#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTSemicolon(TSemicolon node, Q question);
	
	/**
	 * Called by {@link TComma} from {@link TComma#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTComma(TComma node, Q question);
	
	/**
	 * Called by {@link TAssign} from {@link TAssign#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTAssign(TAssign node, Q question);
	
	/**
	 * Called by {@link TPlus} from {@link TPlus#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTPlus(TPlus node, Q question);
	
	/**
	 * Called by {@link TMinus} from {@link TMinus#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTMinus(TMinus node, Q question);
	
	/**
	 * Called by {@link TStar} from {@link TStar#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTStar(TStar node, Q question);
	
	/**
	 * Called by {@link TDiv} from {@link TDiv#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTDiv(TDiv node, Q question);
	
	/**
	 * Called by {@link TAnd} from {@link TAnd#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTAnd(TAnd node, Q question);
	
	/**
	 * Called by {@link TGt} from {@link TGt#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTGt(TGt node, Q question);
	
	/**
	 * Called by {@link TEq} from {@link TEq#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTEq(TEq node, Q question);
	
	/**
	 * Called by {@link TIntegerConst} from {@link TIntegerConst#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTIntegerConst(TIntegerConst node, Q question);
	
	/**
	 * Called by {@link TIdentifier} from {@link TIdentifier#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
	public void caseTIdentifier(TIdentifier node, Q question);
		/**
	 * Called by {@link EOF} from {@link EOF#apply(Question,Object)}.
	 * @param node the calling node
	 * @param question the provided question
	 */
    public void caseEOF(EOF node, Q question);

}
