/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.analysis;

import tip.node.*;

/**
 * {@code QuestionAnswer} defines an interface for the abstraction of answers
 * based on a question and a {@link Node}. The interface is a visitor pattern.
 *
 * @param <Q> the type of the questions
 * @param <A> the type of the answers
 *
 * @author Johnni Winther, jw@brics.dk
 */
public interface QuestionAnswer<Q,A> {

	/**
	 * Called by {@link Start} from {@link Start#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
    public A caseStart(Start node, Q question);

	/**
	 * Called by {@link AProgram} from {@link AProgram#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAProgram(AProgram node, Q question);
	
	/**
	 * Called by {@link AFuncDecl} from {@link AFuncDecl#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAFuncDecl(AFuncDecl node, Q question);
	
	/**
	 * Called by {@link ALocalDecl} from {@link ALocalDecl#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseALocalDecl(ALocalDecl node, Q question);
	
	/**
	 * Called by {@link ABody} from {@link ABody#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseABody(ABody node, Q question);
	
	/**
	 * Called by {@link ABlock} from {@link ABlock#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseABlock(ABlock node, Q question);
	
	/**
	 * Called by {@link APlusBinop} from {@link APlusBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAPlusBinop(APlusBinop node, Q question);
	
	/**
	 * Called by {@link AMinusBinop} from {@link AMinusBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAMinusBinop(AMinusBinop node, Q question);
	
	/**
	 * Called by {@link ATimesBinop} from {@link ATimesBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseATimesBinop(ATimesBinop node, Q question);
	
	/**
	 * Called by {@link ADivideBinop} from {@link ADivideBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseADivideBinop(ADivideBinop node, Q question);
	
	/**
	 * Called by {@link AEqBinop} from {@link AEqBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAEqBinop(AEqBinop node, Q question);
	
	/**
	 * Called by {@link AGtBinop} from {@link AGtBinop#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAGtBinop(AGtBinop node, Q question);
	
	/**
	 * Called by {@link ABinopExp} from {@link ABinopExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseABinopExp(ABinopExp node, Q question);
	
	/**
	 * Called by {@link APointerExp} from {@link APointerExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAPointerExp(APointerExp node, Q question);
	
	/**
	 * Called by {@link ADerefExp} from {@link ADerefExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseADerefExp(ADerefExp node, Q question);
	
	/**
	 * Called by {@link AIntConstExp} from {@link AIntConstExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAIntConstExp(AIntConstExp node, Q question);
	
	/**
	 * Called by {@link AFunctionCallExp} from {@link AFunctionCallExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAFunctionCallExp(AFunctionCallExp node, Q question);
	
	/**
	 * Called by {@link AFunctionPtrCallExp} from {@link AFunctionPtrCallExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAFunctionPtrCallExp(AFunctionPtrCallExp node, Q question);
	
	/**
	 * Called by {@link AVarExp} from {@link AVarExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAVarExp(AVarExp node, Q question);
	
	/**
	 * Called by {@link AInputExp} from {@link AInputExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAInputExp(AInputExp node, Q question);
	
	/**
	 * Called by {@link AMallocExp} from {@link AMallocExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAMallocExp(AMallocExp node, Q question);
	
	/**
	 * Called by {@link ANullExp} from {@link ANullExp#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseANullExp(ANullExp node, Q question);
	
	/**
	 * Called by {@link AIfThenStm} from {@link AIfThenStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAIfThenStm(AIfThenStm node, Q question);
	
	/**
	 * Called by {@link AIfThenElseStm} from {@link AIfThenElseStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAIfThenElseStm(AIfThenElseStm node, Q question);
	
	/**
	 * Called by {@link AWhileStm} from {@link AWhileStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAWhileStm(AWhileStm node, Q question);
	
	/**
	 * Called by {@link ADeclStm} from {@link ADeclStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseADeclStm(ADeclStm node, Q question);
	
	/**
	 * Called by {@link AReturnStm} from {@link AReturnStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAReturnStm(AReturnStm node, Q question);
	
	/**
	 * Called by {@link AOutputStm} from {@link AOutputStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAOutputStm(AOutputStm node, Q question);
	
	/**
	 * Called by {@link AAssignVarStm} from {@link AAssignVarStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAAssignVarStm(AAssignVarStm node, Q question);
	
	/**
	 * Called by {@link AAssignPtrStm} from {@link AAssignPtrStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseAAssignPtrStm(AAssignPtrStm node, Q question);
	
	/**
	 * Called by {@link ABlockStm} from {@link ABlockStm#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseABlockStm(ABlockStm node, Q question);
	

	/**
	 * Called by {@link TWhiteSpace} from {@link TWhiteSpace#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTWhiteSpace(TWhiteSpace node, Q question);
	
	/**
	 * Called by {@link TCommentSingle} from {@link TCommentSingle#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTCommentSingle(TCommentSingle node, Q question);
	
	/**
	 * Called by {@link TCommentBlock} from {@link TCommentBlock#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTCommentBlock(TCommentBlock node, Q question);
	
	/**
	 * Called by {@link TVar} from {@link TVar#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTVar(TVar node, Q question);
	
	/**
	 * Called by {@link TInput} from {@link TInput#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTInput(TInput node, Q question);
	
	/**
	 * Called by {@link TOutput} from {@link TOutput#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTOutput(TOutput node, Q question);
	
	/**
	 * Called by {@link TIf} from {@link TIf#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTIf(TIf node, Q question);
	
	/**
	 * Called by {@link TElse} from {@link TElse#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTElse(TElse node, Q question);
	
	/**
	 * Called by {@link TWhile} from {@link TWhile#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTWhile(TWhile node, Q question);
	
	/**
	 * Called by {@link TReturn} from {@link TReturn#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTReturn(TReturn node, Q question);
	
	/**
	 * Called by {@link TMalloc} from {@link TMalloc#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTMalloc(TMalloc node, Q question);
	
	/**
	 * Called by {@link TNull} from {@link TNull#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTNull(TNull node, Q question);
	
	/**
	 * Called by {@link TLPar} from {@link TLPar#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTLPar(TLPar node, Q question);
	
	/**
	 * Called by {@link TRPar} from {@link TRPar#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTRPar(TRPar node, Q question);
	
	/**
	 * Called by {@link TLBrace} from {@link TLBrace#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTLBrace(TLBrace node, Q question);
	
	/**
	 * Called by {@link TRBrace} from {@link TRBrace#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTRBrace(TRBrace node, Q question);
	
	/**
	 * Called by {@link TSemicolon} from {@link TSemicolon#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTSemicolon(TSemicolon node, Q question);
	
	/**
	 * Called by {@link TComma} from {@link TComma#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTComma(TComma node, Q question);
	
	/**
	 * Called by {@link TAssign} from {@link TAssign#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTAssign(TAssign node, Q question);
	
	/**
	 * Called by {@link TPlus} from {@link TPlus#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTPlus(TPlus node, Q question);
	
	/**
	 * Called by {@link TMinus} from {@link TMinus#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTMinus(TMinus node, Q question);
	
	/**
	 * Called by {@link TStar} from {@link TStar#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTStar(TStar node, Q question);
	
	/**
	 * Called by {@link TDiv} from {@link TDiv#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTDiv(TDiv node, Q question);
	
	/**
	 * Called by {@link TAnd} from {@link TAnd#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTAnd(TAnd node, Q question);
	
	/**
	 * Called by {@link TGt} from {@link TGt#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTGt(TGt node, Q question);
	
	/**
	 * Called by {@link TEq} from {@link TEq#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTEq(TEq node, Q question);
	
	/**
	 * Called by {@link TIntegerConst} from {@link TIntegerConst#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTIntegerConst(TIntegerConst node, Q question);
	
	/**
	 * Called by {@link TIdentifier} from {@link TIdentifier#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
	public A caseTIdentifier(TIdentifier node, Q question);
		/**
	 * Called by {@link EOF} from {@link EOF#apply(QuestionAnswer,Object)}.
	 * @param node the calling node
	 * @return the answer to the question
	 */
    public A caseEOF(EOF node, Q question);

}
