/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code CAssignVarStmPoint} is a program point in a control flow graph associated with a
 * {@link AAssignVarStm}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CAssignVarStmPoint extends AProgramPoint {
	// the AAssignVarStm associated with the program point
	protected AAssignVarStm _node_;
	// the label of the program point
	protected String _label_;

	/**
	 * Creates a new {@code CAssignVarStmPoint} associated with the {@link AAssignVarStm} {@code _node_}
	 * with the label {@code ""}.
	 * @param _node_ the {@link AAssignVarStm} associated the the program point
	 */
	public CAssignVarStmPoint(AAssignVarStm _node_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = "";
	}

	/**
	 * Creates a new {@code CAssignVarStmPoint} associated with the {@link AAssignVarStm} {@code _node_}
	 * with the label {@code _label_}.
	 * @param _node_ the {@link AAssignVarStm} associated the the program point
	 * @param _label_ the label of the program point
	 */
	public CAssignVarStmPoint(AAssignVarStm _node_, String _label_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = _label_;
	}
	
	/**
	 * Returns the {@link AAssignVarStm} associated with this program point.
	 * @return the {@link AAssignVarStm} associated with this program point
	 */
	public AAssignVarStm getNode() {
		return _node_;
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseCAssignVarStmPoint(AAssignVarStm,CAssignVarStmPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseCAssignVarStmPoint(AAssignVarStm,CAssignVarStmPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseCAssignVarStmPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of this program point by calling the 
	 * {@link Answer#caseAAssignVarStm(AAssignVarStm)} on {@code nodeText}.
	 * @return a textual representation of this program point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return nodeText.caseAAssignVarStm(_node_);
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseCAssignVarStmPoint(AAssignVarStm,CAssignVarStmPoint)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseCAssignVarStmPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseCAssignVarStmPoint(AAssignVarStm,CAssignVarStmPoint,Object)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseCAssignVarStmPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the program point with no predecessors or successors.
	 * @return a clone of the program point with no predecessors or successors
	 */
	public CAssignVarStmPoint clone() {
		return new CAssignVarStmPoint(_node_, _label_);
	}
	
	/**
	 * Returns a textual representation of this {@link CAssignVarStmPoint}.
	 * @return a textual representation of this {@link CAssignVarStmPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("CAssignVarStmPoint");
		sb.append("[");
		sb.append(this._label_);
		sb.append("]:");
		sb.append(this._node_);
		return sb.toString();
	}
}
