/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code CBlockPoint} is a program point in a control flow graph associated with a
 * {@link ABlock}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CBlockPoint extends AProgramPoint {
	// the ABlock associated with the program point
	protected ABlock _node_;
	// the label of the program point
	protected String _label_;

	/**
	 * Creates a new {@code CBlockPoint} associated with the {@link ABlock} {@code _node_}
	 * with the label {@code ""}.
	 * @param _node_ the {@link ABlock} associated the the program point
	 */
	public CBlockPoint(ABlock _node_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = "";
	}

	/**
	 * Creates a new {@code CBlockPoint} associated with the {@link ABlock} {@code _node_}
	 * with the label {@code _label_}.
	 * @param _node_ the {@link ABlock} associated the the program point
	 * @param _label_ the label of the program point
	 */
	public CBlockPoint(ABlock _node_, String _label_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = _label_;
	}
	
	/**
	 * Returns the {@link ABlock} associated with this program point.
	 * @return the {@link ABlock} associated with this program point
	 */
	public ABlock getNode() {
		return _node_;
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseCBlockPoint(ABlock,CBlockPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseCBlockPoint(ABlock,CBlockPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseCBlockPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of this program point by calling the 
	 * {@link Answer#caseABlock(ABlock)} on {@code nodeText}.
	 * @return a textual representation of this program point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return nodeText.caseABlock(_node_);
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseCBlockPoint(ABlock,CBlockPoint)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseCBlockPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseCBlockPoint(ABlock,CBlockPoint,Object)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseCBlockPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the program point with no predecessors or successors.
	 * @return a clone of the program point with no predecessors or successors
	 */
	public CBlockPoint clone() {
		return new CBlockPoint(_node_, _label_);
	}
	
	/**
	 * Returns a textual representation of this {@link CBlockPoint}.
	 * @return a textual representation of this {@link CBlockPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("CBlockPoint");
		sb.append("[");
		sb.append(this._label_);
		sb.append("]:");
		sb.append(this._node_);
		return sb.toString();
	}
}
