/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import java.util.*;

/**
 * {@code CCFGCollection} is the standard implementation of 
 * {@link ICFGCollection} used by {@link CFGBuilder}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CCFGCollection implements ICFGCollection {
	// the list of control flow graphs in this collection
	protected Map<String,ICFG> cfgMap = new HashMap<String,ICFG>();
	
	/**
	 * Adds a control flow graph to this collection.
	 * @param cfg the control flow graph added to this collection
	 */
	public void addCFG(ICFG cfg) {
		cfgMap.put(cfg.getName(),cfg);
	}
	
	/**
	 * Returns the collection of control flow graphs in this collection.
	 * @return the collection of control flow graphs in this collection
	 */	 
	public Collection<ICFG> getCFGs() {
		return cfgMap.values();
	}
	
	/**
	 * Returns an iterator for the contained control flow graphs
	 * @return an iterator for the contained control flow graphs
	 **/
	public Iterator<ICFG> iterator() {
		return cfgMap.values().iterator();
	}
	
	/**
	 * Returns the control flow graph in this collection with the given name.
	 * @param name the name of the control flow graph
	 * @return the control flow graph in this collection with the given name
	 */
	public ICFG getCFG(String name) {
		return cfgMap.get(name);
	}
}
