/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;

/**
 * {@code CFGAnalysisAdapter} implements {@link ICFGAnalysis} by defering all
 * {@code case}-methods to {@link #defaultNode(Node,IProgramPoint)}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CFGAnalysisAdapter implements ICFGAnalysis {

	/**
	 * Base implementation for all {@code case}-methods. Returns {@code false}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link IProgramPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean defaultNode(Node node, IProgramPoint point) {
		return false;
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link EntryPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseEntryPoint(Node node, EntryPoint point) {
		return defaultNode(node, point);
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link ExitPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseExitPoint(Node node, ExitPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AReturnStm} associated with {@code point}
	 * @param point the {@link CReturnStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCReturnStmPoint(AReturnStm node, CReturnStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AAssignPtrStm} associated with {@code point}
	 * @param point the {@link CAssignPtrStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCAssignPtrStmPoint(AAssignPtrStm node, CAssignPtrStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ABlock} associated with {@code point}
	 * @param point the {@link CBlockPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCBlockPoint(ABlock node, CBlockPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AVarExp} associated with {@code point}
	 * @param point the {@link CVarExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCVarExpPoint(AVarExp node, CVarExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AFunctionCallExp} associated with {@code point}
	 * @param point the {@link CFunctionCallExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCFunctionCallExpPoint(AFunctionCallExp node, CFunctionCallExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ADerefExp} associated with {@code point}
	 * @param point the {@link CDerefExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCDerefExpPoint(ADerefExp node, CDerefExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ADeclStm} associated with {@code point}
	 * @param point the {@link CDeclStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCDeclStmPoint(ADeclStm node, CDeclStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AInputExp} associated with {@code point}
	 * @param point the {@link CInputExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCInputExpPoint(AInputExp node, CInputExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AMallocExp} associated with {@code point}
	 * @param point the {@link CMallocExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCMallocExpPoint(AMallocExp node, CMallocExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIfThenStm} associated with {@code point}
	 * @param point the {@link CIfThenStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCIfThenStmPoint(AIfThenStm node, CIfThenStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIntConstExp} associated with {@code point}
	 * @param point the {@link CIntConstExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCIntConstExpPoint(AIntConstExp node, CIntConstExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AFunctionPtrCallExp} associated with {@code point}
	 * @param point the {@link CFunctionPtrCallExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCFunctionPtrCallExpPoint(AFunctionPtrCallExp node, CFunctionPtrCallExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AWhileStm} associated with {@code point}
	 * @param point the {@link CWhileStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCWhileStmPoint(AWhileStm node, CWhileStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ABinopExp} associated with {@code point}
	 * @param point the {@link CBinopExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCBinopExpPoint(ABinopExp node, CBinopExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AAssignVarStm} associated with {@code point}
	 * @param point the {@link CAssignVarStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCAssignVarStmPoint(AAssignVarStm node, CAssignVarStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIfThenElseStm} associated with {@code point}
	 * @param point the {@link CIfThenElseStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCIfThenElseStmPoint(AIfThenElseStm node, CIfThenElseStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AOutputStm} associated with {@code point}
	 * @param point the {@link COutputStmPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCOutputStmPoint(AOutputStm node, COutputStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link APointerExp} associated with {@code point}
	 * @param point the {@link CPointerExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCPointerExpPoint(APointerExp node, CPointerExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ANullExp} associated with {@code point}
	 * @param point the {@link CNullExpPoint} calling the method
	 * @return {@code true} if the result of the analysis is changed.
	 */
	public boolean caseCNullExpPoint(ANullExp node, CNullExpPoint point) {
		return defaultNode(node, point);
	}

}
