/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;

/**
 * {@code CFGAnswerAdapter} implements the default behaviour of the 
 * {@link CFGAnswer} interface. All calls return {@code null} by default.
 *
 * @param <A> the type of the answers
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CFGAnswerAdapter<A> implements CFGAnswer<A> {

	/**
	 * Base implementation for all {@code case}-methods. Returns {@code null}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link IProgramPoint} calling the method
	 * @return the default answer for a {@link Node} and {@link IProgramPoint}
	 */
	public A defaultNode(Node node, IProgramPoint point) {
		return null;
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link EntryPoint} calling the method
	 * @return the answer for a {@link Node} and {@link EntryPoint}
	 */
	public A caseEntryPoint(Node node, EntryPoint point) {
		return defaultNode(node, point);
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link ExitPoint} calling the method
	 * @return the answer for a {@link Node} and {@link ExitPoint}
	 */
	public A caseExitPoint(Node node, ExitPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AReturnStm} associated with {@code point}
	 * @param point the {@link CReturnStmPoint} calling the method
	 * @return the answer for a {@link AReturnStm} and {@link CReturnStmPoint}
	 */
	public A caseCReturnStmPoint(AReturnStm node, CReturnStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AAssignPtrStm} associated with {@code point}
	 * @param point the {@link CAssignPtrStmPoint} calling the method
	 * @return the answer for a {@link AAssignPtrStm} and {@link CAssignPtrStmPoint}
	 */
	public A caseCAssignPtrStmPoint(AAssignPtrStm node, CAssignPtrStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ABlock} associated with {@code point}
	 * @param point the {@link CBlockPoint} calling the method
	 * @return the answer for a {@link ABlock} and {@link CBlockPoint}
	 */
	public A caseCBlockPoint(ABlock node, CBlockPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AVarExp} associated with {@code point}
	 * @param point the {@link CVarExpPoint} calling the method
	 * @return the answer for a {@link AVarExp} and {@link CVarExpPoint}
	 */
	public A caseCVarExpPoint(AVarExp node, CVarExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AFunctionCallExp} associated with {@code point}
	 * @param point the {@link CFunctionCallExpPoint} calling the method
	 * @return the answer for a {@link AFunctionCallExp} and {@link CFunctionCallExpPoint}
	 */
	public A caseCFunctionCallExpPoint(AFunctionCallExp node, CFunctionCallExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ADerefExp} associated with {@code point}
	 * @param point the {@link CDerefExpPoint} calling the method
	 * @return the answer for a {@link ADerefExp} and {@link CDerefExpPoint}
	 */
	public A caseCDerefExpPoint(ADerefExp node, CDerefExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ADeclStm} associated with {@code point}
	 * @param point the {@link CDeclStmPoint} calling the method
	 * @return the answer for a {@link ADeclStm} and {@link CDeclStmPoint}
	 */
	public A caseCDeclStmPoint(ADeclStm node, CDeclStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AInputExp} associated with {@code point}
	 * @param point the {@link CInputExpPoint} calling the method
	 * @return the answer for a {@link AInputExp} and {@link CInputExpPoint}
	 */
	public A caseCInputExpPoint(AInputExp node, CInputExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AMallocExp} associated with {@code point}
	 * @param point the {@link CMallocExpPoint} calling the method
	 * @return the answer for a {@link AMallocExp} and {@link CMallocExpPoint}
	 */
	public A caseCMallocExpPoint(AMallocExp node, CMallocExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIfThenStm} associated with {@code point}
	 * @param point the {@link CIfThenStmPoint} calling the method
	 * @return the answer for a {@link AIfThenStm} and {@link CIfThenStmPoint}
	 */
	public A caseCIfThenStmPoint(AIfThenStm node, CIfThenStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIntConstExp} associated with {@code point}
	 * @param point the {@link CIntConstExpPoint} calling the method
	 * @return the answer for a {@link AIntConstExp} and {@link CIntConstExpPoint}
	 */
	public A caseCIntConstExpPoint(AIntConstExp node, CIntConstExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AFunctionPtrCallExp} associated with {@code point}
	 * @param point the {@link CFunctionPtrCallExpPoint} calling the method
	 * @return the answer for a {@link AFunctionPtrCallExp} and {@link CFunctionPtrCallExpPoint}
	 */
	public A caseCFunctionPtrCallExpPoint(AFunctionPtrCallExp node, CFunctionPtrCallExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AWhileStm} associated with {@code point}
	 * @param point the {@link CWhileStmPoint} calling the method
	 * @return the answer for a {@link AWhileStm} and {@link CWhileStmPoint}
	 */
	public A caseCWhileStmPoint(AWhileStm node, CWhileStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ABinopExp} associated with {@code point}
	 * @param point the {@link CBinopExpPoint} calling the method
	 * @return the answer for a {@link ABinopExp} and {@link CBinopExpPoint}
	 */
	public A caseCBinopExpPoint(ABinopExp node, CBinopExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AAssignVarStm} associated with {@code point}
	 * @param point the {@link CAssignVarStmPoint} calling the method
	 * @return the answer for a {@link AAssignVarStm} and {@link CAssignVarStmPoint}
	 */
	public A caseCAssignVarStmPoint(AAssignVarStm node, CAssignVarStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AIfThenElseStm} associated with {@code point}
	 * @param point the {@link CIfThenElseStmPoint} calling the method
	 * @return the answer for a {@link AIfThenElseStm} and {@link CIfThenElseStmPoint}
	 */
	public A caseCIfThenElseStmPoint(AIfThenElseStm node, CIfThenElseStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link AOutputStm} associated with {@code point}
	 * @param point the {@link COutputStmPoint} calling the method
	 * @return the answer for a {@link AOutputStm} and {@link COutputStmPoint}
	 */
	public A caseCOutputStmPoint(AOutputStm node, COutputStmPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link APointerExp} associated with {@code point}
	 * @param point the {@link CPointerExpPoint} calling the method
	 * @return the answer for a {@link APointerExp} and {@link CPointerExpPoint}
	 */
	public A caseCPointerExpPoint(APointerExp node, CPointerExpPoint point) {
		return defaultNode(node, point);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint)}.
	 * @param node the {@link ANullExp} associated with {@code point}
	 * @param point the {@link CNullExpPoint} calling the method
	 * @return the answer for a {@link ANullExp} and {@link CNullExpPoint}
	 */
	public A caseCNullExpPoint(ANullExp node, CNullExpPoint point) {
		return defaultNode(node, point);
	}

}
