/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;

/**
 * {@code CFGQuestionAnswerAdapter} implements the default behaviour of the 
 * {@link CFGQuestionAnswer} interface. All calls return {@code null} by default.
 *
 * @param <Q> the type of the questions
 * @param <A> the type of the answers
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CFGQuestionAnswerAdapter<Q,A> implements CFGQuestionAnswer<Q,A> {

	/**
	 * Base implementation for all {@code case}-methods. Returns {@code null}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link IProgramPoint} calling the method
	 * @param question the question
	 * @return the default answer for a {@link Node} and {@link IProgramPoint} on the {@code question}
	 */
	public A defaultNode(Node node, IProgramPoint point, Q question) {
		return null;
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link EntryPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link Node} and {@link EntryPoint} on the {@code question}
	 */
	public A caseEntryPoint(Node node, EntryPoint point, Q question) {
		return defaultNode(node, point, question);
	}
	
	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link ExitPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link Node} and {@link ExitPoint} on the {@code question}
	 */
	public A caseExitPoint(Node node, ExitPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AReturnStm} associated with {@code point}
	 * @param point the {@link CReturnStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AReturnStm} and {@link CReturnStmPoint} on the {@code question}
	 */
	public A caseCReturnStmPoint(AReturnStm node, CReturnStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AAssignPtrStm} associated with {@code point}
	 * @param point the {@link CAssignPtrStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AAssignPtrStm} and {@link CAssignPtrStmPoint} on the {@code question}
	 */
	public A caseCAssignPtrStmPoint(AAssignPtrStm node, CAssignPtrStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link ABlock} associated with {@code point}
	 * @param point the {@link CBlockPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link ABlock} and {@link CBlockPoint} on the {@code question}
	 */
	public A caseCBlockPoint(ABlock node, CBlockPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AVarExp} associated with {@code point}
	 * @param point the {@link CVarExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AVarExp} and {@link CVarExpPoint} on the {@code question}
	 */
	public A caseCVarExpPoint(AVarExp node, CVarExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AFunctionCallExp} associated with {@code point}
	 * @param point the {@link CFunctionCallExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AFunctionCallExp} and {@link CFunctionCallExpPoint} on the {@code question}
	 */
	public A caseCFunctionCallExpPoint(AFunctionCallExp node, CFunctionCallExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link ADerefExp} associated with {@code point}
	 * @param point the {@link CDerefExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link ADerefExp} and {@link CDerefExpPoint} on the {@code question}
	 */
	public A caseCDerefExpPoint(ADerefExp node, CDerefExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link ADeclStm} associated with {@code point}
	 * @param point the {@link CDeclStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link ADeclStm} and {@link CDeclStmPoint} on the {@code question}
	 */
	public A caseCDeclStmPoint(ADeclStm node, CDeclStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AInputExp} associated with {@code point}
	 * @param point the {@link CInputExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AInputExp} and {@link CInputExpPoint} on the {@code question}
	 */
	public A caseCInputExpPoint(AInputExp node, CInputExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AMallocExp} associated with {@code point}
	 * @param point the {@link CMallocExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AMallocExp} and {@link CMallocExpPoint} on the {@code question}
	 */
	public A caseCMallocExpPoint(AMallocExp node, CMallocExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AIfThenStm} associated with {@code point}
	 * @param point the {@link CIfThenStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AIfThenStm} and {@link CIfThenStmPoint} on the {@code question}
	 */
	public A caseCIfThenStmPoint(AIfThenStm node, CIfThenStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AIntConstExp} associated with {@code point}
	 * @param point the {@link CIntConstExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AIntConstExp} and {@link CIntConstExpPoint} on the {@code question}
	 */
	public A caseCIntConstExpPoint(AIntConstExp node, CIntConstExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AFunctionPtrCallExp} associated with {@code point}
	 * @param point the {@link CFunctionPtrCallExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AFunctionPtrCallExp} and {@link CFunctionPtrCallExpPoint} on the {@code question}
	 */
	public A caseCFunctionPtrCallExpPoint(AFunctionPtrCallExp node, CFunctionPtrCallExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AWhileStm} associated with {@code point}
	 * @param point the {@link CWhileStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AWhileStm} and {@link CWhileStmPoint} on the {@code question}
	 */
	public A caseCWhileStmPoint(AWhileStm node, CWhileStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link ABinopExp} associated with {@code point}
	 * @param point the {@link CBinopExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link ABinopExp} and {@link CBinopExpPoint} on the {@code question}
	 */
	public A caseCBinopExpPoint(ABinopExp node, CBinopExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AAssignVarStm} associated with {@code point}
	 * @param point the {@link CAssignVarStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AAssignVarStm} and {@link CAssignVarStmPoint} on the {@code question}
	 */
	public A caseCAssignVarStmPoint(AAssignVarStm node, CAssignVarStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AIfThenElseStm} associated with {@code point}
	 * @param point the {@link CIfThenElseStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AIfThenElseStm} and {@link CIfThenElseStmPoint} on the {@code question}
	 */
	public A caseCIfThenElseStmPoint(AIfThenElseStm node, CIfThenElseStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link AOutputStm} associated with {@code point}
	 * @param point the {@link COutputStmPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link AOutputStm} and {@link COutputStmPoint} on the {@code question}
	 */
	public A caseCOutputStmPoint(AOutputStm node, COutputStmPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link APointerExp} associated with {@code point}
	 * @param point the {@link CPointerExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link APointerExp} and {@link CPointerExpPoint} on the {@code question}
	 */
	public A caseCPointerExpPoint(APointerExp node, CPointerExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

	/**
	 * Default implementation. Calls {@link #defaultNode(Node,IProgramPoint,Object)}.
	 * @param node the {@link ANullExp} associated with {@code point}
	 * @param point the {@link CNullExpPoint} calling the method
	 * @param question the question
	 * @return the answer for a {@link ANullExp} and {@link CNullExpPoint} on the {@code question}
	 */
	public A caseCNullExpPoint(ANullExp node, CNullExpPoint point, Q question) {
		return defaultNode(node, point, question);
	}

}
