/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code CIfThenElseStmPoint} is a program point in a control flow graph associated with a
 * {@link AIfThenElseStm}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CIfThenElseStmPoint extends AProgramPoint {
	// the AIfThenElseStm associated with the program point
	protected AIfThenElseStm _node_;
	// the label of the program point
	protected String _label_;

	/**
	 * Creates a new {@code CIfThenElseStmPoint} associated with the {@link AIfThenElseStm} {@code _node_}
	 * with the label {@code ""}.
	 * @param _node_ the {@link AIfThenElseStm} associated the the program point
	 */
	public CIfThenElseStmPoint(AIfThenElseStm _node_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = "";
	}

	/**
	 * Creates a new {@code CIfThenElseStmPoint} associated with the {@link AIfThenElseStm} {@code _node_}
	 * with the label {@code _label_}.
	 * @param _node_ the {@link AIfThenElseStm} associated the the program point
	 * @param _label_ the label of the program point
	 */
	public CIfThenElseStmPoint(AIfThenElseStm _node_, String _label_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = _label_;
	}
	
	/**
	 * Returns the {@link AIfThenElseStm} associated with this program point.
	 * @return the {@link AIfThenElseStm} associated with this program point
	 */
	public AIfThenElseStm getNode() {
		return _node_;
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseCIfThenElseStmPoint(AIfThenElseStm,CIfThenElseStmPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseCIfThenElseStmPoint(AIfThenElseStm,CIfThenElseStmPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseCIfThenElseStmPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of this program point by calling the 
	 * {@link Answer#caseAIfThenElseStm(AIfThenElseStm)} on {@code nodeText}.
	 * @return a textual representation of this program point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return nodeText.caseAIfThenElseStm(_node_);
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseCIfThenElseStmPoint(AIfThenElseStm,CIfThenElseStmPoint)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseCIfThenElseStmPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseCIfThenElseStmPoint(AIfThenElseStm,CIfThenElseStmPoint,Object)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseCIfThenElseStmPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the program point with no predecessors or successors.
	 * @return a clone of the program point with no predecessors or successors
	 */
	public CIfThenElseStmPoint clone() {
		return new CIfThenElseStmPoint(_node_, _label_);
	}
	
	/**
	 * Returns a textual representation of this {@link CIfThenElseStmPoint}.
	 * @return a textual representation of this {@link CIfThenElseStmPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("CIfThenElseStmPoint");
		sb.append("[");
		sb.append(this._label_);
		sb.append("]:");
		sb.append(this._node_);
		return sb.toString();
	}
}
