/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code COutputStmPoint} is a program point in a control flow graph associated with a
 * {@link AOutputStm}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class COutputStmPoint extends AProgramPoint {
	// the AOutputStm associated with the program point
	protected AOutputStm _node_;
	// the label of the program point
	protected String _label_;

	/**
	 * Creates a new {@code COutputStmPoint} associated with the {@link AOutputStm} {@code _node_}
	 * with the label {@code ""}.
	 * @param _node_ the {@link AOutputStm} associated the the program point
	 */
	public COutputStmPoint(AOutputStm _node_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = "";
	}

	/**
	 * Creates a new {@code COutputStmPoint} associated with the {@link AOutputStm} {@code _node_}
	 * with the label {@code _label_}.
	 * @param _node_ the {@link AOutputStm} associated the the program point
	 * @param _label_ the label of the program point
	 */
	public COutputStmPoint(AOutputStm _node_, String _label_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = _label_;
	}
	
	/**
	 * Returns the {@link AOutputStm} associated with this program point.
	 * @return the {@link AOutputStm} associated with this program point
	 */
	public AOutputStm getNode() {
		return _node_;
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseCOutputStmPoint(AOutputStm,COutputStmPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseCOutputStmPoint(AOutputStm,COutputStmPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseCOutputStmPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of this program point by calling the 
	 * {@link Answer#caseAOutputStm(AOutputStm)} on {@code nodeText}.
	 * @return a textual representation of this program point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return nodeText.caseAOutputStm(_node_);
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseCOutputStmPoint(AOutputStm,COutputStmPoint)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseCOutputStmPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseCOutputStmPoint(AOutputStm,COutputStmPoint,Object)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseCOutputStmPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the program point with no predecessors or successors.
	 * @return a clone of the program point with no predecessors or successors
	 */
	public COutputStmPoint clone() {
		return new COutputStmPoint(_node_, _label_);
	}
	
	/**
	 * Returns a textual representation of this {@link COutputStmPoint}.
	 * @return a textual representation of this {@link COutputStmPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("COutputStmPoint");
		sb.append("[");
		sb.append(this._label_);
		sb.append("]:");
		sb.append(this._node_);
		return sb.toString();
	}
}
