/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code CVarExpPoint} is a program point in a control flow graph associated with a
 * {@link AVarExp}.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class CVarExpPoint extends AProgramPoint {
	// the AVarExp associated with the program point
	protected AVarExp _node_;
	// the label of the program point
	protected String _label_;

	/**
	 * Creates a new {@code CVarExpPoint} associated with the {@link AVarExp} {@code _node_}
	 * with the label {@code ""}.
	 * @param _node_ the {@link AVarExp} associated the the program point
	 */
	public CVarExpPoint(AVarExp _node_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = "";
	}

	/**
	 * Creates a new {@code CVarExpPoint} associated with the {@link AVarExp} {@code _node_}
	 * with the label {@code _label_}.
	 * @param _node_ the {@link AVarExp} associated the the program point
	 * @param _label_ the label of the program point
	 */
	public CVarExpPoint(AVarExp _node_, String _label_) {
		super(_node_);
		this._node_ = _node_;
		this._label_ = _label_;
	}
	
	/**
	 * Returns the {@link AVarExp} associated with this program point.
	 * @return the {@link AVarExp} associated with this program point
	 */
	public AVarExp getNode() {
		return _node_;
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseCVarExpPoint(AVarExp,CVarExpPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseCVarExpPoint(AVarExp,CVarExpPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseCVarExpPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of this program point by calling the 
	 * {@link Answer#caseAVarExp(AVarExp)} on {@code nodeText}.
	 * @return a textual representation of this program point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return nodeText.caseAVarExp(_node_);
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseCVarExpPoint(AVarExp,CVarExpPoint)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseCVarExpPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseCVarExpPoint(AVarExp,CVarExpPoint,Object)}
	 * the visitor {@code caller} with this program point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseCVarExpPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the program point with no predecessors or successors.
	 * @return a clone of the program point with no predecessors or successors
	 */
	public CVarExpPoint clone() {
		return new CVarExpPoint(_node_, _label_);
	}
	
	/**
	 * Returns a textual representation of this {@link CVarExpPoint}.
	 * @return a textual representation of this {@link CVarExpPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("CVarExpPoint");
		sb.append("[");
		sb.append(this._label_);
		sb.append("]:");
		sb.append(this._node_);
		return sb.toString();
	}
}
