/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code EntryPoint} represents the entry point of a control flow graph.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class EntryPoint extends AProgramPoint {
	/**
	 * Creates a new entry point with no associated node.
	 */ 
	public EntryPoint() {
		super(null);
	}

	/**
	 * Creates a new entry point associated with {@code _node_}.
	 * @param _node_ the {@link Node} associated with this entry point
	 */ 
	public EntryPoint(Node _node_) {
		super(_node_);
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseEntryPoint(Node,EntryPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseEntryPoint(Node,EntryPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseEntryPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of the entry point, which is
	 * {@code "{entry}"}.
	 * @return a textual representation of the entry point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return "{entry}";
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseEntryPoint(Node,EntryPoint)}
	 * the visitor {@code caller} with this entry point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseEntryPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseEntryPoint(Node,EntryPoint,Object)}
	 * the visitor {@code caller} with this entry point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseEntryPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the entry point with no predecessors or successors.
	 * @return a clone of the entry point with no predecessors or successors
	 */
	public EntryPoint clone() {
		return new EntryPoint(_node_);
	}
	
	/**
	 * Returns a textual representation of this {@link EntryPoint}.
	 * @return a textual representation of this {@link EntryPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("EntryPoint");
		sb.append(":");
		sb.append(this._node_);
		return sb.toString();
	}
}
