/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;
import tip.analysis.*;

/**
 * {@code ExitPoint} represents the exit point of a control flow graph.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class ExitPoint extends AProgramPoint {
	/**
	 * Creates a new exit point with no associated node.
	 */ 
	public ExitPoint() {
		super(null);
	}

	/**
	 * Creates a new exit point associated with {@code _node_}.
	 * @param _node_ the {@link Node} associated with this exit point
	 */ 
	public ExitPoint(Node _node_) {
		super(_node_);
	}
	
	/**
	 * Calls {@link ICFGAnalysis#caseExitPoint(Node,ExitPoint)} on 
	 * {@code analysis} and returns the result.
	 * @return the result of calling
	 * {@link ICFGAnalysis#caseExitPoint(Node,ExitPoint)} on {@code analysis}
	 */
	public boolean apply(ICFGAnalysis analysis) {
		return analysis.caseExitPoint(_node_, this);
	}
	
	/**
	 * Returns a textual representation of the exit point, which is
	 * {@code "{exit}"}.
	 * @return a textual representation of the exit point
	 */
	public String getNodeText(Answer<String> nodeText) {
		return "{exit}";
	}

	/**
	 * Returns an answer by calling {@link CFGAnswer#caseExitPoint(Node,ExitPoint)}
	 * the visitor {@code caller} with this exit point.
	 * @param caller the {@link Answer} used
	 * @return the answer as returned from {@code caller} 
	 */
	public <A> A apply(CFGAnswer<A> caller) {
		return caller.caseExitPoint(_node_, this);
	}
	
	/**
	 * Returns an answer by calling {@link CFGQuestionAnswer#caseExitPoint(Node,ExitPoint,Object)}
	 * the visitor {@code caller} with this exit point.
	 * @param caller the {@link QuestionAnswer} used
	 * @param question the question used
	 * @return the answer as returned from {@code caller} on {@code question}
	 */
	public <Q,A> A apply(CFGQuestionAnswer<Q,A> caller, Q question) {
		return caller.caseExitPoint(_node_, this, question);
	}
	
	/**
	 * Returns a clone of the exit point with no predecessors or successors.
	 * @return a clone of the exit point with no predecessors or successors
	 */
	public ExitPoint clone() {
		return new ExitPoint(_node_);
	}
	
	/**
	 * Returns a textual representation of this {@link ExitPoint}.
	 * @return a textual representation of this {@link ExitPoint}
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("ExitPoint");
		sb.append(":");
		sb.append(this._node_);
		return sb.toString();
	}
}
