/* This file was generated by SableCC (http://www.sablecc.org/). */
 
package tip.cfg;


import tip.node.*;

/**
 * {@code ICFGAnalysis} defines the interface for an analysis based on
 * {@link IProgramPoint}. The interface is a visitor pattern.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public interface ICFGAnalysis {
	/**
	 * {@code caseEntryPoint} is called by a {@link EntryPoint} from
	 * {@link EntryPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link EntryPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseEntryPoint(Node node, EntryPoint point);
	/**
	 * {@code caseExitPoint} is called by a {@link ExitPoint} from
	 * {@link ExitPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link Node} associated with {@code point}
	 * @param point the {@link ExitPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseExitPoint(Node node, ExitPoint point);
	
	/**
	 * {@code caseCReturnStmPoint} is called by a {@link CReturnStmPoint} from
	 * {@link CReturnStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AReturnStm} associated with {@code point}
	 * @param point the {@link CReturnStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCReturnStmPoint(AReturnStm node, CReturnStmPoint point);
	
	/**
	 * {@code caseCAssignPtrStmPoint} is called by a {@link CAssignPtrStmPoint} from
	 * {@link CAssignPtrStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AAssignPtrStm} associated with {@code point}
	 * @param point the {@link CAssignPtrStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCAssignPtrStmPoint(AAssignPtrStm node, CAssignPtrStmPoint point);
	
	/**
	 * {@code caseCBlockPoint} is called by a {@link CBlockPoint} from
	 * {@link CBlockPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link ABlock} associated with {@code point}
	 * @param point the {@link CBlockPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCBlockPoint(ABlock node, CBlockPoint point);
	
	/**
	 * {@code caseCVarExpPoint} is called by a {@link CVarExpPoint} from
	 * {@link CVarExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AVarExp} associated with {@code point}
	 * @param point the {@link CVarExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCVarExpPoint(AVarExp node, CVarExpPoint point);
	
	/**
	 * {@code caseCFunctionCallExpPoint} is called by a {@link CFunctionCallExpPoint} from
	 * {@link CFunctionCallExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AFunctionCallExp} associated with {@code point}
	 * @param point the {@link CFunctionCallExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCFunctionCallExpPoint(AFunctionCallExp node, CFunctionCallExpPoint point);
	
	/**
	 * {@code caseCDerefExpPoint} is called by a {@link CDerefExpPoint} from
	 * {@link CDerefExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link ADerefExp} associated with {@code point}
	 * @param point the {@link CDerefExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCDerefExpPoint(ADerefExp node, CDerefExpPoint point);
	
	/**
	 * {@code caseCDeclStmPoint} is called by a {@link CDeclStmPoint} from
	 * {@link CDeclStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link ADeclStm} associated with {@code point}
	 * @param point the {@link CDeclStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCDeclStmPoint(ADeclStm node, CDeclStmPoint point);
	
	/**
	 * {@code caseCInputExpPoint} is called by a {@link CInputExpPoint} from
	 * {@link CInputExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AInputExp} associated with {@code point}
	 * @param point the {@link CInputExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCInputExpPoint(AInputExp node, CInputExpPoint point);
	
	/**
	 * {@code caseCMallocExpPoint} is called by a {@link CMallocExpPoint} from
	 * {@link CMallocExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AMallocExp} associated with {@code point}
	 * @param point the {@link CMallocExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCMallocExpPoint(AMallocExp node, CMallocExpPoint point);
	
	/**
	 * {@code caseCIfThenStmPoint} is called by a {@link CIfThenStmPoint} from
	 * {@link CIfThenStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AIfThenStm} associated with {@code point}
	 * @param point the {@link CIfThenStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCIfThenStmPoint(AIfThenStm node, CIfThenStmPoint point);
	
	/**
	 * {@code caseCIntConstExpPoint} is called by a {@link CIntConstExpPoint} from
	 * {@link CIntConstExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AIntConstExp} associated with {@code point}
	 * @param point the {@link CIntConstExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCIntConstExpPoint(AIntConstExp node, CIntConstExpPoint point);
	
	/**
	 * {@code caseCFunctionPtrCallExpPoint} is called by a {@link CFunctionPtrCallExpPoint} from
	 * {@link CFunctionPtrCallExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AFunctionPtrCallExp} associated with {@code point}
	 * @param point the {@link CFunctionPtrCallExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCFunctionPtrCallExpPoint(AFunctionPtrCallExp node, CFunctionPtrCallExpPoint point);
	
	/**
	 * {@code caseCWhileStmPoint} is called by a {@link CWhileStmPoint} from
	 * {@link CWhileStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AWhileStm} associated with {@code point}
	 * @param point the {@link CWhileStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCWhileStmPoint(AWhileStm node, CWhileStmPoint point);
	
	/**
	 * {@code caseCBinopExpPoint} is called by a {@link CBinopExpPoint} from
	 * {@link CBinopExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link ABinopExp} associated with {@code point}
	 * @param point the {@link CBinopExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCBinopExpPoint(ABinopExp node, CBinopExpPoint point);
	
	/**
	 * {@code caseCAssignVarStmPoint} is called by a {@link CAssignVarStmPoint} from
	 * {@link CAssignVarStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AAssignVarStm} associated with {@code point}
	 * @param point the {@link CAssignVarStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCAssignVarStmPoint(AAssignVarStm node, CAssignVarStmPoint point);
	
	/**
	 * {@code caseCIfThenElseStmPoint} is called by a {@link CIfThenElseStmPoint} from
	 * {@link CIfThenElseStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AIfThenElseStm} associated with {@code point}
	 * @param point the {@link CIfThenElseStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCIfThenElseStmPoint(AIfThenElseStm node, CIfThenElseStmPoint point);
	
	/**
	 * {@code caseCOutputStmPoint} is called by a {@link COutputStmPoint} from
	 * {@link COutputStmPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link AOutputStm} associated with {@code point}
	 * @param point the {@link COutputStmPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCOutputStmPoint(AOutputStm node, COutputStmPoint point);
	
	/**
	 * {@code caseCPointerExpPoint} is called by a {@link CPointerExpPoint} from
	 * {@link CPointerExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link APointerExp} associated with {@code point}
	 * @param point the {@link CPointerExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCPointerExpPoint(APointerExp node, CPointerExpPoint point);
	
	/**
	 * {@code caseCNullExpPoint} is called by a {@link CNullExpPoint} from
	 * {@link CNullExpPoint#apply(ICFGAnalysis)}.
	 * @param node the {@link ANullExp} associated with {@code point}
	 * @param point the {@link CNullExpPoint} calling the method
	 * @return {@code true} if the call resulted in a change of the analysis
	 */
	public boolean caseCNullExpPoint(ANullExp node, CNullExpPoint point);
	
}
