/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ABinopExp} represents the {@code binop} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class ABinopExp extends PExp {
	private PExp _left_;
	private PBinop _binop_;
	private PExp _right_;
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link ABinopExp} node with no children.
	 */
	public ABinopExp() {
	}
	
	/**
	 * Creates a new {@code ABinopExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _left_ the {@link PExp} node for the {@code Left} child of this {@link ABinopExp} node
	 * @param _binop_ the {@link PBinop} node for the {@code Binop} child of this {@link ABinopExp} node
	 * @param _right_ the {@link PExp} node for the {@code Right} child of this {@link ABinopExp} node
	 */
	public ABinopExp(@SuppressWarnings("hiding") PExp _left_,
		@SuppressWarnings("hiding") PBinop _binop_,
		@SuppressWarnings("hiding") PExp _right_)
	{
		setLeft(_left_);
		setBinop(_binop_);
		setRight(_right_);
	}
	
	/**
	 * Creates a new {@code ABinopExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _left_ the {@link PExp} node for the {@code Left} child of this {@link ABinopExp} node
	 * @param _binop_ the {@link PBinop} node for the {@code Binop} child of this {@link ABinopExp} node
	 * @param _right_ the {@link PExp} node for the {@code Right} child of this {@link ABinopExp} node
	 * @param _type_ the {@code Type} child of this {@link ABinopExp} node
	 */
	public ABinopExp(@SuppressWarnings("hiding") PExp _left_,
		@SuppressWarnings("hiding") PBinop _binop_,
		@SuppressWarnings("hiding") PExp _right_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setLeft(_left_);
		setBinop(_binop_);
		setRight(_right_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link ABinopExp} node.
	 * @return a deep clone of this {@link ABinopExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABinopExp clone() {
		return new ABinopExp(
			cloneNode(_left_),
			cloneNode(_binop_),
			cloneNode(_right_),
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ABinopExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ABinopExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABinopExp clone(Map<Node,Node> oldToNewMap) {
		ABinopExp node = new ABinopExp(
			cloneNode(_left_, oldToNewMap),
			cloneNode(_binop_, oldToNewMap),
			cloneNode(_right_, oldToNewMap),
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ABinopExp} node.
	 * @return a textual representation of this {@link ABinopExp} node
	 */
	public @Override String toString() {
		return "" + toString(this._left_)
		 + toString(this._binop_)
		 + toString(this._right_);
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.BINOP;
	}
	
	/**
	 * Returns the {@link PExp} node which is the {@code left} child of this {@link ABinopExp} node.
	 * @return the {@link PExp} node which is the {@code left} child of this {@link ABinopExp} node
	 */
	public PExp getLeft() {
		return this._left_;
	}
	
	/**
	 * Sets the {@code left} child of this {@link ABinopExp} node.
	 * @param value the new {@code left} child of this {@link ABinopExp} node
	 */
	public void setLeft(PExp value) {
		if (this._left_ != null) {
			this._left_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getLeft() is null");
		}
		this._left_ = value;
	}
	
	/**
	 * Returns the {@link PBinop} node which is the {@code binop} child of this {@link ABinopExp} node.
	 * @return the {@link PBinop} node which is the {@code binop} child of this {@link ABinopExp} node
	 */
	public PBinop getBinop() {
		return this._binop_;
	}
	
	/**
	 * Sets the {@code binop} child of this {@link ABinopExp} node.
	 * @param value the new {@code binop} child of this {@link ABinopExp} node
	 */
	public void setBinop(PBinop value) {
		if (this._binop_ != null) {
			this._binop_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getBinop() is null");
		}
		this._binop_ = value;
	}
	
	/**
	 * Returns the {@link PExp} node which is the {@code right} child of this {@link ABinopExp} node.
	 * @return the {@link PExp} node which is the {@code right} child of this {@link ABinopExp} node
	 */
	public PExp getRight() {
		return this._right_;
	}
	
	/**
	 * Sets the {@code right} child of this {@link ABinopExp} node.
	 * @param value the new {@code right} child of this {@link ABinopExp} node
	 */
	public void setRight(PExp value) {
		if (this._right_ != null) {
			this._right_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getRight() is null");
		}
		this._right_ = value;
	}
	
	/**
	 * Returns the {@code type} field of this {@link ABinopExp} node.
	 * @return the {@code type} field of this {@link ABinopExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link ABinopExp} node.
	 * @param value the new {@code type} field of this {@link ABinopExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ABinopExp} node.
	 * @param child the child node to be removed from this {@link ABinopExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ABinopExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._left_ == child) {
			this._left_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getLeft() is null");
			}
			return;
		}
		if (this._binop_ == child) {
			this._binop_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getBinop() is null");
			}
			return;
		}
		if (this._right_ == child) {
			this._right_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getRight() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ABinopExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ABinopExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ABinopExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._left_ == oldChild) {
			setLeft((PExp)newChild);
			return;
		}
		if (this._binop_ == oldChild) {
			setBinop((PBinop)newChild);
			return;
		}
		if (this._right_ == oldChild) {
			setRight((PExp)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ABinopExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._left_ != null) {
			this._left_.getDescendants(collection, filter);
		}
		if(this._binop_ != null) {
			this._binop_.getDescendants(collection, filter);
		}
		if(this._right_ != null) {
			this._right_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ABinopExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._left_ != null) {
			if (filter.accept(this._left_)) {
				collection.add((T)this._left_);
			}
		}
		if(this._binop_ != null) {
			if (filter.accept(this._binop_)) {
				collection.add((T)this._binop_);
			}
		}
		if(this._right_ != null) {
			if (filter.accept(this._right_)) {
				collection.add((T)this._right_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._left_ == null) {
				throw new TreeInvariantException(this, ".getLeft() is null");
			}
			if (this._binop_ == null) {
				throw new TreeInvariantException(this, ".getBinop() is null");
			}
			if (this._right_ == null) {
				throw new TreeInvariantException(this, ".getRight() is null");
			}
		}
		if(this._left_ != null) {
			this._left_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._binop_ != null) {
			this._binop_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._right_ != null) {
			this._right_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseABinopExp(ABinopExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ABinopExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseABinopExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABinopExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseABinopExp(this);
	}
	
	/**
	 * Applies this {@link ABinopExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseABinopExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABinopExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseABinopExp(this, question);
	}
	
}
