/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ABlock} represents the {@code } alternative of the {@code block} production in the AST.
 */
@SuppressWarnings("nls")
public final class ABlock extends PBlock {
	private NodeList<PStm> _statements_ = new NodeList<PStm>(this,"getStatements()",true);
	private Map<String,ALocalDecl> _local_env_;
	
	/**
	 * Creates a new {@link ABlock} node with no children.
	 */
	public ABlock() {
		setLocalEnv(null);
	}
	
	/**
	 * Creates a new {@code ABlock} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _statements_ the list of {@link PStm} nodes for the {@code Statements} children of this {@link ABlock} node
	 */
	public ABlock(@SuppressWarnings("hiding") List<? extends PStm> _statements_) {
		setStatements(_statements_);
		setLocalEnv(null);
	}
	
	/**
	 * Creates a new {@code ABlock} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _statements_ the list of {@link PStm} nodes for the {@code Statements} children of this {@link ABlock} node
	 * @param _local_env_ the {@code LocalEnv} child of this {@link ABlock} node
	 */
	public ABlock(@SuppressWarnings("hiding") List<? extends PStm> _statements_,
		@SuppressWarnings("hiding") Map<String,ALocalDecl> _local_env_)
	{
		setStatements(_statements_);
		setLocalEnv(_local_env_);
	}
	
	/**
	 * Returns a deep clone of this {@link ABlock} node.
	 * @return a deep clone of this {@link ABlock} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABlock clone() {
		return new ABlock(
			cloneList(_statements_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ABlock} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ABlock} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABlock clone(Map<Node,Node> oldToNewMap) {
		ABlock node = new ABlock(
			cloneList(_statements_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ABlock} node.
	 * @return a textual representation of this {@link ABlock} node
	 */
	public @Override String toString() {
		return "" + toString(this._statements_);
	}
	
	/**
	 * Returns the possibly empty list of {@link PStm} nodes that are the {@code statements} children of this {@link ABlock} node.
	 * @return the possibly empty list of {@link PStm} nodes that are the {@code statements} children of this {@link ABlock} node
	 */
	public LinkedList<PStm> getStatements() {
		return this._statements_;
	}
	
	/**
	 * Sets the {@code statements} children of this {@link ABlock} node.
	 * @param value the new {@code statements} children of this {@link ABlock} node
	 */
	public void setStatements(List<? extends PStm> value) {
		if (value == this._statements_) {
			return;
		}
		this._statements_.setAll(value);
	}
	
	/**
	 * Returns the {@code local_env} field of this {@link ABlock} node.
	 * @return the {@code local_env} field of this {@link ABlock} node
	 */
	public Map<String,ALocalDecl> getLocalEnv() {
		return this._local_env_;
	}
	
	/**
	 * Sets the {@code local_env} field of this {@link ABlock} node.
	 * @param value the new {@code local_env} field of this {@link ABlock} node
	 */
	public void setLocalEnv(Map<String,ALocalDecl> value) {
		if (value == null) {
			value = new TreeMap<String,ALocalDecl>();
		}
		this._local_env_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ABlock} node.
	 * @param child the child node to be removed from this {@link ABlock} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ABlock} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._statements_.remove(child)) {
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ABlock} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ABlock} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ABlock} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		for (ListIterator<PStm> i = this._statements_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((PStm)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ABlock} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		for (PStm e : new ArrayList<PStm>(this._statements_)) {
			e.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ABlock} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		for (PStm e : new ArrayList<PStm>(this._statements_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
		}
		for (PStm e : new ArrayList<PStm>(this._statements_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseABlock(ABlock)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ABlock} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseABlock(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABlock}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseABlock(this);
	}
	
	/**
	 * Applies this {@link ABlock} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseABlock(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABlock} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseABlock(this, question);
	}
	
}
