/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ABlockStm} represents the {@code block} alternative of the {@code stm} production in the AST.
 */
@SuppressWarnings("nls")
public final class ABlockStm extends PStm {
	private TLBrace _token_;
	private ABlock _block_;
	
	/**
	 * Creates a new {@link ABlockStm} node with no children.
	 */
	public ABlockStm() {
	}
	
	/**
	 * Creates a new {@code ABlockStm} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TLBrace} node for the {@code Token} child of this {@link ABlockStm} node
	 * @param _block_ the {@link ABlock} node for the {@code Block} child of this {@link ABlockStm} node
	 */
	public ABlockStm(@SuppressWarnings("hiding") TLBrace _token_,
		@SuppressWarnings("hiding") ABlock _block_)
	{
		setToken(_token_);
		setBlock(_block_);
	}
	
	/**
	 * Returns a deep clone of this {@link ABlockStm} node.
	 * @return a deep clone of this {@link ABlockStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABlockStm clone() {
		return new ABlockStm(
			cloneNode(_token_),
			cloneNode(_block_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ABlockStm} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ABlockStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABlockStm clone(Map<Node,Node> oldToNewMap) {
		ABlockStm node = new ABlockStm(
			cloneNode(_token_, oldToNewMap),
			cloneNode(_block_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ABlockStm} node.
	 * @return a textual representation of this {@link ABlockStm} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_)
		 + toString(this._block_);
	}
	
	/**
	 * Returns the {@link EStm} corresponding to the
	 * type of this {@link PStm} node.
	 * @return the {@link EStm} for this node
	 */
	@Override public EStm kindPStm() {
		return EStm.BLOCK;
	}
	
	/**
	 * Returns the {@link TLBrace} node which is the {@code token} child of this {@link ABlockStm} node.
	 * @return the {@link TLBrace} node which is the {@code token} child of this {@link ABlockStm} node
	 */
	public TLBrace getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link ABlockStm} node.
	 * @param value the new {@code token} child of this {@link ABlockStm} node
	 */
	public void setToken(TLBrace value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Returns the {@link ABlock} node which is the {@code block} child of this {@link ABlockStm} node.
	 * @return the {@link ABlock} node which is the {@code block} child of this {@link ABlockStm} node
	 */
	public ABlock getBlock() {
		return this._block_;
	}
	
	/**
	 * Sets the {@code block} child of this {@link ABlockStm} node.
	 * @param value the new {@code block} child of this {@link ABlockStm} node
	 */
	public void setBlock(ABlock value) {
		if (this._block_ != null) {
			this._block_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getBlock() is null");
		}
		this._block_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ABlockStm} node.
	 * @param child the child node to be removed from this {@link ABlockStm} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ABlockStm} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		if (this._block_ == child) {
			this._block_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getBlock() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ABlockStm} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ABlockStm} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ABlockStm} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TLBrace)newChild);
			return;
		}
		if (this._block_ == oldChild) {
			setBlock((ABlock)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ABlockStm} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
		if(this._block_ != null) {
			this._block_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ABlockStm} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
		if(this._block_ != null) {
			if (filter.accept(this._block_)) {
				collection.add((T)this._block_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			if (this._block_ == null) {
				throw new TreeInvariantException(this, ".getBlock() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._block_ != null) {
			this._block_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseABlockStm(ABlockStm)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ABlockStm} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseABlockStm(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABlockStm}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseABlockStm(this);
	}
	
	/**
	 * Applies this {@link ABlockStm} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseABlockStm(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABlockStm} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseABlockStm(this, question);
	}
	
}
