/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ABody} represents the {@code } alternative of the {@code body} production in the AST.
 */
@SuppressWarnings("nls")
public final class ABody extends PBody {
	private ABlock _block_;
	private LinkedList<tip.instructions.Instruction> _instructions_ = new LinkedList<tip.instructions.Instruction>();
	
	/**
	 * Creates a new {@link ABody} node with no children.
	 */
	public ABody() {
	}
	
	/**
	 * Creates a new {@code ABody} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _block_ the {@link ABlock} node for the {@code Block} child of this {@link ABody} node
	 */
	public ABody(@SuppressWarnings("hiding") ABlock _block_) {
		setBlock(_block_);
	}
	
	/**
	 * Creates a new {@code ABody} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _block_ the {@link ABlock} node for the {@code Block} child of this {@link ABody} node
	 * @param _instructions_ the {@code Instructions} child of this {@link ABody} node
	 */
	public ABody(@SuppressWarnings("hiding") ABlock _block_,
		@SuppressWarnings("hiding") List<? extends tip.instructions.Instruction> _instructions_)
	{
		setBlock(_block_);
		setInstructions(_instructions_);
	}
	
	/**
	 * Returns a deep clone of this {@link ABody} node.
	 * @return a deep clone of this {@link ABody} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABody clone() {
		return new ABody(
			cloneNode(_block_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ABody} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ABody} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ABody clone(Map<Node,Node> oldToNewMap) {
		ABody node = new ABody(
			cloneNode(_block_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ABody} node.
	 * @return a textual representation of this {@link ABody} node
	 */
	public @Override String toString() {
		return "" + toString(this._block_);
	}
	
	/**
	 * Returns the {@link ABlock} node which is the {@code block} child of this {@link ABody} node.
	 * @return the {@link ABlock} node which is the {@code block} child of this {@link ABody} node
	 */
	public ABlock getBlock() {
		return this._block_;
	}
	
	/**
	 * Sets the {@code block} child of this {@link ABody} node.
	 * @param value the new {@code block} child of this {@link ABody} node
	 */
	public void setBlock(ABlock value) {
		if (this._block_ != null) {
			this._block_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getBlock() is null");
		}
		this._block_ = value;
	}
	
	/**
	 * Returns the {@code instructions} field of this {@link ABody} node.
	 * @return the {@code instructions} field of this {@link ABody} node
	 */
	public LinkedList<tip.instructions.Instruction> getInstructions() {
		return this._instructions_;
	}
	
	/**
	 * Sets the {@code instructions} field of this {@link ABody} node.
	 * @param value the new {@code instructions} field of this {@link ABody} node
	 */
	public void setInstructions(List<? extends tip.instructions.Instruction> value) {
		if (value == this._instructions_) {
			return;
		}
		this._instructions_.clear();
		this._instructions_.addAll(value);
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ABody} node.
	 * @param child the child node to be removed from this {@link ABody} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ABody} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._block_ == child) {
			this._block_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getBlock() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ABody} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ABody} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ABody} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._block_ == oldChild) {
			setBlock((ABlock)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ABody} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._block_ != null) {
			this._block_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ABody} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._block_ != null) {
			if (filter.accept(this._block_)) {
				collection.add((T)this._block_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._block_ == null) {
				throw new TreeInvariantException(this, ".getBlock() is null");
			}
		}
		if(this._block_ != null) {
			this._block_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseABody(ABody)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ABody} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseABody(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABody}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseABody(this);
	}
	
	/**
	 * Applies this {@link ABody} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseABody(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ABody} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseABody(this, question);
	}
	
}
