/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ADeclStm} represents the {@code decl} alternative of the {@code stm} production in the AST.
 */
@SuppressWarnings("nls")
public final class ADeclStm extends PStm {
	private TVar _token_;
	private NodeList<ALocalDecl> _decl_ = new NodeList<ALocalDecl>(this,"getDecl()",true);
	
	/**
	 * Creates a new {@link ADeclStm} node with no children.
	 */
	public ADeclStm() {
	}
	
	/**
	 * Creates a new {@code ADeclStm} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TVar} node for the {@code Token} child of this {@link ADeclStm} node
	 * @param _decl_ the list of {@link ALocalDecl} nodes for the {@code Decl} children of this {@link ADeclStm} node
	 */
	public ADeclStm(@SuppressWarnings("hiding") TVar _token_,
		@SuppressWarnings("hiding") List<? extends ALocalDecl> _decl_)
	{
		setToken(_token_);
		setDecl(_decl_);
	}
	
	/**
	 * Returns a deep clone of this {@link ADeclStm} node.
	 * @return a deep clone of this {@link ADeclStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ADeclStm clone() {
		return new ADeclStm(
			cloneNode(_token_),
			cloneList(_decl_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ADeclStm} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ADeclStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ADeclStm clone(Map<Node,Node> oldToNewMap) {
		ADeclStm node = new ADeclStm(
			cloneNode(_token_, oldToNewMap),
			cloneList(_decl_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ADeclStm} node.
	 * @return a textual representation of this {@link ADeclStm} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_)
		 + toString(this._decl_);
	}
	
	/**
	 * Returns the {@link EStm} corresponding to the
	 * type of this {@link PStm} node.
	 * @return the {@link EStm} for this node
	 */
	@Override public EStm kindPStm() {
		return EStm.DECL;
	}
	
	/**
	 * Returns the {@link TVar} node which is the {@code token} child of this {@link ADeclStm} node.
	 * @return the {@link TVar} node which is the {@code token} child of this {@link ADeclStm} node
	 */
	public TVar getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link ADeclStm} node.
	 * @param value the new {@code token} child of this {@link ADeclStm} node
	 */
	public void setToken(TVar value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Returns the possibly empty list of {@link ALocalDecl} nodes that are the {@code decl} children of this {@link ADeclStm} node.
	 * @return the possibly empty list of {@link ALocalDecl} nodes that are the {@code decl} children of this {@link ADeclStm} node
	 */
	public LinkedList<ALocalDecl> getDecl() {
		return this._decl_;
	}
	
	/**
	 * Sets the {@code decl} children of this {@link ADeclStm} node.
	 * @param value the new {@code decl} children of this {@link ADeclStm} node
	 */
	public void setDecl(List<? extends ALocalDecl> value) {
		if (value == this._decl_) {
			return;
		}
		this._decl_.setAll(value);
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ADeclStm} node.
	 * @param child the child node to be removed from this {@link ADeclStm} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ADeclStm} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		if (this._decl_.remove(child)) {
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ADeclStm} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ADeclStm} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ADeclStm} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TVar)newChild);
			return;
		}
		for (ListIterator<ALocalDecl> i = this._decl_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((ALocalDecl)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ADeclStm} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._decl_)) {
			e.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ADeclStm} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._decl_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._decl_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseADeclStm(ADeclStm)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ADeclStm} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseADeclStm(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ADeclStm}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseADeclStm(this);
	}
	
	/**
	 * Applies this {@link ADeclStm} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseADeclStm(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ADeclStm} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseADeclStm(this, question);
	}
	
}
