/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AFuncDecl} represents the {@code func} alternative of the {@code decl} production in the AST.
 */
@SuppressWarnings("nls")
public final class AFuncDecl extends PDecl {
	private TIdentifier _name_;
	private NodeList<ALocalDecl> _formals_ = new NodeList<ALocalDecl>(this,"getFormals()",true);
	private ABody _body_;
	private int _num_locals_ = 1;
	private int _num_args_;
	private int _index_;
	
	/**
	 * Creates a new {@link AFuncDecl} node with no children.
	 */
	public AFuncDecl() {
	}
	
	/**
	 * Creates a new {@code AFuncDecl} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _name_ the {@link TIdentifier} node for the {@code Name} child of this {@link AFuncDecl} node
	 * @param _formals_ the list of {@link ALocalDecl} nodes for the {@code Formals} children of this {@link AFuncDecl} node
	 * @param _body_ the {@link ABody} node for the {@code Body} child of this {@link AFuncDecl} node
	 */
	public AFuncDecl(@SuppressWarnings("hiding") TIdentifier _name_,
		@SuppressWarnings("hiding") List<? extends ALocalDecl> _formals_,
		@SuppressWarnings("hiding") ABody _body_)
	{
		setName(_name_);
		setFormals(_formals_);
		setBody(_body_);
	}
	
	/**
	 * Creates a new {@code AFuncDecl} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _name_ the {@link TIdentifier} node for the {@code Name} child of this {@link AFuncDecl} node
	 * @param _formals_ the list of {@link ALocalDecl} nodes for the {@code Formals} children of this {@link AFuncDecl} node
	 * @param _body_ the {@link ABody} node for the {@code Body} child of this {@link AFuncDecl} node
	 * @param _num_locals_ the {@code NumLocals} child of this {@link AFuncDecl} node
	 * @param _num_args_ the {@code NumArgs} child of this {@link AFuncDecl} node
	 * @param _index_ the {@code Index} child of this {@link AFuncDecl} node
	 */
	public AFuncDecl(@SuppressWarnings("hiding") TIdentifier _name_,
		@SuppressWarnings("hiding") List<? extends ALocalDecl> _formals_,
		@SuppressWarnings("hiding") ABody _body_,
		@SuppressWarnings("hiding") int _num_locals_,
		@SuppressWarnings("hiding") int _num_args_,
		@SuppressWarnings("hiding") int _index_)
	{
		setName(_name_);
		setFormals(_formals_);
		setBody(_body_);
		setNumLocals(_num_locals_);
		setNumArgs(_num_args_);
		setIndex(_index_);
	}
	
	/**
	 * Returns a deep clone of this {@link AFuncDecl} node.
	 * @return a deep clone of this {@link AFuncDecl} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFuncDecl clone() {
		return new AFuncDecl(
			cloneNode(_name_),
			cloneList(_formals_),
			cloneNode(_body_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AFuncDecl} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AFuncDecl} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFuncDecl clone(Map<Node,Node> oldToNewMap) {
		AFuncDecl node = new AFuncDecl(
			cloneNode(_name_, oldToNewMap),
			cloneList(_formals_, oldToNewMap),
			cloneNode(_body_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AFuncDecl} node.
	 * @return a textual representation of this {@link AFuncDecl} node
	 */
	public @Override String toString() {
		return "" + toString(this._name_)
		 + toString(this._formals_)
		 + toString(this._body_);
	}
	
	/**
	 * Returns the {@link EDecl} corresponding to the
	 * type of this {@link PDecl} node.
	 * @return the {@link EDecl} for this node
	 */
	@Override public EDecl kindPDecl() {
		return EDecl.FUNC;
	}
	
	/**
	 * Returns the {@link TIdentifier} node which is the {@code name} child of this {@link AFuncDecl} node.
	 * @return the {@link TIdentifier} node which is the {@code name} child of this {@link AFuncDecl} node
	 */
	public TIdentifier getName() {
		return this._name_;
	}
	
	/**
	 * Sets the {@code name} child of this {@link AFuncDecl} node.
	 * @param value the new {@code name} child of this {@link AFuncDecl} node
	 */
	public void setName(TIdentifier value) {
		if (this._name_ != null) {
			this._name_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getName() is null");
		}
		this._name_ = value;
	}
	
	/**
	 * Returns the possibly empty list of {@link ALocalDecl} nodes that are the {@code formals} children of this {@link AFuncDecl} node.
	 * @return the possibly empty list of {@link ALocalDecl} nodes that are the {@code formals} children of this {@link AFuncDecl} node
	 */
	public LinkedList<ALocalDecl> getFormals() {
		return this._formals_;
	}
	
	/**
	 * Sets the {@code formals} children of this {@link AFuncDecl} node.
	 * @param value the new {@code formals} children of this {@link AFuncDecl} node
	 */
	public void setFormals(List<? extends ALocalDecl> value) {
		if (value == this._formals_) {
			return;
		}
		this._formals_.setAll(value);
	}
	
	/**
	 * Returns the {@link ABody} node which is the {@code body} child of this {@link AFuncDecl} node.
	 * @return the {@link ABody} node which is the {@code body} child of this {@link AFuncDecl} node
	 */
	public ABody getBody() {
		return this._body_;
	}
	
	/**
	 * Sets the {@code body} child of this {@link AFuncDecl} node.
	 * @param value the new {@code body} child of this {@link AFuncDecl} node
	 */
	public void setBody(ABody value) {
		if (this._body_ != null) {
			this._body_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getBody() is null");
		}
		this._body_ = value;
	}
	
	/**
	 * Returns the {@code num_locals} field of this {@link AFuncDecl} node.
	 * @return the {@code num_locals} field of this {@link AFuncDecl} node
	 */
	public int getNumLocals() {
		return this._num_locals_;
	}
	
	/**
	 * Sets the {@code num_locals} field of this {@link AFuncDecl} node.
	 * @param value the new {@code num_locals} field of this {@link AFuncDecl} node
	 */
	public void setNumLocals(int value) {
		this._num_locals_ = value;
	}
	
	/**
	 * Returns the {@code num_args} field of this {@link AFuncDecl} node.
	 * @return the {@code num_args} field of this {@link AFuncDecl} node
	 */
	public int getNumArgs() {
		return this._num_args_;
	}
	
	/**
	 * Sets the {@code num_args} field of this {@link AFuncDecl} node.
	 * @param value the new {@code num_args} field of this {@link AFuncDecl} node
	 */
	public void setNumArgs(int value) {
		this._num_args_ = value;
	}
	
	/**
	 * Returns the {@code index} field of this {@link AFuncDecl} node.
	 * @return the {@code index} field of this {@link AFuncDecl} node
	 */
	public int getIndex() {
		return this._index_;
	}
	
	/**
	 * Sets the {@code index} field of this {@link AFuncDecl} node.
	 * @param value the new {@code index} field of this {@link AFuncDecl} node
	 */
	public void setIndex(int value) {
		this._index_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AFuncDecl} node.
	 * @param child the child node to be removed from this {@link AFuncDecl} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AFuncDecl} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._name_ == child) {
			this._name_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getName() is null");
			}
			return;
		}
		if (this._formals_.remove(child)) {
			return;
		}
		if (this._body_ == child) {
			this._body_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getBody() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AFuncDecl} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AFuncDecl} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AFuncDecl} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._name_ == oldChild) {
			setName((TIdentifier)newChild);
			return;
		}
		for (ListIterator<ALocalDecl> i = this._formals_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((ALocalDecl)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		if (this._body_ == oldChild) {
			setBody((ABody)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AFuncDecl} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._name_ != null) {
			this._name_.getDescendants(collection, filter);
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._formals_)) {
			e.getDescendants(collection, filter);
		}
		if(this._body_ != null) {
			this._body_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AFuncDecl} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._name_ != null) {
			if (filter.accept(this._name_)) {
				collection.add((T)this._name_);
			}
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._formals_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
		if(this._body_ != null) {
			if (filter.accept(this._body_)) {
				collection.add((T)this._body_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._name_ == null) {
				throw new TreeInvariantException(this, ".getName() is null");
			}
			if (this._body_ == null) {
				throw new TreeInvariantException(this, ".getBody() is null");
			}
		}
		if(this._name_ != null) {
			this._name_.setOptionalInvariant(is_optional_invariant);
		}
		for (ALocalDecl e : new ArrayList<ALocalDecl>(this._formals_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
		if(this._body_ != null) {
			this._body_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAFuncDecl(AFuncDecl)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AFuncDecl} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAFuncDecl(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFuncDecl}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAFuncDecl(this);
	}
	
	/**
	 * Applies this {@link AFuncDecl} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAFuncDecl(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFuncDecl} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAFuncDecl(this, question);
	}
	
}
