/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AFunctionCallExp} represents the {@code function_call} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class AFunctionCallExp extends PExp {
	private TIdentifier _identifier_;
	private NodeList<PExp> _args_ = new NodeList<PExp>(this,"getArgs()",true);
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link AFunctionCallExp} node with no children.
	 */
	public AFunctionCallExp() {
	}
	
	/**
	 * Creates a new {@code AFunctionCallExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _identifier_ the {@link TIdentifier} node for the {@code Identifier} child of this {@link AFunctionCallExp} node
	 * @param _args_ the list of {@link PExp} nodes for the {@code Args} children of this {@link AFunctionCallExp} node
	 */
	public AFunctionCallExp(@SuppressWarnings("hiding") TIdentifier _identifier_,
		@SuppressWarnings("hiding") List<? extends PExp> _args_)
	{
		setIdentifier(_identifier_);
		setArgs(_args_);
	}
	
	/**
	 * Creates a new {@code AFunctionCallExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _identifier_ the {@link TIdentifier} node for the {@code Identifier} child of this {@link AFunctionCallExp} node
	 * @param _args_ the list of {@link PExp} nodes for the {@code Args} children of this {@link AFunctionCallExp} node
	 * @param _type_ the {@code Type} child of this {@link AFunctionCallExp} node
	 */
	public AFunctionCallExp(@SuppressWarnings("hiding") TIdentifier _identifier_,
		@SuppressWarnings("hiding") List<? extends PExp> _args_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setIdentifier(_identifier_);
		setArgs(_args_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link AFunctionCallExp} node.
	 * @return a deep clone of this {@link AFunctionCallExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFunctionCallExp clone() {
		return new AFunctionCallExp(
			cloneNode(_identifier_),
			cloneList(_args_),
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AFunctionCallExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AFunctionCallExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFunctionCallExp clone(Map<Node,Node> oldToNewMap) {
		AFunctionCallExp node = new AFunctionCallExp(
			cloneNode(_identifier_, oldToNewMap),
			cloneList(_args_, oldToNewMap),
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AFunctionCallExp} node.
	 * @return a textual representation of this {@link AFunctionCallExp} node
	 */
	public @Override String toString() {
		return "" + toString(this._identifier_)
		 + toString(this._args_);
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.FUNCTION_CALL;
	}
	
	/**
	 * Returns the {@link TIdentifier} node which is the {@code identifier} child of this {@link AFunctionCallExp} node.
	 * @return the {@link TIdentifier} node which is the {@code identifier} child of this {@link AFunctionCallExp} node
	 */
	public TIdentifier getIdentifier() {
		return this._identifier_;
	}
	
	/**
	 * Sets the {@code identifier} child of this {@link AFunctionCallExp} node.
	 * @param value the new {@code identifier} child of this {@link AFunctionCallExp} node
	 */
	public void setIdentifier(TIdentifier value) {
		if (this._identifier_ != null) {
			this._identifier_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getIdentifier() is null");
		}
		this._identifier_ = value;
	}
	
	/**
	 * Returns the possibly empty list of {@link PExp} nodes that are the {@code args} children of this {@link AFunctionCallExp} node.
	 * @return the possibly empty list of {@link PExp} nodes that are the {@code args} children of this {@link AFunctionCallExp} node
	 */
	public LinkedList<PExp> getArgs() {
		return this._args_;
	}
	
	/**
	 * Sets the {@code args} children of this {@link AFunctionCallExp} node.
	 * @param value the new {@code args} children of this {@link AFunctionCallExp} node
	 */
	public void setArgs(List<? extends PExp> value) {
		if (value == this._args_) {
			return;
		}
		this._args_.setAll(value);
	}
	
	/**
	 * Returns the {@code type} field of this {@link AFunctionCallExp} node.
	 * @return the {@code type} field of this {@link AFunctionCallExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link AFunctionCallExp} node.
	 * @param value the new {@code type} field of this {@link AFunctionCallExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AFunctionCallExp} node.
	 * @param child the child node to be removed from this {@link AFunctionCallExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AFunctionCallExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._identifier_ == child) {
			this._identifier_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getIdentifier() is null");
			}
			return;
		}
		if (this._args_.remove(child)) {
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AFunctionCallExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AFunctionCallExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AFunctionCallExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._identifier_ == oldChild) {
			setIdentifier((TIdentifier)newChild);
			return;
		}
		for (ListIterator<PExp> i = this._args_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((PExp)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AFunctionCallExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._identifier_ != null) {
			this._identifier_.getDescendants(collection, filter);
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			e.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AFunctionCallExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._identifier_ != null) {
			if (filter.accept(this._identifier_)) {
				collection.add((T)this._identifier_);
			}
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._identifier_ == null) {
				throw new TreeInvariantException(this, ".getIdentifier() is null");
			}
		}
		if(this._identifier_ != null) {
			this._identifier_.setOptionalInvariant(is_optional_invariant);
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAFunctionCallExp(AFunctionCallExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AFunctionCallExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAFunctionCallExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFunctionCallExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAFunctionCallExp(this);
	}
	
	/**
	 * Applies this {@link AFunctionCallExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAFunctionCallExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFunctionCallExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAFunctionCallExp(this, question);
	}
	
}
