/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AFunctionPtrCallExp} represents the {@code function_ptr_call} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class AFunctionPtrCallExp extends PExp {
	private PExp _exp_;
	private NodeList<PExp> _args_ = new NodeList<PExp>(this,"getArgs()",true);
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link AFunctionPtrCallExp} node with no children.
	 */
	public AFunctionPtrCallExp() {
	}
	
	/**
	 * Creates a new {@code AFunctionPtrCallExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _exp_ the {@link PExp} node for the {@code Exp} child of this {@link AFunctionPtrCallExp} node
	 * @param _args_ the list of {@link PExp} nodes for the {@code Args} children of this {@link AFunctionPtrCallExp} node
	 */
	public AFunctionPtrCallExp(@SuppressWarnings("hiding") PExp _exp_,
		@SuppressWarnings("hiding") List<? extends PExp> _args_)
	{
		setExp(_exp_);
		setArgs(_args_);
	}
	
	/**
	 * Creates a new {@code AFunctionPtrCallExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _exp_ the {@link PExp} node for the {@code Exp} child of this {@link AFunctionPtrCallExp} node
	 * @param _args_ the list of {@link PExp} nodes for the {@code Args} children of this {@link AFunctionPtrCallExp} node
	 * @param _type_ the {@code Type} child of this {@link AFunctionPtrCallExp} node
	 */
	public AFunctionPtrCallExp(@SuppressWarnings("hiding") PExp _exp_,
		@SuppressWarnings("hiding") List<? extends PExp> _args_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setExp(_exp_);
		setArgs(_args_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link AFunctionPtrCallExp} node.
	 * @return a deep clone of this {@link AFunctionPtrCallExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFunctionPtrCallExp clone() {
		return new AFunctionPtrCallExp(
			cloneNode(_exp_),
			cloneList(_args_),
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AFunctionPtrCallExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AFunctionPtrCallExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AFunctionPtrCallExp clone(Map<Node,Node> oldToNewMap) {
		AFunctionPtrCallExp node = new AFunctionPtrCallExp(
			cloneNode(_exp_, oldToNewMap),
			cloneList(_args_, oldToNewMap),
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AFunctionPtrCallExp} node.
	 * @return a textual representation of this {@link AFunctionPtrCallExp} node
	 */
	public @Override String toString() {
		return "" + toString(this._exp_)
		 + toString(this._args_);
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.FUNCTION_PTR_CALL;
	}
	
	/**
	 * Returns the {@link PExp} node which is the {@code exp} child of this {@link AFunctionPtrCallExp} node.
	 * @return the {@link PExp} node which is the {@code exp} child of this {@link AFunctionPtrCallExp} node
	 */
	public PExp getExp() {
		return this._exp_;
	}
	
	/**
	 * Sets the {@code exp} child of this {@link AFunctionPtrCallExp} node.
	 * @param value the new {@code exp} child of this {@link AFunctionPtrCallExp} node
	 */
	public void setExp(PExp value) {
		if (this._exp_ != null) {
			this._exp_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getExp() is null");
		}
		this._exp_ = value;
	}
	
	/**
	 * Returns the possibly empty list of {@link PExp} nodes that are the {@code args} children of this {@link AFunctionPtrCallExp} node.
	 * @return the possibly empty list of {@link PExp} nodes that are the {@code args} children of this {@link AFunctionPtrCallExp} node
	 */
	public LinkedList<PExp> getArgs() {
		return this._args_;
	}
	
	/**
	 * Sets the {@code args} children of this {@link AFunctionPtrCallExp} node.
	 * @param value the new {@code args} children of this {@link AFunctionPtrCallExp} node
	 */
	public void setArgs(List<? extends PExp> value) {
		if (value == this._args_) {
			return;
		}
		this._args_.setAll(value);
	}
	
	/**
	 * Returns the {@code type} field of this {@link AFunctionPtrCallExp} node.
	 * @return the {@code type} field of this {@link AFunctionPtrCallExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link AFunctionPtrCallExp} node.
	 * @param value the new {@code type} field of this {@link AFunctionPtrCallExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AFunctionPtrCallExp} node.
	 * @param child the child node to be removed from this {@link AFunctionPtrCallExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AFunctionPtrCallExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._exp_ == child) {
			this._exp_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getExp() is null");
			}
			return;
		}
		if (this._args_.remove(child)) {
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AFunctionPtrCallExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AFunctionPtrCallExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AFunctionPtrCallExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._exp_ == oldChild) {
			setExp((PExp)newChild);
			return;
		}
		for (ListIterator<PExp> i = this._args_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((PExp)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AFunctionPtrCallExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._exp_ != null) {
			this._exp_.getDescendants(collection, filter);
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			e.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AFunctionPtrCallExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._exp_ != null) {
			if (filter.accept(this._exp_)) {
				collection.add((T)this._exp_);
			}
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._exp_ == null) {
				throw new TreeInvariantException(this, ".getExp() is null");
			}
		}
		if(this._exp_ != null) {
			this._exp_.setOptionalInvariant(is_optional_invariant);
		}
		for (PExp e : new ArrayList<PExp>(this._args_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAFunctionPtrCallExp(AFunctionPtrCallExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AFunctionPtrCallExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAFunctionPtrCallExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFunctionPtrCallExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAFunctionPtrCallExp(this);
	}
	
	/**
	 * Applies this {@link AFunctionPtrCallExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAFunctionPtrCallExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AFunctionPtrCallExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAFunctionPtrCallExp(this, question);
	}
	
}
