/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AIntConstExp} represents the {@code int_const} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class AIntConstExp extends PExp {
	private TIntegerConst _integer_const_;
	private Integer _value_;
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link AIntConstExp} node with no children.
	 */
	public AIntConstExp() {
		setValue(null);
	}
	
	/**
	 * Creates a new {@code AIntConstExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _integer_const_ the {@link TIntegerConst} node for the {@code IntegerConst} child of this {@link AIntConstExp} node
	 */
	public AIntConstExp(@SuppressWarnings("hiding") TIntegerConst _integer_const_) {
		setIntegerConst(_integer_const_);
		setValue(null);
	}
	
	/**
	 * Creates a new {@code AIntConstExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _integer_const_ the {@link TIntegerConst} node for the {@code IntegerConst} child of this {@link AIntConstExp} node
	 * @param _type_ the {@code Type} child of this {@link AIntConstExp} node
	 */
	public AIntConstExp(@SuppressWarnings("hiding") TIntegerConst _integer_const_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setIntegerConst(_integer_const_);
		setType(_type_);
		setValue(null);
	}
	
	/**
	 * Creates a new {@code AIntConstExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _integer_const_ the {@link TIntegerConst} node for the {@code IntegerConst} child of this {@link AIntConstExp} node
	 * @param _value_ the {@code Value} child of this {@link AIntConstExp} node
	 * @param _type_ the {@code Type} child of this {@link AIntConstExp} node
	 */
	public AIntConstExp(@SuppressWarnings("hiding") TIntegerConst _integer_const_,
		@SuppressWarnings("hiding") Integer _value_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setIntegerConst(_integer_const_);
		setValue(_value_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link AIntConstExp} node.
	 * @return a deep clone of this {@link AIntConstExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AIntConstExp clone() {
		return new AIntConstExp(
			cloneNode(_integer_const_),
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AIntConstExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AIntConstExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AIntConstExp clone(Map<Node,Node> oldToNewMap) {
		AIntConstExp node = new AIntConstExp(
			cloneNode(_integer_const_, oldToNewMap),
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AIntConstExp} node.
	 * @return a textual representation of this {@link AIntConstExp} node
	 */
	public @Override String toString() {
		return "" + toString(this._integer_const_);
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.INT_CONST;
	}
	
	/**
	 * Returns the {@link TIntegerConst} node which is the {@code integer_const} child of this {@link AIntConstExp} node.
	 * @return the {@link TIntegerConst} node which is the {@code integer_const} child of this {@link AIntConstExp} node
	 */
	public TIntegerConst getIntegerConst() {
		return this._integer_const_;
	}
	
	/**
	 * Sets the {@code integer_const} child of this {@link AIntConstExp} node.
	 * @param value the new {@code integer_const} child of this {@link AIntConstExp} node
	 */
	public void setIntegerConst(TIntegerConst value) {
		if (this._integer_const_ != null) {
			this._integer_const_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getIntegerConst() is null");
		}
		this._integer_const_ = value;
	}
	
	/**
	 * Returns the {@code value} field of this {@link AIntConstExp} node.
	 * @return the {@code value} field of this {@link AIntConstExp} node
	 */
	public Integer getValue() {
		return this._value_;
	}
	
	/**
	 * Sets the {@code value} field of this {@link AIntConstExp} node.
	 * @param value the new {@code value} field of this {@link AIntConstExp} node
	 */
	public void setValue(Integer value) {
		if (value == null) {
			value = getIntegerConst() != null ? Integer.valueOf(getIntegerConst().getText()) : null;
		}
		this._value_ = value;
	}
	
	/**
	 * Returns the {@code type} field of this {@link AIntConstExp} node.
	 * @return the {@code type} field of this {@link AIntConstExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link AIntConstExp} node.
	 * @param value the new {@code type} field of this {@link AIntConstExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AIntConstExp} node.
	 * @param child the child node to be removed from this {@link AIntConstExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AIntConstExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._integer_const_ == child) {
			this._integer_const_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getIntegerConst() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AIntConstExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AIntConstExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AIntConstExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._integer_const_ == oldChild) {
			setIntegerConst((TIntegerConst)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AIntConstExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._integer_const_ != null) {
			this._integer_const_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AIntConstExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._integer_const_ != null) {
			if (filter.accept(this._integer_const_)) {
				collection.add((T)this._integer_const_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._integer_const_ == null) {
				throw new TreeInvariantException(this, ".getIntegerConst() is null");
			}
		}
		if(this._integer_const_ != null) {
			this._integer_const_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAIntConstExp(AIntConstExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AIntConstExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAIntConstExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AIntConstExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAIntConstExp(this);
	}
	
	/**
	 * Applies this {@link AIntConstExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAIntConstExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AIntConstExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAIntConstExp(this, question);
	}
	
}
