/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code ALocalDecl} represents the {@code local} alternative of the {@code decl} production in the AST.
 */
@SuppressWarnings("nls")
public final class ALocalDecl extends PDecl {
	private TIdentifier _name_;
	private boolean _declared_;
	private int _index_;
	
	/**
	 * Creates a new {@link ALocalDecl} node with no children.
	 */
	public ALocalDecl() {
	}
	
	/**
	 * Creates a new {@code ALocalDecl} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _name_ the {@link TIdentifier} node for the {@code Name} child of this {@link ALocalDecl} node
	 */
	public ALocalDecl(@SuppressWarnings("hiding") TIdentifier _name_) {
		setName(_name_);
	}
	
	/**
	 * Creates a new {@code ALocalDecl} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _name_ the {@link TIdentifier} node for the {@code Name} child of this {@link ALocalDecl} node
	 * @param _declared_ the {@code Declared} child of this {@link ALocalDecl} node
	 * @param _index_ the {@code Index} child of this {@link ALocalDecl} node
	 */
	public ALocalDecl(@SuppressWarnings("hiding") TIdentifier _name_,
		@SuppressWarnings("hiding") boolean _declared_,
		@SuppressWarnings("hiding") int _index_)
	{
		setName(_name_);
		setDeclared(_declared_);
		setIndex(_index_);
	}
	
	/**
	 * Returns a deep clone of this {@link ALocalDecl} node.
	 * @return a deep clone of this {@link ALocalDecl} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ALocalDecl clone() {
		return new ALocalDecl(
			cloneNode(_name_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link ALocalDecl} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link ALocalDecl} node
	 */
	@Override @SuppressWarnings("unchecked")
	public ALocalDecl clone(Map<Node,Node> oldToNewMap) {
		ALocalDecl node = new ALocalDecl(
			cloneNode(_name_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link ALocalDecl} node.
	 * @return a textual representation of this {@link ALocalDecl} node
	 */
	public @Override String toString() {
		return "" + toString(this._name_);
	}
	
	/**
	 * Returns the {@link EDecl} corresponding to the
	 * type of this {@link PDecl} node.
	 * @return the {@link EDecl} for this node
	 */
	@Override public EDecl kindPDecl() {
		return EDecl.LOCAL;
	}
	
	/**
	 * Returns the {@link TIdentifier} node which is the {@code name} child of this {@link ALocalDecl} node.
	 * @return the {@link TIdentifier} node which is the {@code name} child of this {@link ALocalDecl} node
	 */
	public TIdentifier getName() {
		return this._name_;
	}
	
	/**
	 * Sets the {@code name} child of this {@link ALocalDecl} node.
	 * @param value the new {@code name} child of this {@link ALocalDecl} node
	 */
	public void setName(TIdentifier value) {
		if (this._name_ != null) {
			this._name_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getName() is null");
		}
		this._name_ = value;
	}
	
	/**
	 * Returns the {@code declared} field of this {@link ALocalDecl} node.
	 * @return the {@code declared} field of this {@link ALocalDecl} node
	 */
	public boolean getDeclared() {
		return this._declared_;
	}
	
	/**
	 * Sets the {@code declared} field of this {@link ALocalDecl} node.
	 * @param value the new {@code declared} field of this {@link ALocalDecl} node
	 */
	public void setDeclared(boolean value) {
		this._declared_ = value;
	}
	
	/**
	 * Returns the {@code index} field of this {@link ALocalDecl} node.
	 * @return the {@code index} field of this {@link ALocalDecl} node
	 */
	public int getIndex() {
		return this._index_;
	}
	
	/**
	 * Sets the {@code index} field of this {@link ALocalDecl} node.
	 * @param value the new {@code index} field of this {@link ALocalDecl} node
	 */
	public void setIndex(int value) {
		this._index_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link ALocalDecl} node.
	 * @param child the child node to be removed from this {@link ALocalDecl} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link ALocalDecl} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._name_ == child) {
			this._name_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getName() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link ALocalDecl} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link ALocalDecl} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link ALocalDecl} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._name_ == oldChild) {
			setName((TIdentifier)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link ALocalDecl} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._name_ != null) {
			this._name_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link ALocalDecl} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._name_ != null) {
			if (filter.accept(this._name_)) {
				collection.add((T)this._name_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._name_ == null) {
				throw new TreeInvariantException(this, ".getName() is null");
			}
		}
		if(this._name_ != null) {
			this._name_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseALocalDecl(ALocalDecl)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link ALocalDecl} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseALocalDecl(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ALocalDecl}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseALocalDecl(this);
	}
	
	/**
	 * Applies this {@link ALocalDecl} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseALocalDecl(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link ALocalDecl} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseALocalDecl(this, question);
	}
	
}
