/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AMallocExp} represents the {@code malloc} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class AMallocExp extends PExp implements ITarget {
	private int _malloc_index_;
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link AMallocExp} node with no children.
	 */
	public AMallocExp() {
	}
	
	/**
	 * Creates a new {@code AMallocExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _type_ the {@code Type} child of this {@link AMallocExp} node
	 */
	public AMallocExp(@SuppressWarnings("hiding") tip.types.Type _type_) {
		setType(_type_);
	}
	
	/**
	 * Creates a new {@code AMallocExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _malloc_index_ the {@code MallocIndex} child of this {@link AMallocExp} node
	 * @param _type_ the {@code Type} child of this {@link AMallocExp} node
	 */
	public AMallocExp(@SuppressWarnings("hiding") int _malloc_index_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setMallocIndex(_malloc_index_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link AMallocExp} node.
	 * @return a deep clone of this {@link AMallocExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AMallocExp clone() {
		return new AMallocExp(
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AMallocExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AMallocExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AMallocExp clone(Map<Node,Node> oldToNewMap) {
		AMallocExp node = new AMallocExp(
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AMallocExp} node.
	 * @return a textual representation of this {@link AMallocExp} node
	 */
	public @Override String toString() {
		return "";
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.MALLOC;
	}
	
	/**
	 * Returns the {@code malloc_index} field of this {@link AMallocExp} node.
	 * @return the {@code malloc_index} field of this {@link AMallocExp} node
	 */
	public int getMallocIndex() {
		return this._malloc_index_;
	}
	
	/**
	 * Sets the {@code malloc_index} field of this {@link AMallocExp} node.
	 * @param value the new {@code malloc_index} field of this {@link AMallocExp} node
	 */
	public void setMallocIndex(int value) {
		this._malloc_index_ = value;
	}
	
	/**
	 * Returns the {@code type} field of this {@link AMallocExp} node.
	 * @return the {@code type} field of this {@link AMallocExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link AMallocExp} node.
	 * @param value the new {@code type} field of this {@link AMallocExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AMallocExp} node.
	 * @param child the child node to be removed from this {@link AMallocExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AMallocExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AMallocExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AMallocExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AMallocExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AMallocExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
	}
	
	/**
	 * Adds all children of this {@link AMallocExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAMallocExp(AMallocExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AMallocExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAMallocExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AMallocExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAMallocExp(this);
	}
	
	/**
	 * Applies this {@link AMallocExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAMallocExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AMallocExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAMallocExp(this, question);
	}
	
}
