/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code APlusBinop} represents the {@code plus} alternative of the {@code binop} production in the AST.
 */
@SuppressWarnings("nls")
public final class APlusBinop extends PBinop {
	private TPlus _token_;
	
	/**
	 * Creates a new {@link APlusBinop} node with no children.
	 */
	public APlusBinop() {
	}
	
	/**
	 * Creates a new {@code APlusBinop} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TPlus} node for the {@code Token} child of this {@link APlusBinop} node
	 */
	public APlusBinop(@SuppressWarnings("hiding") TPlus _token_) {
		setToken(_token_);
	}
	
	/**
	 * Returns a deep clone of this {@link APlusBinop} node.
	 * @return a deep clone of this {@link APlusBinop} node
	 */
	@Override @SuppressWarnings("unchecked")
	public APlusBinop clone() {
		return new APlusBinop(
			cloneNode(_token_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link APlusBinop} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link APlusBinop} node
	 */
	@Override @SuppressWarnings("unchecked")
	public APlusBinop clone(Map<Node,Node> oldToNewMap) {
		APlusBinop node = new APlusBinop(
			cloneNode(_token_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link APlusBinop} node.
	 * @return a textual representation of this {@link APlusBinop} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_);
	}
	
	/**
	 * Returns the {@link EBinop} corresponding to the
	 * type of this {@link PBinop} node.
	 * @return the {@link EBinop} for this node
	 */
	@Override public EBinop kindPBinop() {
		return EBinop.PLUS;
	}
	
	/**
	 * Returns the {@link TPlus} node which is the {@code token} child of this {@link APlusBinop} node.
	 * @return the {@link TPlus} node which is the {@code token} child of this {@link APlusBinop} node
	 */
	public TPlus getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link APlusBinop} node.
	 * @param value the new {@code token} child of this {@link APlusBinop} node
	 */
	public void setToken(TPlus value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link APlusBinop} node.
	 * @param child the child node to be removed from this {@link APlusBinop} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link APlusBinop} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link APlusBinop} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link APlusBinop} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link APlusBinop} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TPlus)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link APlusBinop} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link APlusBinop} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAPlusBinop(APlusBinop)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link APlusBinop} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAPlusBinop(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link APlusBinop}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAPlusBinop(this);
	}
	
	/**
	 * Applies this {@link APlusBinop} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAPlusBinop(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link APlusBinop} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAPlusBinop(this, question);
	}
	
}
