/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code APointerExp} represents the {@code pointer} alternative of the {@code exp} production in the AST.
 */
@SuppressWarnings("nls")
public final class APointerExp extends PExp {
	private TAnd _token_;
	private TIdentifier _identifier_;
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link APointerExp} node with no children.
	 */
	public APointerExp() {
	}
	
	/**
	 * Creates a new {@code APointerExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TAnd} node for the {@code Token} child of this {@link APointerExp} node
	 * @param _identifier_ the {@link TIdentifier} node for the {@code Identifier} child of this {@link APointerExp} node
	 */
	public APointerExp(@SuppressWarnings("hiding") TAnd _token_,
		@SuppressWarnings("hiding") TIdentifier _identifier_)
	{
		setToken(_token_);
		setIdentifier(_identifier_);
	}
	
	/**
	 * Creates a new {@code APointerExp} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TAnd} node for the {@code Token} child of this {@link APointerExp} node
	 * @param _identifier_ the {@link TIdentifier} node for the {@code Identifier} child of this {@link APointerExp} node
	 * @param _type_ the {@code Type} child of this {@link APointerExp} node
	 */
	public APointerExp(@SuppressWarnings("hiding") TAnd _token_,
		@SuppressWarnings("hiding") TIdentifier _identifier_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setToken(_token_);
		setIdentifier(_identifier_);
		setType(_type_);
	}
	
	/**
	 * Returns a deep clone of this {@link APointerExp} node.
	 * @return a deep clone of this {@link APointerExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public APointerExp clone() {
		return new APointerExp(
			cloneNode(_token_),
			cloneNode(_identifier_),
			_type_
		);
	}
	
	/**
	 * Creates a deep clone of this {@link APointerExp} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link APointerExp} node
	 */
	@Override @SuppressWarnings("unchecked")
	public APointerExp clone(Map<Node,Node> oldToNewMap) {
		APointerExp node = new APointerExp(
			cloneNode(_token_, oldToNewMap),
			cloneNode(_identifier_, oldToNewMap),
			_type_
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link APointerExp} node.
	 * @return a textual representation of this {@link APointerExp} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_)
		 + toString(this._identifier_);
	}
	
	/**
	 * Returns the {@link EExp} corresponding to the
	 * type of this {@link PExp} node.
	 * @return the {@link EExp} for this node
	 */
	@Override public EExp kindPExp() {
		return EExp.POINTER;
	}
	
	/**
	 * Returns the {@link TAnd} node which is the {@code token} child of this {@link APointerExp} node.
	 * @return the {@link TAnd} node which is the {@code token} child of this {@link APointerExp} node
	 */
	public TAnd getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link APointerExp} node.
	 * @param value the new {@code token} child of this {@link APointerExp} node
	 */
	public void setToken(TAnd value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Returns the {@link TIdentifier} node which is the {@code identifier} child of this {@link APointerExp} node.
	 * @return the {@link TIdentifier} node which is the {@code identifier} child of this {@link APointerExp} node
	 */
	public TIdentifier getIdentifier() {
		return this._identifier_;
	}
	
	/**
	 * Sets the {@code identifier} child of this {@link APointerExp} node.
	 * @param value the new {@code identifier} child of this {@link APointerExp} node
	 */
	public void setIdentifier(TIdentifier value) {
		if (this._identifier_ != null) {
			this._identifier_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getIdentifier() is null");
		}
		this._identifier_ = value;
	}
	
	/**
	 * Returns the {@code type} field of this {@link APointerExp} node.
	 * @return the {@code type} field of this {@link APointerExp} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link APointerExp} node.
	 * @param value the new {@code type} field of this {@link APointerExp} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link APointerExp} node.
	 * @param child the child node to be removed from this {@link APointerExp} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link APointerExp} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		if (this._identifier_ == child) {
			this._identifier_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getIdentifier() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link APointerExp} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link APointerExp} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link APointerExp} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TAnd)newChild);
			return;
		}
		if (this._identifier_ == oldChild) {
			setIdentifier((TIdentifier)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link APointerExp} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
		if(this._identifier_ != null) {
			this._identifier_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link APointerExp} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
		if(this._identifier_ != null) {
			if (filter.accept(this._identifier_)) {
				collection.add((T)this._identifier_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			if (this._identifier_ == null) {
				throw new TreeInvariantException(this, ".getIdentifier() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._identifier_ != null) {
			this._identifier_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAPointerExp(APointerExp)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link APointerExp} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAPointerExp(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link APointerExp}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAPointerExp(this);
	}
	
	/**
	 * Applies this {@link APointerExp} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAPointerExp(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link APointerExp} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAPointerExp(this, question);
	}
	
}
