/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AProgram} represents the {@code } alternative of the {@code program} production in the AST.
 */
@SuppressWarnings("nls")
public final class AProgram extends PProgram {
	private NodeList<AFuncDecl> _functions_ = new NodeList<AFuncDecl>(this,"getFunctions()",true);
	private int[] _code_;
	private Map<String,AFuncDecl> _function_env_;
	
	/**
	 * Creates a new {@link AProgram} node with no children.
	 */
	public AProgram() {
		setFunctionEnv(null);
	}
	
	/**
	 * Creates a new {@code AProgram} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _functions_ the list of {@link AFuncDecl} nodes for the {@code Functions} children of this {@link AProgram} node
	 */
	public AProgram(@SuppressWarnings("hiding") List<? extends AFuncDecl> _functions_) {
		setFunctions(_functions_);
		setFunctionEnv(null);
	}
	
	/**
	 * Creates a new {@code AProgram} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _functions_ the list of {@link AFuncDecl} nodes for the {@code Functions} children of this {@link AProgram} node
	 * @param _code_ the {@code Code} child of this {@link AProgram} node
	 * @param _function_env_ the {@code FunctionEnv} child of this {@link AProgram} node
	 */
	public AProgram(@SuppressWarnings("hiding") List<? extends AFuncDecl> _functions_,
		@SuppressWarnings("hiding") int[] _code_,
		@SuppressWarnings("hiding") Map<String,AFuncDecl> _function_env_)
	{
		setFunctions(_functions_);
		setCode(_code_);
		setFunctionEnv(_function_env_);
	}
	
	/**
	 * Returns a deep clone of this {@link AProgram} node.
	 * @return a deep clone of this {@link AProgram} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AProgram clone() {
		return new AProgram(
			cloneList(_functions_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AProgram} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AProgram} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AProgram clone(Map<Node,Node> oldToNewMap) {
		AProgram node = new AProgram(
			cloneList(_functions_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AProgram} node.
	 * @return a textual representation of this {@link AProgram} node
	 */
	public @Override String toString() {
		return "" + toString(this._functions_);
	}
	
	/**
	 * Returns the possibly empty list of {@link AFuncDecl} nodes that are the {@code functions} children of this {@link AProgram} node.
	 * @return the possibly empty list of {@link AFuncDecl} nodes that are the {@code functions} children of this {@link AProgram} node
	 */
	public LinkedList<AFuncDecl> getFunctions() {
		return this._functions_;
	}
	
	/**
	 * Sets the {@code functions} children of this {@link AProgram} node.
	 * @param value the new {@code functions} children of this {@link AProgram} node
	 */
	public void setFunctions(List<? extends AFuncDecl> value) {
		if (value == this._functions_) {
			return;
		}
		this._functions_.setAll(value);
	}
	
	/**
	 * Returns the {@code code} field of this {@link AProgram} node.
	 * @return the {@code code} field of this {@link AProgram} node
	 */
	public int[] getCode() {
		return this._code_;
	}
	
	/**
	 * Sets the {@code code} field of this {@link AProgram} node.
	 * @param value the new {@code code} field of this {@link AProgram} node
	 */
	public void setCode(int[] value) {
		this._code_ = value;
	}
	
	/**
	 * Returns the {@code function_env} field of this {@link AProgram} node.
	 * @return the {@code function_env} field of this {@link AProgram} node
	 */
	public Map<String,AFuncDecl> getFunctionEnv() {
		return this._function_env_;
	}
	
	/**
	 * Sets the {@code function_env} field of this {@link AProgram} node.
	 * @param value the new {@code function_env} field of this {@link AProgram} node
	 */
	public void setFunctionEnv(Map<String,AFuncDecl> value) {
		if (value == null) {
			value = new TreeMap<String,AFuncDecl>();
		}
		this._function_env_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AProgram} node.
	 * @param child the child node to be removed from this {@link AProgram} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AProgram} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._functions_.remove(child)) {
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AProgram} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AProgram} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AProgram} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		for (ListIterator<AFuncDecl> i = this._functions_.listIterator() ; i.hasNext() ; ) {
			if (i.next() == oldChild) {
				if (newChild != null) {
					i.set((AFuncDecl)newChild);
					return;
				}
				i.remove();
				return;
			}
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AProgram} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		for (AFuncDecl e : new ArrayList<AFuncDecl>(this._functions_)) {
			e.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AProgram} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		for (AFuncDecl e : new ArrayList<AFuncDecl>(this._functions_)) {
			if (filter.accept(e)) {
				collection.add((T)e);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
		}
		for (AFuncDecl e : new ArrayList<AFuncDecl>(this._functions_)) {
			e.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAProgram(AProgram)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AProgram} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAProgram(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AProgram}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAProgram(this);
	}
	
	/**
	 * Applies this {@link AProgram} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAProgram(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AProgram} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAProgram(this, question);
	}
	
}
