/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AReturnStm} represents the {@code return} alternative of the {@code stm} production in the AST.
 */
@SuppressWarnings("nls")
public final class AReturnStm extends PStm {
	private TReturn _token_;
	private PExp _exp_;
	
	/**
	 * Creates a new {@link AReturnStm} node with no children.
	 */
	public AReturnStm() {
	}
	
	/**
	 * Creates a new {@code AReturnStm} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TReturn} node for the {@code Token} child of this {@link AReturnStm} node
	 * @param _exp_ the {@link PExp} node for the {@code Exp} child of this {@link AReturnStm} node
	 */
	public AReturnStm(@SuppressWarnings("hiding") TReturn _token_,
		@SuppressWarnings("hiding") PExp _exp_)
	{
		setToken(_token_);
		setExp(_exp_);
	}
	
	/**
	 * Returns a deep clone of this {@link AReturnStm} node.
	 * @return a deep clone of this {@link AReturnStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AReturnStm clone() {
		return new AReturnStm(
			cloneNode(_token_),
			cloneNode(_exp_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AReturnStm} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AReturnStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AReturnStm clone(Map<Node,Node> oldToNewMap) {
		AReturnStm node = new AReturnStm(
			cloneNode(_token_, oldToNewMap),
			cloneNode(_exp_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AReturnStm} node.
	 * @return a textual representation of this {@link AReturnStm} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_)
		 + toString(this._exp_);
	}
	
	/**
	 * Returns the {@link EStm} corresponding to the
	 * type of this {@link PStm} node.
	 * @return the {@link EStm} for this node
	 */
	@Override public EStm kindPStm() {
		return EStm.RETURN;
	}
	
	/**
	 * Returns the {@link TReturn} node which is the {@code token} child of this {@link AReturnStm} node.
	 * @return the {@link TReturn} node which is the {@code token} child of this {@link AReturnStm} node
	 */
	public TReturn getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link AReturnStm} node.
	 * @param value the new {@code token} child of this {@link AReturnStm} node
	 */
	public void setToken(TReturn value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Returns the {@link PExp} node which is the {@code exp} child of this {@link AReturnStm} node.
	 * @return the {@link PExp} node which is the {@code exp} child of this {@link AReturnStm} node
	 */
	public PExp getExp() {
		return this._exp_;
	}
	
	/**
	 * Sets the {@code exp} child of this {@link AReturnStm} node.
	 * @param value the new {@code exp} child of this {@link AReturnStm} node
	 */
	public void setExp(PExp value) {
		if (this._exp_ != null) {
			this._exp_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getExp() is null");
		}
		this._exp_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AReturnStm} node.
	 * @param child the child node to be removed from this {@link AReturnStm} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AReturnStm} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		if (this._exp_ == child) {
			this._exp_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getExp() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AReturnStm} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AReturnStm} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AReturnStm} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TReturn)newChild);
			return;
		}
		if (this._exp_ == oldChild) {
			setExp((PExp)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AReturnStm} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
		if(this._exp_ != null) {
			this._exp_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AReturnStm} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
		if(this._exp_ != null) {
			if (filter.accept(this._exp_)) {
				collection.add((T)this._exp_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			if (this._exp_ == null) {
				throw new TreeInvariantException(this, ".getExp() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._exp_ != null) {
			this._exp_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAReturnStm(AReturnStm)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AReturnStm} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAReturnStm(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AReturnStm}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAReturnStm(this);
	}
	
	/**
	 * Applies this {@link AReturnStm} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAReturnStm(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AReturnStm} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAReturnStm(this, question);
	}
	
}
