/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code AWhileStm} represents the {@code while} alternative of the {@code stm} production in the AST.
 */
@SuppressWarnings("nls")
public final class AWhileStm extends PStm {
	private TLPar _token_;
	private PExp _condition_;
	private PStm _body_;
	
	/**
	 * Creates a new {@link AWhileStm} node with no children.
	 */
	public AWhileStm() {
	}
	
	/**
	 * Creates a new {@code AWhileStm} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param _token_ the {@link TLPar} node for the {@code Token} child of this {@link AWhileStm} node
	 * @param _condition_ the {@link PExp} node for the {@code Condition} child of this {@link AWhileStm} node
	 * @param _body_ the {@link PStm} node for the {@code Body} child of this {@link AWhileStm} node
	 */
	public AWhileStm(@SuppressWarnings("hiding") TLPar _token_,
		@SuppressWarnings("hiding") PExp _condition_,
		@SuppressWarnings("hiding") PStm _body_)
	{
		setToken(_token_);
		setCondition(_condition_);
		setBody(_body_);
	}
	
	/**
	 * Returns a deep clone of this {@link AWhileStm} node.
	 * @return a deep clone of this {@link AWhileStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AWhileStm clone() {
		return new AWhileStm(
			cloneNode(_token_),
			cloneNode(_condition_),
			cloneNode(_body_)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link AWhileStm} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link AWhileStm} node
	 */
	@Override @SuppressWarnings("unchecked")
	public AWhileStm clone(Map<Node,Node> oldToNewMap) {
		AWhileStm node = new AWhileStm(
			cloneNode(_token_, oldToNewMap),
			cloneNode(_condition_, oldToNewMap),
			cloneNode(_body_, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link AWhileStm} node.
	 * @return a textual representation of this {@link AWhileStm} node
	 */
	public @Override String toString() {
		return "" + toString(this._token_)
		 + toString(this._condition_)
		 + toString(this._body_);
	}
	
	/**
	 * Returns the {@link EStm} corresponding to the
	 * type of this {@link PStm} node.
	 * @return the {@link EStm} for this node
	 */
	@Override public EStm kindPStm() {
		return EStm.WHILE;
	}
	
	/**
	 * Returns the {@link TLPar} node which is the {@code token} child of this {@link AWhileStm} node.
	 * @return the {@link TLPar} node which is the {@code token} child of this {@link AWhileStm} node
	 */
	public TLPar getToken() {
		return this._token_;
	}
	
	/**
	 * Sets the {@code token} child of this {@link AWhileStm} node.
	 * @param value the new {@code token} child of this {@link AWhileStm} node
	 */
	public void setToken(TLPar value) {
		if (this._token_ != null) {
			this._token_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getToken() is null");
		}
		this._token_ = value;
	}
	
	/**
	 * Returns the {@link PExp} node which is the {@code condition} child of this {@link AWhileStm} node.
	 * @return the {@link PExp} node which is the {@code condition} child of this {@link AWhileStm} node
	 */
	public PExp getCondition() {
		return this._condition_;
	}
	
	/**
	 * Sets the {@code condition} child of this {@link AWhileStm} node.
	 * @param value the new {@code condition} child of this {@link AWhileStm} node
	 */
	public void setCondition(PExp value) {
		if (this._condition_ != null) {
			this._condition_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getCondition() is null");
		}
		this._condition_ = value;
	}
	
	/**
	 * Returns the {@link PStm} node which is the {@code body} child of this {@link AWhileStm} node.
	 * @return the {@link PStm} node which is the {@code body} child of this {@link AWhileStm} node
	 */
	public PStm getBody() {
		return this._body_;
	}
	
	/**
	 * Sets the {@code body} child of this {@link AWhileStm} node.
	 * @param value the new {@code body} child of this {@link AWhileStm} node
	 */
	public void setBody(PStm value) {
		if (this._body_ != null) {
			this._body_.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getBody() is null");
		}
		this._body_ = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link AWhileStm} node.
	 * @param child the child node to be removed from this {@link AWhileStm} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link AWhileStm} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this._token_ == child) {
			this._token_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			return;
		}
		if (this._condition_ == child) {
			this._condition_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getCondition() is null");
			}
			return;
		}
		if (this._body_ == child) {
			this._body_ = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getBody() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link AWhileStm} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link AWhileStm} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link AWhileStm} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this._token_ == oldChild) {
			setToken((TLPar)newChild);
			return;
		}
		if (this._condition_ == oldChild) {
			setCondition((PExp)newChild);
			return;
		}
		if (this._body_ == oldChild) {
			setBody((PStm)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link AWhileStm} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this._token_ != null) {
			this._token_.getDescendants(collection, filter);
		}
		if(this._condition_ != null) {
			this._condition_.getDescendants(collection, filter);
		}
		if(this._body_ != null) {
			this._body_.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link AWhileStm} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this._token_ != null) {
			if (filter.accept(this._token_)) {
				collection.add((T)this._token_);
			}
		}
		if(this._condition_ != null) {
			if (filter.accept(this._condition_)) {
				collection.add((T)this._condition_);
			}
		}
		if(this._body_ != null) {
			if (filter.accept(this._body_)) {
				collection.add((T)this._body_);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this._token_ == null) {
				throw new TreeInvariantException(this, ".getToken() is null");
			}
			if (this._condition_ == null) {
				throw new TreeInvariantException(this, ".getCondition() is null");
			}
			if (this._body_ == null) {
				throw new TreeInvariantException(this, ".getBody() is null");
			}
		}
		if(this._token_ != null) {
			this._token_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._condition_ != null) {
			this._condition_.setOptionalInvariant(is_optional_invariant);
		}
		if(this._body_ != null) {
			this._body_.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseAWhileStm(AWhileStm)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link AWhileStm} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseAWhileStm(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AWhileStm}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseAWhileStm(this);
	}
	
	/**
	 * Applies this {@link AWhileStm} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseAWhileStm(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link AWhileStm} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseAWhileStm(this, question);
	}
	
}
