package tip.node;

import tip.analysis.*;
import java.util.*;

class BackwardStepRelation extends QuestionAnswerAdapter<RoutingSymbol,List<Node>> {
	@Override
	public List<Node> defaultNode(Node node, RoutingSymbol symbol) {
		switch (symbol) {
		case _ROOT_:
			if (node.parent() == null) {
				return Collections.singletonList(node);
			}
			break;
		case _LEAF_:
			if (node.getChildren(Node.class).isEmpty()) {
				return Collections.singletonList(node);
			}
			break;
		case _PARENT_:
			return node.getChildren(Node.class);
		default:
		}
		return Collections.emptyList();
	}
	@Override
	public List<Node> defaultToken(Token node, RoutingSymbol symbol) {
		switch (symbol) {
		case _LEAF_:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	@Override
	public List<Node> caseTWhiteSpace(TWhiteSpace node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TWHITESPACE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTCommentSingle(TCommentSingle node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TCOMMENTSINGLE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTCommentBlock(TCommentBlock node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TCOMMENTBLOCK:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTVar(TVar node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TVAR:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTInput(TInput node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TINPUT:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTOutput(TOutput node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TOUTPUT:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTIf(TIf node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TIF:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTElse(TElse node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TELSE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTWhile(TWhile node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TWHILE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTReturn(TReturn node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TRETURN:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTMalloc(TMalloc node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TMALLOC:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTNull(TNull node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TNULL:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTLPar(TLPar node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TLPAR:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTRPar(TRPar node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TRPAR:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTLBrace(TLBrace node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TLBRACE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTRBrace(TRBrace node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TRBRACE:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTSemicolon(TSemicolon node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TSEMICOLON:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTComma(TComma node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TCOMMA:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTAssign(TAssign node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TASSIGN:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTPlus(TPlus node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TPLUS:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTMinus(TMinus node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TMINUS:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTStar(TStar node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TSTAR:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTDiv(TDiv node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TDIV:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTAnd(TAnd node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TAND:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTGt(TGt node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TGT:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTEq(TEq node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TEQ:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTIntegerConst(TIntegerConst node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TINTEGERCONST:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> caseTIdentifier(TIdentifier node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_TIDENTIFIER:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultToken(node, symbol);
	}
	
	@Override
	public List<Node> defaultPProgram(PProgram node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PPROGRAM:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPDecl(PDecl node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PDECL:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPBody(PBody node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PBODY:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPBlock(PBlock node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PBLOCK:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPBinop(PBinop node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PBINOP:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPExp(PExp node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PEXP:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> defaultPStm(PStm node, RoutingSymbol symbol) {
		switch (symbol) {
		case _TYPE_PSTM:
			return Collections.<Node>singletonList(node);
		default:
		}
		return defaultNode(node, symbol);
	}
	
	@Override
	public List<Node> caseAPointerExp(APointerExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_APOINTEREXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TAnd child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_IDENTIFIER:
			TIdentifier child_PARENT_IDENTIFIER = node.getIdentifier();
			if (child_PARENT_IDENTIFIER != null) {
				return Collections.<Node>singletonList(child_PARENT_IDENTIFIER);
			}
			return Collections.emptyList();
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseADerefExp(ADerefExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ADEREFEXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TStar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_EXP:
			PExp child_PARENT_EXP = node.getExp();
			if (child_PARENT_EXP != null) {
				return Collections.<Node>singletonList(child_PARENT_EXP);
			}
			return Collections.emptyList();
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAEqBinop(AEqBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AEQBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TEq child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseADeclStm(ADeclStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ADECLSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TVar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_DECL:
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAIfThenElseStm(AIfThenElseStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AIFTHENELSESTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TLPar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_CONDITION:
			PExp child_PARENT_CONDITION = node.getCondition();
			if (child_PARENT_CONDITION != null) {
				return Collections.<Node>singletonList(child_PARENT_CONDITION);
			}
			return Collections.emptyList();
		case _PARENT_THENBODY:
			PStm child_PARENT_THENBODY = node.getThenBody();
			if (child_PARENT_THENBODY != null) {
				return Collections.<Node>singletonList(child_PARENT_THENBODY);
			}
			return Collections.emptyList();
		case _PARENT_ELSEBODY:
			PStm child_PARENT_ELSEBODY = node.getElseBody();
			if (child_PARENT_ELSEBODY != null) {
				return Collections.<Node>singletonList(child_PARENT_ELSEBODY);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAWhileStm(AWhileStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AWHILESTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TLPar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_CONDITION:
			PExp child_PARENT_CONDITION = node.getCondition();
			if (child_PARENT_CONDITION != null) {
				return Collections.<Node>singletonList(child_PARENT_CONDITION);
			}
			return Collections.emptyList();
		case _PARENT_BODY:
			PStm child_PARENT_BODY = node.getBody();
			if (child_PARENT_BODY != null) {
				return Collections.<Node>singletonList(child_PARENT_BODY);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAOutputStm(AOutputStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AOUTPUTSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TOutput child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_EXP:
			PExp child_PARENT_EXP = node.getExp();
			if (child_PARENT_EXP != null) {
				return Collections.<Node>singletonList(child_PARENT_EXP);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAFunctionPtrCallExp(AFunctionPtrCallExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AFUNCTIONPTRCALLEXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_EXP:
			PExp child_PARENT_EXP = node.getExp();
			if (child_PARENT_EXP != null) {
				return Collections.<Node>singletonList(child_PARENT_EXP);
			}
			return Collections.emptyList();
		case _PARENT_ARGS:
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAAssignPtrStm(AAssignPtrStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AASSIGNPTRSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TAssign child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_LEFT:
			PExp child_PARENT_LEFT = node.getLeft();
			if (child_PARENT_LEFT != null) {
				return Collections.<Node>singletonList(child_PARENT_LEFT);
			}
			return Collections.emptyList();
		case _PARENT_RIGHT:
			PExp child_PARENT_RIGHT = node.getRight();
			if (child_PARENT_RIGHT != null) {
				return Collections.<Node>singletonList(child_PARENT_RIGHT);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseATimesBinop(ATimesBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ATIMESBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TStar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseAMallocExp(AMallocExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AMALLOCEXP:
			return Collections.<Node>singletonList(node);
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAGtBinop(AGtBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AGTBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TGt child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseABinopExp(ABinopExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ABINOPEXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_LEFT:
			PExp child_PARENT_LEFT = node.getLeft();
			if (child_PARENT_LEFT != null) {
				return Collections.<Node>singletonList(child_PARENT_LEFT);
			}
			return Collections.emptyList();
		case _PARENT_BINOP:
			PBinop child_PARENT_BINOP = node.getBinop();
			if (child_PARENT_BINOP != null) {
				return Collections.<Node>singletonList(child_PARENT_BINOP);
			}
			return Collections.emptyList();
		case _PARENT_RIGHT:
			PExp child_PARENT_RIGHT = node.getRight();
			if (child_PARENT_RIGHT != null) {
				return Collections.<Node>singletonList(child_PARENT_RIGHT);
			}
			return Collections.emptyList();
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAIfThenStm(AIfThenStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AIFTHENSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TLPar child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_CONDITION:
			PExp child_PARENT_CONDITION = node.getCondition();
			if (child_PARENT_CONDITION != null) {
				return Collections.<Node>singletonList(child_PARENT_CONDITION);
			}
			return Collections.emptyList();
		case _PARENT_BODY:
			PStm child_PARENT_BODY = node.getBody();
			if (child_PARENT_BODY != null) {
				return Collections.<Node>singletonList(child_PARENT_BODY);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAAssignVarStm(AAssignVarStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AASSIGNVARSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TAssign child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_IDENTIFIER:
			TIdentifier child_PARENT_IDENTIFIER = node.getIdentifier();
			if (child_PARENT_IDENTIFIER != null) {
				return Collections.<Node>singletonList(child_PARENT_IDENTIFIER);
			}
			return Collections.emptyList();
		case _PARENT_EXP:
			PExp child_PARENT_EXP = node.getExp();
			if (child_PARENT_EXP != null) {
				return Collections.<Node>singletonList(child_PARENT_EXP);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseABlock(ABlock node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ABLOCK:
			return Collections.<Node>singletonList(node);
		case _PARENT_STATEMENTS:
		case _CHILD_BLOCK:
			parent = node.parent();
			if (parent instanceof ABlockStm) {
				if (((ABlockStm)parent).getBlock() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABody) {
				if (((ABody)parent).getBlock() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBlock(node, symbol);
	}
	
	@Override
	public List<Node> caseAFunctionCallExp(AFunctionCallExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AFUNCTIONCALLEXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_IDENTIFIER:
			TIdentifier child_PARENT_IDENTIFIER = node.getIdentifier();
			if (child_PARENT_IDENTIFIER != null) {
				return Collections.<Node>singletonList(child_PARENT_IDENTIFIER);
			}
			return Collections.emptyList();
		case _PARENT_ARGS:
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAIntConstExp(AIntConstExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AINTCONSTEXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_INTEGERCONST:
			TIntegerConst child_PARENT_INTEGERCONST = node.getIntegerConst();
			if (child_PARENT_INTEGERCONST != null) {
				return Collections.<Node>singletonList(child_PARENT_INTEGERCONST);
			}
			return Collections.emptyList();
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseABlockStm(ABlockStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ABLOCKSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TLBrace child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_BLOCK:
			ABlock child_PARENT_BLOCK = node.getBlock();
			if (child_PARENT_BLOCK != null) {
				return Collections.<Node>singletonList(child_PARENT_BLOCK);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAMinusBinop(AMinusBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AMINUSBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TMinus child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseADivideBinop(ADivideBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ADIVIDEBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TDiv child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseAVarExp(AVarExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AVAREXP:
			return Collections.<Node>singletonList(node);
		case _PARENT_IDENTIFIER:
			TIdentifier child_PARENT_IDENTIFIER = node.getIdentifier();
			if (child_PARENT_IDENTIFIER != null) {
				return Collections.<Node>singletonList(child_PARENT_IDENTIFIER);
			}
			return Collections.emptyList();
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAReturnStm(AReturnStm node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ARETURNSTM:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TReturn child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _PARENT_EXP:
			PExp child_PARENT_EXP = node.getExp();
			if (child_PARENT_EXP != null) {
				return Collections.<Node>singletonList(child_PARENT_EXP);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_STATEMENTS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_THENBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getThenBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ELSEBODY:
			parent = node.parent();
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getElseBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPStm(node, symbol);
	}
	
	@Override
	public List<Node> caseAInputExp(AInputExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AINPUTEXP:
			return Collections.<Node>singletonList(node);
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAFuncDecl(AFuncDecl node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_AFUNCDECL:
			return Collections.<Node>singletonList(node);
		case _PARENT_NAME:
			TIdentifier child_PARENT_NAME = node.getName();
			if (child_PARENT_NAME != null) {
				return Collections.<Node>singletonList(child_PARENT_NAME);
			}
			return Collections.emptyList();
		case _PARENT_FORMALS:
		case _PARENT_BODY:
			ABody child_PARENT_BODY = node.getBody();
			if (child_PARENT_BODY != null) {
				return Collections.<Node>singletonList(child_PARENT_BODY);
			}
			return Collections.emptyList();
		case _CHILD_FUNCTIONS:
			parent = node.parent();
			return Collections.emptyList();
		default:
		}
		return defaultPDecl(node, symbol);
	}
	
	@Override
	public List<Node> caseANullExp(ANullExp node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ANULLEXP:
			return Collections.<Node>singletonList(node);
		case _CHILD_EXP:
			parent = node.parent();
			if (parent instanceof ADerefExp) {
				if (((ADerefExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AAssignVarStm) {
				if (((AAssignVarStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AFunctionPtrCallExp) {
				if (((AFunctionPtrCallExp)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AOutputStm) {
				if (((AOutputStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AReturnStm) {
				if (((AReturnStm)parent).getExp() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_CONDITION:
			parent = node.parent();
			if (parent instanceof AWhileStm) {
				if (((AWhileStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenStm) {
				if (((AIfThenStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof AIfThenElseStm) {
				if (((AIfThenElseStm)parent).getCondition() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_ARGS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_LEFT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getLeft() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		case _CHILD_RIGHT:
			parent = node.parent();
			if (parent instanceof AAssignPtrStm) {
				if (((AAssignPtrStm)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getRight() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPExp(node, symbol);
	}
	
	@Override
	public List<Node> caseAPlusBinop(APlusBinop node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_APLUSBINOP:
			return Collections.<Node>singletonList(node);
		case _PARENT_TOKEN:
			TPlus child_PARENT_TOKEN = node.getToken();
			if (child_PARENT_TOKEN != null) {
				return Collections.<Node>singletonList(child_PARENT_TOKEN);
			}
			return Collections.emptyList();
		case _CHILD_BINOP:
			parent = node.parent();
			if (parent instanceof ABinopExp) {
				if (((ABinopExp)parent).getBinop() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBinop(node, symbol);
	}
	
	@Override
	public List<Node> caseABody(ABody node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ABODY:
			return Collections.<Node>singletonList(node);
		case _PARENT_BLOCK:
			ABlock child_PARENT_BLOCK = node.getBlock();
			if (child_PARENT_BLOCK != null) {
				return Collections.<Node>singletonList(child_PARENT_BLOCK);
			}
			return Collections.emptyList();
		case _CHILD_BODY:
			parent = node.parent();
			if (parent instanceof AFuncDecl) {
				if (((AFuncDecl)parent).getBody() == node) {
					return Collections.singletonList(parent);
				}
			}
			return Collections.emptyList();
		default:
		}
		return defaultPBody(node, symbol);
	}
	
	@Override
	public List<Node> caseAProgram(AProgram node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_APROGRAM:
			return Collections.<Node>singletonList(node);
		case _PARENT_FUNCTIONS:
		default:
		}
		return defaultPProgram(node, symbol);
	}
	
	@Override
	public List<Node> caseALocalDecl(ALocalDecl node, RoutingSymbol symbol) {
		Node parent;
		switch (symbol) {
		case _TYPE_ALOCALDECL:
			return Collections.<Node>singletonList(node);
		case _PARENT_NAME:
			TIdentifier child_PARENT_NAME = node.getName();
			if (child_PARENT_NAME != null) {
				return Collections.<Node>singletonList(child_PARENT_NAME);
			}
			return Collections.emptyList();
		case _CHILD_FORMALS:
			parent = node.parent();
			return Collections.emptyList();
		case _CHILD_DECL:
			parent = node.parent();
			return Collections.emptyList();
		default:
		}
		return defaultPDecl(node, symbol);
	}
	
}
