/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * The {@code EOF} token represents the end-of-file marker from an input-file.
 */

@SuppressWarnings("nls")
public final class EOF extends Token {
	
	/**
	 * Creates a new {@link EOF} token with no line and position information.
	 */
	public EOF() {
		super.setText("");
	}
	
	/**
	 * Creates a new {@link EOF} token with the given line and position information.
	 * @param line the line number information for this {@link EOF} token
	 * @param pos the line position information for this {@link EOF} token
	 */
	public EOF(int line, int pos) {
		super.setText("");
		setLine(line);
		setPos(pos);
	}
	
	/**
	 * Creates a new {@link EOF} token that is an alias of the given token.
	 * @param token the original token for this {@link EOF} token
	 */
	public EOF(Token token) {
		super(token);
		super.setText("");
		setLine(token.getLine());
		setPos(token.getPos());
	}
	
	/**
	 * Creates a clone of this {@link EOF} token.
	 * @return a clone of this {@link EOF} token
	 */
	public @Override EOF clone() {
		return new EOF(getToken());
	}
	
	/**
	 * Creates a deep clone of this {@link EOF} token while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a clone of this {@link EOF} token
	 */
	public @Override EOF clone(Map<Node,Node> oldToNewMap) {
		EOF token = new EOF(getToken());
		oldToNewMap.put(this, token);
		return token;
	}
	
	/**
	 * Returns the {@link TokenEnum} corresponding to the
	 * type of this {@link Token} node.
	 * @return the {@link TokenEnum} for this node
	 */
	@Override public TokenEnum kindToken() {
		return TokenEnum._EOF_;
	}
	
	/**
	 * Implements the {@link Token#setText(String)} method. Since EOF represents
	 * fixed token, this method throws a {@link RuntimeException}.
	 * @param text the new text of this token
	 */
	public @Override void setText(@SuppressWarnings("unused") String text) {
		throw new RuntimeException("Cannot change EOF text.");
	}
	
	/**
	 * Calls the {@link Analysis#caseEOF(EOF)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link EOF} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseEOF(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link EOF}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseEOF(this);
	}
	
	/**
	 * Applies this {@link EOF} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseEOF(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link EOF} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseEOF(this, question);
	}
	
}
