/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

/**
 * {@code GuardedSubTypeFilter} implements the {@link NodeFilter} interface by 
 * accepting all nodes that are subtypes of the first class and
 * guarding on all nodes that are subtypes of the second class  given in the constructor.
 *
 * @param <T> the supertype for which the {@code GuardedSubTypeFilter} can accept nodes.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class GuardedSubTypeFilter<T extends NodeInterface> implements NodeFilter<T> {
	// the class used for filtering
	protected final Class<T> classT;
	// the class used for guarding
	protected final Class<? extends NodeInterface> guardClass;
	
	/**
	 * Creates a {@code SubTypeFilter} using subtype relation of {@code classT} 
	 * as filtering criterion and subtype relation of {@code guardClass} as
	 * guarding criterion.
	 * @param classT the class used for filtering
	 * @param guardClass the class used for guarding
	 */
	public GuardedSubTypeFilter(Class<T> classT, Class<? extends NodeInterface> guardClass) {
		this.classT = classT;
		this.guardClass = guardClass;
	}
	
	/**
	 * Returns {@code true} if {@code node} is a subtype of the class given in
	 * the constructor.
	 * @param node the node in question
	 * @return {@code true} if {@code node} is a subtype of the class given in
	 * the constructor
	 */
	public boolean accept(Node node) {
		return classT.isInstance(node);
	}
	
	/**
	 * Returns {@code true} if {@code node} guards further processesing.
	 * @param node the node in question
	 * @return {@code true} if {@code node} guards further processesing.
	 */
	public boolean guard(Node node) {
		return guardClass.isInstance(node);
	}
}
