/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

@SuppressWarnings("nls")
public interface NodeInterface {
	public Node clone();
	public Node clone(Map<Node,Node> oldToNewMap);
	/**
	 * Returns the parent node of this node.
	 * @return the parent node of this node
	 */
	public Node parent();
	
	/**
	 * Replaces this node by {@code node} in the AST. If this node has no parent
	 * node, this results in a {@link NullPointerException}.
	 * The replacing {@code node} is removed from its previous parent.
	 * @param node the node replacing this node in the AST
	 */
	public void replaceBy(Node node);
	
	/**
	 * Returns the nearest ancestor of this node (including itself)
	 * which is accepted by the {@link NodeFilter} {@code filter}.
	 * Traversal is stopped if the node is guarded by
	 * the {@link NodeFilter} {@code filter}.
	 * @param filter the {@link NodeFilter} used
	 * @return the nearest ancestor of this node
	 */
	public <T extends NodeInterface> T getAncestor(NodeFilter<T> filter);
	
	/**
	 * Returns the nearest ancestor of this node (including itself)
	 * which is a subclass of {@code classType}.
	 * @param classType the superclass used
	 * @return the nearest ancestor of this node
	 */
	public <T extends NodeInterface> T getAncestor(Class<T> classType);
	
	/**
	 * Returns the nearest ancestor of this node (including itself)
	 * which is a subclass of {@code classType}. Traversal is stopped
	 * if a subclass of {@code guardClass} is found.
	 * @param classType the superclass used for filtering
	 * @param guardClass the superclass used for guarding
	 * @return the nearest ancestor of this node
	 */
	public <T extends NodeInterface> T getAncestor(Class<T> classType, Class<? extends NodeInterface> guardClass);
	
	/**
	 * Adds all descendants of this {@link NodeInterface} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	public abstract <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter);
	
	/**
	 * Returns the collection of descendants to this node (including the node
	 * itself) which are accepted by the {@link NodeFilter} {@code filter}.
	 * Descandants of nodes which are guarded by the {@link NodeFilter} {@code filter}
	 * are not included.
	 * @param filter the {@link NodeFilter} used
	 * @return a collection of the accepted descendants
	 */
	public <T extends NodeInterface> Collection<T> getDescendants(NodeFilter<T> filter);
	
	/**
	 * Returns the collection of descendants to this node (including itself)
	 * which are subtypes of {@code classType}.
	 * @param classType the supertype for all collected descendants
	 * @return a collection of the accepted nodes
	 */
	public <T extends NodeInterface> Collection<T> getDescendants(Class<T> classType);
	
	/**
	 * Returns the collection of descendants to this node (including itself)
	 * which are subtypes of {@code classType}. Descendants of subtypes of
	 * {@code guardClass} are not included.
	 * @param classType the supertype for all collected descendants
	 * @return a collection of the accepted nodes
	 */
	public <T extends NodeInterface> Collection<T> getDescendants(Class<T> classType, Class<? extends NodeInterface> guardClass);
	
	/**
	 * Adds all children of this {@link NodeInterface} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	public abstract <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter);
	
	/**
	 * Returns the collection of children to this node which are accepted by the
	 * {@link NodeFilter} {@code filter}.
	 * @param filter the {@link NodeFilter} used
	 * @return a collection of the accepted children
	 */
	public <T extends NodeInterface> List<T> getChildren(NodeFilter<T> filter);
	
	/**
	 * Returns the collection of children to this node which are subtypes of
	 * {@code classType}.
	 * @param classType the supertype for all collected children
	 * @return a collection of the accepted nodes
	 */
	public <T extends NodeInterface> List<T> getChildren(Class<T> classType);
	
	/**
	 * Applies the {@link Analysis} visitor to this node.
	 * @param caller the {@link Analysis} to which this node is applied
	 */
	public abstract void apply(Analysis caller);
	
	/**
	 * Returns the answer for {@code caller} by applying this node to the
	 * {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	public abstract <A> A apply(Answer<A> caller);
	
	/**
	 * Applies this node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	public abstract <Q> void apply(Question<Q> caller, Q question);
	
	/**
	 * Returns the answer for {@code answer} by applying this node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code answer}
	 * @return the answer as returned from {@code answer}
	 */
	public abstract <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question);
	
	public boolean isOptionalInvariant();
	
	public void setOptionalInvariant(boolean value);
	
	public void checkOptionalInvariant();
	
}
