/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * The {@code Start} node is the topmost node in the AST. It holds the 
 * {@link PProgram} node which is the initial production of the grammar.
 */
@SuppressWarnings("nls")
public final class Start extends Node {
	private AProgram program;
	private EOF eof;
	
	/**
	 * Creates a new {@link Start} node with no children.
	 */
	public Start() {
	}
	
	/**
	 * Creates a new {@code Start} node with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param program the {@link AProgram} node for the {@code Program} child of this {@link Start} node
	 * @param eof the {@link EOF} node for the {@code EOF} child of this {@link Start} node
	 */
	public Start(@SuppressWarnings("hiding") AProgram program,
		@SuppressWarnings("hiding") EOF eof)
	{
		setProgram(program);
		setEOF(eof);
	}
	
	/**
	 * Returns a deep clone of this {@link Start} node.
	 * @return a deep clone of this {@link Start} node
	 */
	@Override @SuppressWarnings("unchecked")
	public Start clone() {
		return new Start(
			cloneNode(program),
			cloneNode(eof)
		);
	}
	
	/**
	 * Creates a deep clone of this {@link Start} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link Start} node
	 */
	@Override @SuppressWarnings("unchecked")
	public Start clone(Map<Node,Node> oldToNewMap) {
		Start node = new Start(
			cloneNode(program, oldToNewMap),
			cloneNode(eof, oldToNewMap)
		);
		oldToNewMap.put(this, node);
		return node;
	}
	
	/**
	 * Returns a textual representation of this {@link Start} node.
	 * @return a textual representation of this {@link Start} node
	 */
	public @Override String toString() {
		return "" + toString(this.program)
		 + toString(this.eof);
	}
	
	/**
	 * Returns the {@link NodeEnum} corresponding to the
	 * type of this {@link Node} node.
	 * @return the {@link NodeEnum} for this node
	 */
	@Override public NodeEnum kindNode() {
		return NodeEnum._START_;
	}
	
	/**
	 * Returns the {@link AProgram} node which is the {@code program} child of this {@link Start} node.
	 * @return the {@link AProgram} node which is the {@code program} child of this {@link Start} node
	 */
	public AProgram getProgram() {
		return this.program;
	}
	
	/**
	 * Sets the {@code program} child of this {@link Start} node.
	 * @param value the new {@code program} child of this {@link Start} node
	 */
	public void setProgram(AProgram value) {
		if (this.program != null) {
			this.program.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getProgram() is null");
		}
		this.program = value;
	}
	
	/**
	 * Returns the {@link EOF} node which is the {@code eof} child of this {@link Start} node.
	 * @return the {@link EOF} node which is the {@code eof} child of this {@link Start} node
	 */
	public EOF getEOF() {
		return this.eof;
	}
	
	/**
	 * Sets the {@code eof} child of this {@link Start} node.
	 * @param value the new {@code eof} child of this {@link Start} node
	 */
	public void setEOF(EOF value) {
		if (this.eof != null) {
			this.eof.parent(null);
		}
		if (value != null) {
			if (value.parent() != null) {
				value.parent().removeChild(value);
			}
			value.parent(this);
		} else if (is_optional_invariant) {
			throw new TreeInvariantException(this, ".getEOF() is null");
		}
		this.eof = value;
	}
	
	/**
	 * Removes the {@link Node} {@code child} as a child of this {@link Start} node.
	 * @param child the child node to be removed from this {@link Start} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link Start} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		if (this.program == child) {
			this.program = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getProgram() is null");
			}
			return;
		}
		if (this.eof == child) {
			this.eof = null;
			if (is_optional_invariant) {
				throw new TreeInvariantException(this, ".getEOF() is null");
			}
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Replaces the {@link Node} {@code oldChild} child node of this {@link Start} node.
	 * with the {@link Node} {@code newChild}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link Start} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link Start} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		if (this.program == oldChild) {
			setProgram((AProgram)newChild);
			return;
		}
		if (this.eof == oldChild) {
			setEOF((EOF)newChild);
			return;
		}
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link Start} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
		if(this.program != null) {
			this.program.getDescendants(collection, filter);
		}
		if(this.eof != null) {
			this.eof.getDescendants(collection, filter);
		}
	}
	
	/**
	 * Adds all children of this {@link Start} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
		if(this.program != null) {
			if (filter.accept(this.program)) {
				collection.add((T)this.program);
			}
		}
		if(this.eof != null) {
			if (filter.accept(this.eof)) {
				collection.add((T)this.eof);
			}
		}
	}
	
	@Override public void checkOptionalInvariant() {
		if (is_optional_invariant) {
			if (this.program == null) {
				throw new TreeInvariantException(this, ".getProgram() is null");
			}
			if (this.eof == null) {
				throw new TreeInvariantException(this, ".getEOF() is null");
			}
		}
		if(this.program != null) {
			this.program.setOptionalInvariant(is_optional_invariant);
		}
		if(this.eof != null) {
			this.eof.setOptionalInvariant(is_optional_invariant);
		}
	}
	
	/**
	 * Calls the {@link Analysis#caseStart(Start)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link Start} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseStart(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link Start}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseStart(this);
	}
	
	/**
	 * Applies this {@link Start} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseStart(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link Start} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseStart(this, question);
	}
	
}
