/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

/**
 * {@code SubTypeFilter} implements the {@link NodeFilter} interface by 
 * accepting all nodes that are subtypes of the class given in the constructor and
 * guarding on no nodes.
 *
 * @param <T> the supertype for which the {@code SubTypeFilter} can accept nodes.
 *
 * @author Johnni Winther, jw@brics.dk
 */
public class SubTypeFilter<T extends NodeInterface> implements NodeFilter<T> {
	// the class used for filtering
	protected final Class<T> classT;
	
	/**
	 * Creates a {@code SubTypeFilter} using subtype relation of {@code classT} 
	 * as filtering criterion.
	 * @param classT the class used for filtering
	 */
	public SubTypeFilter(Class<T> classT) {
		this.classT = classT;
	}
	
	/**
	 * Returns {@code true} if {@code node} is a subtype of the class given in
	 * the constructor.
	 * @param node the node in question
	 * @return {@code true} if {@code node} is a subtype of the class given in
	 * the constructor
	 */
	public boolean accept(Node node) {
		return classT.isInstance(node);
	}
	
	/**
	 * Returns {@code true} if {@code node} guards further processesing. The
	 * implementation returns {@code false} on all nodes, effectively disabling
	 * guard functionality.
	 * @param node the node in question
	 * @return {@code true} if {@code node} guards further processesing.
	 */
	public boolean guard(Node node) {
		return false;
	}
}
