/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code TCommentBlock} represents a <code>comment block</code> token from the input file.
 */
@SuppressWarnings("nls")
public final class TCommentBlock extends Token {
	
	/**
	 * Creates a new {@link TCommentBlock} token with {@code text} as text and with no line
	 * and position information.
	 * @param text the text of this {@link TCommentBlock} token
	 */
	public TCommentBlock(String text) {
		setText(text);
	}
	
	/**
	 * Creates a new {@link TCommentBlock} token with {@code text} as text and with the
	 * given line and position information.
	 * @param text the text of this token
	 * @param line the line number information for this {@link TCommentBlock} token
	 * @param pos the line position information for this {@link TCommentBlock} token
	 */
	public TCommentBlock(String text, int line, int pos) {
		setText(text);
		setLine(line);
		setPos(pos);
	}
	
	/**
	 * Creates a new {@link TCommentBlock} token with {@code text} as text which is
	 * an alias of the given token.
	 * @param text the text of this token
	 * @param token the original token for this {@link TCommentBlock} token
	 */
	public TCommentBlock(String text, Token token) {
		super(token);
		setText(text);
		setLine(token.getLine());
		setPos(token.getPos());
	}
	
	/**
	 * Creates a clone of this {@link TCommentBlock} token.
	 * @return a clone of this {@link TCommentBlock} token
	 */
	public @Override TCommentBlock clone() {
		return new TCommentBlock(getText(), getToken());
	}
	
	/**
	 * Creates a deep clone of this {@link TCommentBlock} token while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a clone of this {@link TCommentBlock} token
	 */
	public @Override TCommentBlock clone(Map<Node,Node> oldToNewMap) {
		TCommentBlock token = new TCommentBlock(getText(), getToken());
		oldToNewMap.put(this, token);
		return token;
	}
	
	/**
	 * Returns the {@link TokenEnum} corresponding to the
	 * type of this {@link Token} node.
	 * @return the {@link TokenEnum} for this node
	 */
	@Override public TokenEnum kindToken() {
		return TokenEnum.COMMENTBLOCK;
	}
	
	/**
	 * Calls the {@link Analysis#caseTCommentBlock(TCommentBlock)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link TCommentBlock} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseTCommentBlock(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TCommentBlock}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseTCommentBlock(this);
	}
	
	/**
	 * Applies this {@link TCommentBlock} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseTCommentBlock(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TCommentBlock} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseTCommentBlock(this, question);
	}
	
}
