/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code TIdentifier} represents a <code>identifier</code> token from the input file.
 */
@SuppressWarnings("nls")
public final class TIdentifier extends Token {
	private PDecl _decl_;
	private tip.types.Type _type_;
	
	/**
	 * Creates a new {@link TIdentifier} token with {@code text} as text and with no line
	 * and position information.
	 * @param text the text of this {@link TIdentifier} token
	 */
	public TIdentifier(String text) {
		setText(text);
	}
	
	/**
	 * Creates a new {@link TIdentifier} token with {@code text} as text and with the
	 * given line and position information.
	 * @param text the text of this token
	 * @param line the line number information for this {@link TIdentifier} token
	 * @param pos the line position information for this {@link TIdentifier} token
	 */
	public TIdentifier(String text, int line, int pos) {
		setText(text);
		setLine(line);
		setPos(pos);
	}
	
	/**
	 * Creates a new {@link TIdentifier} token with {@code text} as text which is
	 * an alias of the given token.
	 * @param text the text of this token
	 * @param token the original token for this {@link TIdentifier} token
	 */
	public TIdentifier(String text, Token token) {
		super(token);
		setText(text);
		setLine(token.getLine());
		setPos(token.getPos());
	}
	
	/**
	 * Creates a new {@code TIdentifier} token with the given nodes as children.
	 * The basic child nodes are removed from their previous parents.
	 * @param text the {@code Text} child of this {@link TIdentifier} token
	 * @param token the {@code Token} child of this {@link TIdentifier} token
	 * @param _decl_ the {@code Decl} child of this {@link TIdentifier} token
	 * @param _type_ the {@code Type} child of this {@link TIdentifier} token
	 */
	public TIdentifier(@SuppressWarnings("hiding") String text,
		@SuppressWarnings("hiding") Token token,
		@SuppressWarnings("hiding") PDecl _decl_,
		@SuppressWarnings("hiding") tip.types.Type _type_)
	{
		setText(text);
		setToken(token);
		setDecl(_decl_);
		setType(_type_);
	}
	
	/**
	 * Creates a clone of this {@link TIdentifier} token.
	 * @return a clone of this {@link TIdentifier} token
	 */
	public @Override TIdentifier clone() {
		return new TIdentifier(getText(), getToken(),
		_decl_,
		_type_);
	}
	
	/**
	 * Creates a deep clone of this {@link TIdentifier} token while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a clone of this {@link TIdentifier} token
	 */
	public @Override TIdentifier clone(Map<Node,Node> oldToNewMap) {
		TIdentifier token = new TIdentifier(getText(), getToken(),
		_decl_,
		_type_);
		oldToNewMap.put(this, token);
		return token;
	}
	
	/**
	 * Returns the {@link TokenEnum} corresponding to the
	 * type of this {@link Token} node.
	 * @return the {@link TokenEnum} for this node
	 */
	@Override public TokenEnum kindToken() {
		return TokenEnum.IDENTIFIER;
	}
	
	/**
	 * Returns the {@code decl} field of this {@link TIdentifier} node.
	 * @return the {@code decl} field of this {@link TIdentifier} node
	 */
	public PDecl getDecl() {
		return this._decl_;
	}
	
	/**
	 * Sets the {@code decl} field of this {@link TIdentifier} node.
	 * @param value the new {@code decl} field of this {@link TIdentifier} node
	 */
	public void setDecl(PDecl value) {
		this._decl_ = value;
	}
	
	/**
	 * Returns the {@code type} field of this {@link TIdentifier} node.
	 * @return the {@code type} field of this {@link TIdentifier} node
	 */
	public tip.types.Type getType() {
		return this._type_;
	}
	
	/**
	 * Sets the {@code type} field of this {@link TIdentifier} node.
	 * @param value the new {@code type} field of this {@link TIdentifier} node
	 */
	public void setType(tip.types.Type value) {
		this._type_ = value;
	}
	
	/**
	 * Calls the {@link Analysis#caseTIdentifier(TIdentifier)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link TIdentifier} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseTIdentifier(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TIdentifier}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseTIdentifier(this);
	}
	
	/**
	 * Applies this {@link TIdentifier} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseTIdentifier(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TIdentifier} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseTIdentifier(this, question);
	}
	
}
