/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;
import tip.analysis.*;

/**
 * {@code TNull} represents a <code>&apos;null&apos;</code> token from the input file.
 */
@SuppressWarnings("nls")
public final class TNull extends Token {
	
	/**
	 * Creates a new {@link TNull} token with no line and position information.
	 */
	public TNull() {
		super.setText("null");
	}
	
	/**
	 * Creates a new {@link TNull} token with the given line and position information.
	 * @param line the line number information for this {@link TNull} token
	 * @param pos the line position information for this {@link TNull} token
	 */
	public TNull(int line, int pos) {
		super.setText("null");
		setLine(line);
		setPos(pos);
	}
	
	/**
	 * Creates a new {@link TNull} token that is an alias of the given token.
	 * @param token the original token for this {@link TNull} token
	 */
	public TNull(Token token) {
		super(token);
		super.setText("null");
		setLine(token.getLine());
		setPos(token.getPos());
	}
	
	/**
	 * Creates a clone of this {@link TNull} token.
	 * @return a clone of this {@link TNull} token
	 */
	public @Override TNull clone() {
		return new TNull(getToken());
	}
	
	/**
	 * Creates a deep clone of this {@link TNull} token while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a clone of this {@link TNull} token
	 */
	public @Override TNull clone(Map<Node,Node> oldToNewMap) {
		TNull token = new TNull(getToken());
		oldToNewMap.put(this, token);
		return token;
	}
	
	/**
	 * Returns the {@link TokenEnum} corresponding to the
	 * type of this {@link Token} node.
	 * @return the {@link TokenEnum} for this node
	 */
	@Override public TokenEnum kindToken() {
		return TokenEnum.NULL;
	}
	
	/**
	 * Implements the {@link Token#setText(String)} method. Since TNull represents
	 * fixed token, this method throws a {@link RuntimeException}.
	 * @param text the new text of this token
	 */
	public @Override void setText(@SuppressWarnings("unused") String text) {
		throw new RuntimeException("Cannot change TNull text.");
	}
	
	/**
	 * Calls the {@link Analysis#caseTNull(TNull)} of the {@link Analysis} {@code caller}.
	 * @param sw the {@link Analysis} to which this {@link TNull} node is applied
	 */
	@Override public void apply(Analysis caller) {
		caller.caseTNull(this);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TNull}
	 * node to the {@link Answer} visitor.
	 * @param caller the {@link Answer} to which this node is applied
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <A> A apply(Answer<A> caller) {
		return caller.caseTNull(this);
	}
	
	/**
	 * Applies this {@link TNull} node to the {@link Question} visitor {@code caller}.
	 * @param caller the {@link Question} to which this node is applied
	 * @param question the question provided to {@code caller}
	 */
	@Override public <Q> void apply(Question<Q> caller, Q question) {
		caller.caseTNull(this, question);
	}
	
	/**
	 * Returns the answer for {@code caller} by applying this {@link TNull} node with the
	 * {@code question} to the {@link QuestionAnswer} visitor.
	 * @param caller the {@link QuestionAnswer} to which this node is applied
	 * @param question the question provided to {@code caller}
	 * @return the answer as returned from {@code caller}
	 */
	@Override public <Q,A> A apply(QuestionAnswer<Q,A> caller, Q question) {
		return caller.caseTNull(this, question);
	}
	
}
