/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.node;

import java.util.*;

/**
 * {@code Token} is the superclass of all tokens is the AST.
 */
@SuppressWarnings("nls")
public abstract class Token extends Node {
	private String text;
	private int line;
	private int pos;
	private Token token;
	
	protected Token() {}
	
	protected Token(Token token) {
		this.token = token;
	}
	
	/**
	 * Returns a deep clone of this {@link Token} node.
	 * @return a deep clone of this {@link Token} node
	 */
	public @Override abstract Token clone();
	
	/**
	 * Creates a deep clone of this {@link Token} node while putting all
	 * old node-new node relations in the map {@code oldToNewMap}.
	 * @param oldToNewMap the map filled with the old node-new node relation
	 * @return a deep clone of this {@link Token} node
	 */
	public abstract Token clone(Map<Node,Node> oldToNewMap);
	
	/**
	 * Returns the {@link TokenEnum} corresponding to the
	 * type of this {@link Token} node.
	 * @return the {@link TokenEnum} for this node
	 */
	public abstract TokenEnum kindToken();
	
	/**
	 * Returns the {@link NodeEnum} corresponding to the
	 * type of this {@link Node} node.
	 * @return the {@link NodeEnum} for this node
	 */
	@Override public NodeEnum kindNode() {
		return NodeEnum._TOKEN_;
	}
	
	/**
	 * Returns the original token for this token.
	 * @return the original token for this token
	 */
	public Token getToken() {
		return token == null ? this : token.getToken();
	}
	
	/**
	 * Sets the original token for this token. This should only be call 
	 * from within token constructors.
	 * @param token the original token for this token
	 */
	void setToken(Token token) {
		this.token = token;
	}
	
	/**
	 * Returns the text from the input file from which this token was made.
	 * @return the text from the input file from which this token was made
	 */
	public String getText() {
		return this.text;
	}
	
	/**
	 * Sets the text of this token.
	 * @param text the new text of this token
	 */
	public void setText(@SuppressWarnings("hiding") String text) {
		this.text = text;
	}
	
	/**
	 * Returns the line number information of this token.
	 * @return the line number information of this token
	 */
	public int getLine() {
		return this.line;
	}
	
	/**
	 * Sets the line number information of this token.
	 * @param line the new line number information of this token
	 */
	public void setLine(@SuppressWarnings("hiding") int line) {
		this.line = line;
	}
	
	/**
	 * Returns the position information of this token.
	 * @return the position information of this token
	 */
	public int getPos() {
		return this.pos;
	}
	
	/**
	 * Sets the position information of this token.
	 * @param pos the new position information of this token
	 */
	public void setPos(@SuppressWarnings("hiding") int pos) {
		this.pos = pos;
	}
	
	/**
	 * Returns a textual representation of this {@link Token} node.
	 * @return a textual representation of this {@link Token} node
	 */
	public @Override String toString() {
		return this.text + " ";
	}
	
	/**
	 * Implements the {@link Node#removeChild(Node)} method. Since tokens have no
	 * children, it always throws a {@link RuntimeException}.
	 * @param child the child node to be removed from this {@link Token} node
	 * @throws RuntimeException if {@code child} is not a child of this {@link Token} node
	 */
	@Override void removeChild(@SuppressWarnings("unused") Node child) {
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Implements the {@link Node#replaceChild(Node,Node)} method. Since tokens have no
	 * children, it always throws a {@link RuntimeException}.
	 * @param oldChild the child node to be replaced
	 * @param newChild the new child node of this {@link Token} node
	 * @throws RuntimeException if {@code oldChild} is not a child of this {@link Token} node
	 */
	@Override void replaceChild(@SuppressWarnings("unused") Node oldChild, @SuppressWarnings("unused") Node newChild) {
		throw new RuntimeException("Not a child.");
	}
	
	/**
	 * Adds all descendants of this {@link Token} node (including the node itself) that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the descendants are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getDescendants(Collection<T> collection, NodeFilter<T> filter) {
		if (filter.accept(this)) {
			collection.add((T)this);
		}
		if (filter.guard(this)) {
			return;
		}
	}
	
	/**
	 * Adds all children of this {@link Token} node that are
	 * accepted by the {@link NodeFilter} {@code filter} to {@code collection}.
	 * @param collection the collection to which the children are added
	 * @param filter the {@link NodeFilter} used
	 */
	@SuppressWarnings("unchecked") @Override
	public <T extends NodeInterface> void getChildren(Collection<T> collection, NodeFilter<T> filter) {
	}
	
	@Override public void checkOptionalInvariant() {}
	
}
