/* This file was generated by SableCC (http://www.sablecc.org/). */

package tip.parser;

import tip.lexer.*;
import tip.node.*;
import tip.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser {
	//public final Analysis ignoredTokens = new AnalysisAdapter();

	private final Lexer lexer;
	//private final LinkedList<State> stackList = new LinkedList<State>();
	//private final ListIterator<State> stack = stackList.listIterator();
	private final Stack<State> stack = new Stack<State>();
	private final TokenIndex converter = new TokenIndex();

	private final static int SHIFT = 0;
	private final static int REDUCE = 1;
	private final static int ACCEPT = 2;
	private final static int ERROR = 3;

	public Parser(@SuppressWarnings("hiding") Lexer lexer) {
		this.lexer = lexer;
	}

	@SuppressWarnings({"unchecked","unused"})
	private void pushState(StateInfo stateInfo, int nextStateIndex) throws ParserException, LexerException, IOException {
		ArrayList nodeList = stateInfo.nodes;
		lexer.setState(lexerState[nextStateIndex]);		
		/*if(!stack.hasNext()) {
			stack.add(new State(nextStateIndex, new StateInfo(nodeList)));
			return;
		}*/
		/*State state = stack.next();
		state.stateIndex = nextStateIndex;
		state.info = new StateInfo(nodeList);*/
		stack.push(new State(nextStateIndex, new StateInfo(nodeList)));
	}

	private int gotoState(int nonterminalIndex) {
		int stateIndex = getStateIndex();
		int low = 1;
		int high = gotoTable[nonterminalIndex].length - 1;
		int nextStateIndex = gotoTable[nonterminalIndex][0][1];

		while (low <= high) {
			int middle = (low + high) / 2;
			if (stateIndex < gotoTable[nonterminalIndex][middle][0]) {
				high = middle - 1;
			} else if (stateIndex > gotoTable[nonterminalIndex][middle][0]) {
				low = middle + 1;
			} else {
				nextStateIndex = gotoTable[nonterminalIndex][middle][1];
				break;
			}
		}

		return nextStateIndex;
	}

	private int getStateIndex() {
		/*State state = stack.previous();
		stack.next();
		return state.stateIndex;*/
		return stack.peek().stateIndex;
	}

	private StateInfo popState() {
		State state = stack.pop();
		//State state = stack.previous();
		//parserStateIndex = state.stateIndex;
		return state.info;
	}

	private int getIndex(Token token) {
		converter.index = -1;
		token.apply(converter);
		return converter.index;
	}

	@SuppressWarnings("unchecked")
	public Start parse() throws ParserException, LexerException, IOException {
		pushState(new StateInfo(null), 0);
		while(true) {
			ParserToken lastToken = lexer.peekToken();
			int index = getIndex(lastToken.getToken(0));
			while (index == -1) {
				lexer.consumeToken();
				lastToken = lexer.peekToken();
				index = getIndex(lastToken.getToken(0));
			}

			int stateIndex = getStateIndex();
			int nextAction = Parser.actionTable[stateIndex][0][1];
			int nextActionArg = Parser.actionTable[stateIndex][0][2];

			int low = 1;
			int high = Parser.actionTable[stateIndex].length - 1;

			while (low <= high) {
				int middle = (low + high) / 2;
				if(index < Parser.actionTable[stateIndex][middle][0]) {
					high = middle - 1;
				} else if(index > Parser.actionTable[stateIndex][middle][0]) {
					low = middle + 1;
				} else {
					nextAction = Parser.actionTable[stateIndex][middle][1];
					nextActionArg = Parser.actionTable[stateIndex][middle][2];
					break;
				}
			}

			switch(nextAction) {
				case SHIFT:
					{
						ArrayList<Node> list = new ArrayList<Node>();
						StateInfo info = new StateInfo(list);
						list.add(lastToken.getToken(stateIndex));
						lexer.consumeToken();
						pushState(info, nextActionArg);
					}
					break;
				case REDUCE:
					switch(nextActionArg) {
					case 0: /* reduce  */
						pushState(new0(), gotoState(0));
						break;
					case 1: /* reduce  */
						pushState(new1(), gotoState(0));
						break;
					case 2: /* reduce  */
						pushState(new2(), gotoState(1));
						break;
					case 3: /* reduce  */
						pushState(new3(), gotoState(2));
						break;
					case 4: /* reduce  */
						pushState(new4(), gotoState(3));
						break;
					case 5: /* reduce  */
						pushState(new5(), gotoState(3));
						break;
					case 6: /* reduce  */
						pushState(new6(), gotoState(4));
						break;
					case 7: /* reduce  */
						pushState(new7(), gotoState(4));
						break;
					case 8: /* reduce  */
						pushState(new8(), gotoState(5));
						break;
					case 9: /* reduce  */
						pushState(new9(), gotoState(6));
						break;
					case 10: /* reduce  */
						pushState(new10(), gotoState(6));
						break;
					case 11: /* reduce  */
						pushState(new11(), gotoState(7));
						break;
					case 12: /* reduce  */
						pushState(new12(), gotoState(7));
						break;
					case 13: /* reduce  */
						pushState(new13(), gotoState(8));
						break;
					case 14: /* reduce  */
						pushState(new14(), gotoState(8));
						break;
					case 15: /* reduce  */
						pushState(new15(), gotoState(8));
						break;
					case 16: /* reduce  */
						pushState(new16(), gotoState(9));
						break;
					case 17: /* reduce  */
						pushState(new17(), gotoState(9));
						break;
					case 18: /* reduce  */
						pushState(new18(), gotoState(9));
						break;
					case 19: /* reduce  */
						pushState(new19(), gotoState(10));
						break;
					case 20: /* reduce  */
						pushState(new20(), gotoState(11));
						break;
					case 21: /* reduce  */
						pushState(new21(), gotoState(11));
						break;
					case 22: /* reduce  */
						pushState(new22(), gotoState(12));
						break;
					case 23: /* reduce  */
						pushState(new23(), gotoState(12));
						break;
					case 24: /* reduce  */
						pushState(new24(), gotoState(13));
						break;
					case 25: /* reduce  */
						pushState(new25(), gotoState(13));
						break;
					case 26: /* reduce  */
						pushState(new26(), gotoState(13));
						break;
					case 27: /* reduce  */
						pushState(new27(), gotoState(14));
						break;
					case 28: /* reduce  */
						pushState(new28(), gotoState(14));
						break;
					case 29: /* reduce  */
						pushState(new29(), gotoState(14));
						break;
					case 30: /* reduce  */
						pushState(new30(), gotoState(14));
						break;
					case 31: /* reduce  */
						pushState(new31(), gotoState(14));
						break;
					case 32: /* reduce  */
						pushState(new32(), gotoState(14));
						break;
					case 33: /* reduce  */
						pushState(new33(), gotoState(14));
						break;
					case 34: /* reduce  */
						pushState(new34(), gotoState(14));
						break;
					case 35: /* reduce  */
						pushState(new35(), gotoState(15));
						break;
					case 36: /* reduce  */
						pushState(new36(), gotoState(15));
						break;
					case 37: /* reduce  */
						pushState(new37(), gotoState(15));
						break;
					case 38: /* reduce  */
						pushState(new38(), gotoState(15));
						break;
					case 39: /* reduce  */
						pushState(new39(), gotoState(16));
						break;
					case 40: /* reduce  */
						pushState(new40(), gotoState(16));
						break;
					case 41: /* reduce  */
						pushState(new41(), gotoState(16));
						break;
					case 42: /* reduce  */
						pushState(new42(), gotoState(16));
						break;
					case 43: /* reduce  */
						pushState(new43(), gotoState(17));
						break;
					case 44: /* reduce  */
						pushState(new44(), gotoState(17));
						break;
					case 45: /* reduce  */
						pushState(new45(), gotoState(17));
						break;
					case 46: /* reduce  */
						pushState(new46(), gotoState(18));
						break;
					case 47: /* reduce  */
						pushState(new47(), gotoState(19));
						break;
					case 48: /* reduce  */
						pushState(new48(), gotoState(19));
						break;
					case 49: /* reduce  */
						pushState(new49(), gotoState(20));
						break;
					case 50: /* reduce  */
						pushState(new50(), gotoState(21));
						break;
					case 51: /* reduce  */
						pushState(new51(), gotoState(21));
						break;
					case 52: /* reduce  */
						pushState(new52(), gotoState(22));
						break;
					case 53: /* reduce  */
						pushState(new53(), gotoState(23));
						break;
					case 54: /* reduce  */
						pushState(new54(), gotoState(24));
						break;
					case 55: /* reduce  */
						pushState(new55(), gotoState(25));
						break;
					case 56: /* reduce  */
						pushState(new56(), gotoState(26));
						break;
					case 57: /* reduce  */
						pushState(new57(), gotoState(27));
						break;
					case 58: /* reduce  */
						pushState(new58(), gotoState(28));
						break;
					case 59: /* reduce  */
						pushState(new59(), gotoState(29));
						break;
					case 60: /* reduce  */
						pushState(new60(), gotoState(29));
						break;
					case 61: /* reduce  */
						pushState(new61(), gotoState(30));
						break;
					case 62: /* reduce  */
						pushState(new62(), gotoState(30));
						break;
					case 63: /* reduce  */
						pushState(new63(), gotoState(31));
						break;
					case 64: /* reduce  */
						pushState(new64(), gotoState(31));
						break;
					}
					break;
				case ACCEPT:
					{
						EOF node2 = (EOF)lastToken.getToken(stateIndex);
						lexer.consumeToken();
						StateInfo stateInfo = popState();
						AProgram node1 = (AProgram) stateInfo.nodes.get(0);
						Start node = new Start(node1, node2);
						RoutingAutomaton.updateTree(node);
						return node;
					}
				case ERROR:
					throw new ParserException(lastToken.getToken(stateIndex),
						"[" + lastToken.getLine() + "," + lastToken.getPos() + "] " 
						+ lastToken.getTokenName() + "='" + lastToken.getText() + "' " + 
						Parser.errorMessages[Parser.errors[nextActionArg]]);
			}
		}
	}



	@SuppressWarnings("unchecked")
	StateInfo new0() /* reduce PFunction+ */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AProgram elemNode0;
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		{
			// Block
		LinkedList listNode2 = new LinkedList();
		listNode2 = (LinkedList)nodeArrayList0.get(0);
		if (listNode2 != null) {
			listNode1.addAll(listNode2);
		}
		}

		elemNode0 = new AProgram(listNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new1() /* reduce  */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		AProgram elemNode0;
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		{
			// Block
		}

		elemNode0 = new AProgram(listNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new2() /* reduce TIdentifier PFunctionParams PFunctionBody */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AFuncDecl elemNode0;
		{
			// Block
		TIdentifier elemNode1;
		LinkedList listNode2 = new LinkedList();
		ABody elemNode4;
		elemNode1 = (TIdentifier)nodeArrayList0.get(0);
		{
			// Block
		LinkedList listNode3 = new LinkedList();
		listNode3 = (LinkedList)nodeArrayList1.get(0);
		if (listNode3 != null) {
			listNode2.addAll(listNode3);
		}
		}
		elemNode4 = (ABody)nodeArrayList2.get(0);

		elemNode0 = new AFuncDecl(elemNode1, listNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new3() /* reduce TLPar PFormalParameterList TRPar */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		listNode1 = (LinkedList)nodeArrayList1.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new4() /* reduce PDeclList */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new5() /* reduce  */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		LinkedList listNode0 = new LinkedList();
		{
			// Block
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new6() /* reduce TLBrace PStatementList TReturn PExpression TSemicolon TRBrace */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo5 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList5 = stateInfo5.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABody elemNode0;
		{
			// Block
		ABlock elemNode1;
		{
			// Block
		LinkedList listNode2 = new LinkedList();
		{
			// Block
		LinkedList listNode3 = new LinkedList();
		AReturnStm elemNode4;
		listNode3 = (LinkedList)nodeArrayList1.get(0);
		{
			// Block
		TReturn elemNode5;
		PExp elemNode6;
		elemNode5 = (TReturn)nodeArrayList2.get(0);
		elemNode6 = (PExp)nodeArrayList3.get(0);

		elemNode4 = new AReturnStm(elemNode5, elemNode6);
				}
		if (listNode3 != null) {
			listNode2.addAll(listNode3);
		}
		if (elemNode4 != null) {
			listNode2.add(elemNode4);
		}
		}

		elemNode1 = new ABlock(listNode2);
				}

		elemNode0 = new ABody(elemNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new7() /* reduce TLBrace TReturn PExpression TSemicolon TRBrace */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABody elemNode0;
		{
			// Block
		ABlock elemNode1;
		{
			// Block
		LinkedList listNode2 = new LinkedList();
		{
			// Block
		AReturnStm elemNode3;
		{
			// Block
		TReturn elemNode4;
		PExp elemNode5;
		elemNode4 = (TReturn)nodeArrayList1.get(0);
		elemNode5 = (PExp)nodeArrayList2.get(0);

		elemNode3 = new AReturnStm(elemNode4, elemNode5);
				}
		if (elemNode3 != null) {
			listNode2.add(elemNode3);
		}
		}

		elemNode1 = new ABlock(listNode2);
				}

		elemNode0 = new ABody(elemNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new8() /* reduce PEqualityExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new9() /* reduce PRelationalExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new10() /* reduce PEqualityExpression TEq PRelationalExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		AEqBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TEq elemNode3;
		elemNode3 = (TEq)nodeArrayList1.get(0);

		elemNode2 = new AEqBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new11() /* reduce PAdditiveExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new12() /* reduce PRelationalExpression TGt PAdditiveExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		AGtBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TGt elemNode3;
		elemNode3 = (TGt)nodeArrayList1.get(0);

		elemNode2 = new AGtBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new13() /* reduce PMultiplicativeExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new14() /* reduce PAdditiveExpression TPlus PMultiplicativeExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		APlusBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TPlus elemNode3;
		elemNode3 = (TPlus)nodeArrayList1.get(0);

		elemNode2 = new APlusBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new15() /* reduce PAdditiveExpression TMinus PMultiplicativeExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		AMinusBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TMinus elemNode3;
		elemNode3 = (TMinus)nodeArrayList1.get(0);

		elemNode2 = new AMinusBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new16() /* reduce PPointerExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new17() /* reduce PMultiplicativeExpression TStar PPointerExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		ATimesBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TStar elemNode3;
		elemNode3 = (TStar)nodeArrayList1.get(0);

		elemNode2 = new ATimesBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new18() /* reduce PMultiplicativeExpression TDiv PPointerExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABinopExp elemNode0;
		{
			// Block
		PExp elemNode1;
		ADivideBinop elemNode2;
		PExp elemNode4;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		{
			// Block
		TDiv elemNode3;
		elemNode3 = (TDiv)nodeArrayList1.get(0);

		elemNode2 = new ADivideBinop(elemNode3);
				}
		elemNode4 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new ABinopExp(elemNode1, elemNode2, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new19() /* reduce PExpressionList */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new20() /* reduce PExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		PExp elemNode1;
		elemNode1 = (PExp)nodeArrayList0.get(0);
		if (elemNode1 != null) {
			listNode0.add(elemNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new21() /* reduce PExpressionList TComma PExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		PExp elemNode2;
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		if (elemNode2 != null) {
			listNode0.add(elemNode2);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new22() /* reduce TLPar PArgumentsList TRPar */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		listNode1 = (LinkedList)nodeArrayList1.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new23() /* reduce TLPar TRPar */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new24() /* reduce PPrimaryExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new25() /* reduce TAnd TIdentifier */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		APointerExp elemNode0;
		{
			// Block
		TAnd elemNode1;
		TIdentifier elemNode2;
		elemNode1 = (TAnd)nodeArrayList0.get(0);
		elemNode2 = (TIdentifier)nodeArrayList1.get(0);

		elemNode0 = new APointerExp(elemNode1, elemNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new26() /* reduce TStar PPointerExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ADerefExp elemNode0;
		{
			// Block
		TStar elemNode1;
		PExp elemNode2;
		elemNode1 = (TStar)nodeArrayList0.get(0);
		elemNode2 = (PExp)nodeArrayList1.get(0);

		elemNode0 = new ADerefExp(elemNode1, elemNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new27() /* reduce TIntegerConst */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIntConstExp elemNode0;
		{
			// Block
		TIntegerConst elemNode1;
		elemNode1 = (TIntegerConst)nodeArrayList0.get(0);

		elemNode0 = new AIntConstExp(elemNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new28() /* reduce TIdentifier */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AVarExp elemNode0;
		{
			// Block
		TIdentifier elemNode1;
		elemNode1 = (TIdentifier)nodeArrayList0.get(0);

		elemNode0 = new AVarExp(elemNode1);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new29() /* reduce TInput */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AInputExp elemNode0;
		{
			// Block

		elemNode0 = new AInputExp();
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new30() /* reduce TMalloc */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AMallocExp elemNode0;
		{
			// Block

		elemNode0 = new AMallocExp();
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new31() /* reduce TNull */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ANullExp elemNode0;
		{
			// Block

		elemNode0 = new ANullExp();
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new32() /* reduce TLPar PExpression TRPar */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PExp elemNode0;
		elemNode0 = (PExp)nodeArrayList1.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new33() /* reduce TLPar PExpression TRPar PFunctionArguments */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AFunctionPtrCallExp elemNode0;
		{
			// Block
		PExp elemNode1;
		LinkedList listNode2 = new LinkedList();
		elemNode1 = (PExp)nodeArrayList1.get(0);
		{
			// Block
		LinkedList listNode3 = new LinkedList();
		listNode3 = (LinkedList)nodeArrayList3.get(0);
		if (listNode3 != null) {
			listNode2.addAll(listNode3);
		}
		}

		elemNode0 = new AFunctionPtrCallExp(elemNode1, listNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new34() /* reduce TIdentifier PFunctionArguments */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AFunctionCallExp elemNode0;
		{
			// Block
		TIdentifier elemNode1;
		LinkedList listNode2 = new LinkedList();
		elemNode1 = (TIdentifier)nodeArrayList0.get(0);
		{
			// Block
		LinkedList listNode3 = new LinkedList();
		listNode3 = (LinkedList)nodeArrayList1.get(0);
		if (listNode3 != null) {
			listNode2.addAll(listNode3);
		}
		}

		elemNode0 = new AFunctionCallExp(elemNode1, listNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new35() /* reduce PStatementExpression TSemicolon */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PStm elemNode0;
		elemNode0 = (PStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new36() /* reduce POutputStatement TSemicolon */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AOutputStm elemNode0;
		elemNode0 = (AOutputStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new37() /* reduce PDeclStatement TSemicolon */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ADeclStm elemNode0;
		elemNode0 = (ADeclStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new38() /* reduce PBlockStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABlockStm elemNode0;
		elemNode0 = (ABlockStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new39() /* reduce PStatementWithoutTrailingSubstatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PStm elemNode0;
		elemNode0 = (PStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new40() /* reduce PIfThenStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenStm elemNode0;
		elemNode0 = (AIfThenStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new41() /* reduce PIfThenElseStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenElseStm elemNode0;
		elemNode0 = (AIfThenElseStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new42() /* reduce PWhileStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AWhileStm elemNode0;
		elemNode0 = (AWhileStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new43() /* reduce PStatementWithoutTrailingSubstatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PStm elemNode0;
		elemNode0 = (PStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new44() /* reduce PIfThenElseStatementNoShortIf */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenElseStm elemNode0;
		elemNode0 = (AIfThenElseStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new45() /* reduce PWhileStatementNoShortIf */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AWhileStm elemNode0;
		elemNode0 = (AWhileStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new46() /* reduce PAssignment */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		PStm elemNode0;
		elemNode0 = (PStm)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new47() /* reduce TIdentifier TAssign PExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AAssignVarStm elemNode0;
		{
			// Block
		TAssign elemNode1;
		TIdentifier elemNode2;
		PExp elemNode3;
		elemNode1 = (TAssign)nodeArrayList1.get(0);
		elemNode2 = (TIdentifier)nodeArrayList0.get(0);
		elemNode3 = (PExp)nodeArrayList2.get(0);

		elemNode0 = new AAssignVarStm(elemNode1, elemNode2, elemNode3);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new48() /* reduce TStar PExpression TAssign PExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AAssignPtrStm elemNode0;
		{
			// Block
		TAssign elemNode1;
		PExp elemNode2;
		PExp elemNode3;
		elemNode1 = (TAssign)nodeArrayList2.get(0);
		elemNode2 = (PExp)nodeArrayList1.get(0);
		elemNode3 = (PExp)nodeArrayList3.get(0);

		elemNode0 = new AAssignPtrStm(elemNode1, elemNode2, elemNode3);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new49() /* reduce PStatementBlock */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABlockStm elemNode0;
		{
			// Block
		TLBrace elemNode1;
		ABlock elemNode2;
		elemNode1 = (TLBrace)nodeArrayList0.get(1);
		elemNode2 = (ABlock)nodeArrayList0.get(0);

		elemNode0 = new ABlockStm(elemNode1, elemNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new50() /* reduce TLBrace PStatementList TRBrace */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABlock elemNode0;
		TLBrace elemNode3;
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		{
			// Block
		LinkedList listNode2 = new LinkedList();
		listNode2 = (LinkedList)nodeArrayList1.get(0);
		if (listNode2 != null) {
			listNode1.addAll(listNode2);
		}
		}

		elemNode0 = new ABlock(listNode1);
				}
		elemNode3 = (TLBrace)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		nodeList.add(elemNode3);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new51() /* reduce TLBrace TRBrace */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ABlock elemNode0;
		TLBrace elemNode2;
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		{
			// Block
		}

		elemNode0 = new ABlock(listNode1);
				}
		elemNode2 = (TLBrace)nodeArrayList0.get(0);
		nodeList.add(elemNode0);
		nodeList.add(elemNode2);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new52() /* reduce TOutput PExpression */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AOutputStm elemNode0;
		{
			// Block
		TOutput elemNode1;
		PExp elemNode2;
		elemNode1 = (TOutput)nodeArrayList0.get(0);
		elemNode2 = (PExp)nodeArrayList1.get(0);

		elemNode0 = new AOutputStm(elemNode1, elemNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new53() /* reduce TIf TLPar PExpression TRPar PStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenStm elemNode0;
		{
			// Block
		TLPar elemNode1;
		PExp elemNode2;
		PStm elemNode3;
		elemNode1 = (TLPar)nodeArrayList1.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		elemNode3 = (PStm)nodeArrayList4.get(0);

		elemNode0 = new AIfThenStm(elemNode1, elemNode2, elemNode3);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new54() /* reduce TIf TLPar PExpression TRPar PStatementNoShortIf TElse PStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo6 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList6 = stateInfo6.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo5 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList5 = stateInfo5.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenElseStm elemNode0;
		{
			// Block
		TLPar elemNode1;
		PExp elemNode2;
		PStm elemNode3;
		PStm elemNode4;
		elemNode1 = (TLPar)nodeArrayList1.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		elemNode3 = (PStm)nodeArrayList4.get(0);
		elemNode4 = (PStm)nodeArrayList6.get(0);

		elemNode0 = new AIfThenElseStm(elemNode1, elemNode2, elemNode3, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new55() /* reduce TIf TLPar PExpression TRPar PStatementNoShortIf TElse PStatementNoShortIf */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo6 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList6 = stateInfo6.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo5 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList5 = stateInfo5.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AIfThenElseStm elemNode0;
		{
			// Block
		TLPar elemNode1;
		PExp elemNode2;
		PStm elemNode3;
		PStm elemNode4;
		elemNode1 = (TLPar)nodeArrayList1.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		elemNode3 = (PStm)nodeArrayList4.get(0);
		elemNode4 = (PStm)nodeArrayList6.get(0);

		elemNode0 = new AIfThenElseStm(elemNode1, elemNode2, elemNode3, elemNode4);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new56() /* reduce TWhile TLPar PExpression TRPar PStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AWhileStm elemNode0;
		{
			// Block
		TLPar elemNode1;
		PExp elemNode2;
		PStm elemNode3;
		elemNode1 = (TLPar)nodeArrayList1.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		elemNode3 = (PStm)nodeArrayList4.get(0);

		elemNode0 = new AWhileStm(elemNode1, elemNode2, elemNode3);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new57() /* reduce TWhile TLPar PExpression TRPar PStatementNoShortIf */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo4 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList4 = stateInfo4.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo3 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList3 = stateInfo3.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		AWhileStm elemNode0;
		{
			// Block
		TLPar elemNode1;
		PExp elemNode2;
		PStm elemNode3;
		elemNode1 = (TLPar)nodeArrayList1.get(0);
		elemNode2 = (PExp)nodeArrayList2.get(0);
		elemNode3 = (PStm)nodeArrayList4.get(0);

		elemNode0 = new AWhileStm(elemNode1, elemNode2, elemNode3);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new58() /* reduce TVar PDeclList */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		ADeclStm elemNode0;
		{
			// Block
		TVar elemNode1;
		LinkedList listNode2 = new LinkedList();
		elemNode1 = (TVar)nodeArrayList0.get(0);
		{
			// Block
		LinkedList listNode3 = new LinkedList();
		listNode3 = (LinkedList)nodeArrayList1.get(0);
		if (listNode3 != null) {
			listNode2.addAll(listNode3);
		}
		}

		elemNode0 = new ADeclStm(elemNode1, listNode2);
				}
		nodeList.add(elemNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new59() /* reduce TIdentifier */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		ALocalDecl elemNode1;
		{
			// Block
		TIdentifier elemNode2;
		elemNode2 = (TIdentifier)nodeArrayList0.get(0);

		elemNode1 = new ALocalDecl(elemNode2);
				}
		if (elemNode1 != null) {
			listNode0.add(elemNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new60() /* reduce PDeclList TComma TIdentifier */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo2 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList2 = stateInfo2.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		ALocalDecl elemNode2;
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		{
			// Block
		TIdentifier elemNode3;
		elemNode3 = (TIdentifier)nodeArrayList2.get(0);

		elemNode2 = new ALocalDecl(elemNode3);
				}
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		if (elemNode2 != null) {
			listNode0.add(elemNode2);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new61() /* reduce PStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		PStm elemNode1;
		elemNode1 = (PStm)nodeArrayList0.get(0);
		if (elemNode1 != null) {
			listNode0.add(elemNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new62() /* reduce PStatementList PStatement */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		PStm elemNode2;
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		elemNode2 = (PStm)nodeArrayList1.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		if (elemNode2 != null) {
			listNode0.add(elemNode2);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new63() /* reduce PFunction */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		AFuncDecl elemNode1;
		elemNode1 = (AFuncDecl)nodeArrayList0.get(0);
		if (elemNode1 != null) {
			listNode0.add(elemNode1);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	@SuppressWarnings("unchecked")
	StateInfo new64() /* reduce PFunction+ PFunction */ {
		@SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

		@SuppressWarnings("unused") StateInfo stateInfo1 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList1 = stateInfo1.nodes;
		@SuppressWarnings("unused") StateInfo stateInfo0 = popState();
		@SuppressWarnings("unused") ArrayList nodeArrayList0 = stateInfo0.nodes;
		LinkedList listNode0 = new LinkedList();
		{
			// Block
		LinkedList listNode1 = new LinkedList();
		AFuncDecl elemNode2;
		listNode1 = (LinkedList)nodeArrayList0.get(0);
		elemNode2 = (AFuncDecl)nodeArrayList1.get(0);
		if (listNode1 != null) {
			listNode0.addAll(listNode1);
		}
		if (elemNode2 != null) {
			listNode0.add(elemNode2);
		}
		}
		nodeList.add(listNode0);
		return new StateInfo(nodeList);
	}



	private static int[][][] actionTable;
/*      {
			{0{-1, REDUCE, 1}, {24, SHIFT, 1}, },
			{1{-1, ERROR, 1}, {9, SHIFT, 5}, },
			{2{-1, ERROR, 2}, {25, ACCEPT, -1}, },
			{3{-1, REDUCE, 63}, },
			{4{-1, REDUCE, 0}, {24, SHIFT, 1}, },
			{5{-1, REDUCE, 5}, {24, SHIFT, 8}, },
			{6{-1, ERROR, 6}, {11, SHIFT, 11}, },
			{7{-1, REDUCE, 64}, },
			{8{-1, REDUCE, 59}, },
			{9{-1, ERROR, 9}, {10, SHIFT, 13}, },
			{10{-1, REDUCE, 4}, {14, SHIFT, 14}, },
			{11{-1, ERROR, 11}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {6, SHIFT, 19}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{12{-1, REDUCE, 2}, },
			{13{-1, REDUCE, 3}, },
			{14{-1, ERROR, 14}, {24, SHIFT, 35}, },
			{15{-1, ERROR, 15}, {24, SHIFT, 8}, },
			{16{-1, ERROR, 16}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{17{-1, ERROR, 17}, {9, SHIFT, 52}, },
			{18{-1, ERROR, 18}, {9, SHIFT, 53}, },
			{19{-1, ERROR, 19}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{20{-1, ERROR, 20}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {11, SHIFT, 20}, {12, SHIFT, 55}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{21{-1, ERROR, 21}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{22{-1, ERROR, 22}, {15, SHIFT, 58}, },
			{23{-1, REDUCE, 39}, },
			{24{-1, REDUCE, 61}, },
			{25{-1, ERROR, 25}, {13, SHIFT, 59}, },
			{26{-1, REDUCE, 46}, },
			{27{-1, REDUCE, 38}, },
			{28{-1, REDUCE, 49}, },
			{29{-1, ERROR, 29}, {13, SHIFT, 60}, },
			{30{-1, REDUCE, 40}, },
			{31{-1, REDUCE, 41}, },
			{32{-1, REDUCE, 42}, },
			{33{-1, ERROR, 33}, {13, SHIFT, 61}, },
			{34{-1, ERROR, 34}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {6, SHIFT, 62}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{35{-1, REDUCE, 60}, },
			{36{-1, REDUCE, 58}, {14, SHIFT, 14}, },
			{37{-1, REDUCE, 29}, },
			{38{-1, REDUCE, 30}, },
			{39{-1, REDUCE, 31}, },
			{40{-1, ERROR, 40}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{41{-1, ERROR, 41}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{42{-1, ERROR, 42}, {24, SHIFT, 66}, },
			{43{-1, REDUCE, 27}, },
			{44{-1, REDUCE, 28}, {9, SHIFT, 67}, },
			{45{-1, REDUCE, 52}, },
			{46{-1, REDUCE, 8}, {22, SHIFT, 69}, },
			{47{-1, REDUCE, 9}, {21, SHIFT, 70}, },
			{48{-1, REDUCE, 11}, {16, SHIFT, 71}, {17, SHIFT, 72}, },
			{49{-1, REDUCE, 13}, {18, SHIFT, 73}, {19, SHIFT, 74}, },
			{50{-1, REDUCE, 16}, },
			{51{-1, REDUCE, 24}, },
			{52{-1, ERROR, 52}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{53{-1, ERROR, 53}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{54{-1, ERROR, 54}, {13, SHIFT, 77}, },
			{55{-1, REDUCE, 51}, },
			{56{-1, ERROR, 56}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {11, SHIFT, 20}, {12, SHIFT, 78}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{57{-1, ERROR, 57}, {15, SHIFT, 79}, },
			{58{-1, ERROR, 58}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{59{-1, REDUCE, 35}, },
			{60{-1, REDUCE, 36}, },
			{61{-1, REDUCE, 37}, },
			{62{-1, ERROR, 62}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{63{-1, REDUCE, 62}, },
			{64{-1, ERROR, 64}, {10, SHIFT, 82}, },
			{65{-1, REDUCE, 26}, },
			{66{-1, REDUCE, 25}, },
			{67{-1, ERROR, 67}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {10, SHIFT, 83}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{68{-1, REDUCE, 34}, },
			{69{-1, ERROR, 69}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{70{-1, ERROR, 70}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{71{-1, ERROR, 71}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{72{-1, ERROR, 72}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{73{-1, ERROR, 73}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{74{-1, ERROR, 74}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{75{-1, ERROR, 75}, {10, SHIFT, 93}, },
			{76{-1, ERROR, 76}, {10, SHIFT, 94}, },
			{77{-1, ERROR, 77}, {12, SHIFT, 95}, },
			{78{-1, REDUCE, 50}, },
			{79{-1, ERROR, 79}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{80{-1, REDUCE, 47}, },
			{81{-1, ERROR, 81}, {13, SHIFT, 97}, },
			{82{-1, REDUCE, 32}, {9, SHIFT, 67}, },
			{83{-1, REDUCE, 23}, },
			{84{-1, REDUCE, 20}, },
			{85{-1, ERROR, 85}, {10, SHIFT, 99}, },
			{86{-1, REDUCE, 19}, {14, SHIFT, 100}, },
			{87{-1, REDUCE, 10}, {21, SHIFT, 70}, },
			{88{-1, REDUCE, 12}, {16, SHIFT, 71}, {17, SHIFT, 72}, },
			{89{-1, REDUCE, 14}, {18, SHIFT, 73}, {19, SHIFT, 74}, },
			{90{-1, REDUCE, 15}, {18, SHIFT, 73}, {19, SHIFT, 74}, },
			{91{-1, REDUCE, 17}, },
			{92{-1, REDUCE, 18}, },
			{93{-1, ERROR, 93}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 101}, {5, SHIFT, 102}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{94{-1, ERROR, 94}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{95{-1, REDUCE, 7}, },
			{96{-1, REDUCE, 48}, },
			{97{-1, ERROR, 97}, {12, SHIFT, 109}, },
			{98{-1, REDUCE, 33}, },
			{99{-1, REDUCE, 22}, },
			{100{-1, ERROR, 100}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{101{-1, ERROR, 101}, {9, SHIFT, 111}, },
			{102{-1, ERROR, 102}, {9, SHIFT, 112}, },
			{103{-1, REDUCE, 39}, {4, REDUCE, 43}, },
			{104{-1, REDUCE, 53}, },
			{105{-1, ERROR, 105}, {4, SHIFT, 113}, },
			{106{-1, REDUCE, 44}, },
			{107{-1, REDUCE, 45}, },
			{108{-1, REDUCE, 56}, },
			{109{-1, REDUCE, 6}, },
			{110{-1, REDUCE, 21}, },
			{111{-1, ERROR, 111}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{112{-1, ERROR, 112}, {1, SHIFT, 37}, {7, SHIFT, 38}, {8, SHIFT, 39}, {9, SHIFT, 40}, {18, SHIFT, 41}, {20, SHIFT, 42}, {23, SHIFT, 43}, {24, SHIFT, 44}, },
			{113{-1, ERROR, 113}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 17}, {5, SHIFT, 18}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{114{-1, ERROR, 114}, {10, SHIFT, 117}, },
			{115{-1, ERROR, 115}, {10, SHIFT, 118}, },
			{116{-1, REDUCE, 54}, },
			{117{-1, ERROR, 117}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 101}, {5, SHIFT, 102}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{118{-1, ERROR, 118}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 101}, {5, SHIFT, 102}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{119{-1, ERROR, 119}, {4, SHIFT, 121}, },
			{120{-1, REDUCE, 57}, },
			{121{-1, ERROR, 121}, {0, SHIFT, 15}, {2, SHIFT, 16}, {3, SHIFT, 101}, {5, SHIFT, 102}, {11, SHIFT, 20}, {18, SHIFT, 21}, {24, SHIFT, 22}, },
			{122{-1, REDUCE, 55}, },
		};*/
	private static int[][][] gotoTable;
/*      {
			{0{-1, 2}, },
			{1{-1, 3}, {4, 7}, },
			{2{-1, 6}, },
			{3{-1, 9}, },
			{4{-1, 12}, },
			{5{-1, 45}, {19, 54}, {21, 57}, {40, 64}, {52, 75}, {53, 76}, {58, 80}, {62, 81}, {67, 84}, {79, 96}, {100, 110}, {111, 114}, {112, 115}, },
			{6{-1, 46}, },
			{7{-1, 47}, {69, 87}, },
			{8{-1, 48}, {70, 88}, },
			{9{-1, 49}, {71, 89}, {72, 90}, },
			{10{-1, 85}, },
			{11{-1, 86}, },
			{12{-1, 68}, {82, 98}, },
			{13{-1, 50}, {41, 65}, {73, 91}, {74, 92}, },
			{14{-1, 51}, },
			{15{-1, 23}, {93, 103}, {117, 103}, {118, 103}, {121, 103}, },
			{16{-1, 24}, {34, 63}, {56, 63}, {93, 104}, {94, 108}, {113, 116}, {117, 104}, {118, 108}, {121, 116}, },
			{17{-1, 105}, {117, 119}, {118, 120}, {121, 122}, },
			{18{-1, 25}, },
			{19{-1, 26}, },
			{20{-1, 27}, },
			{21{-1, 28}, },
			{22{-1, 29}, },
			{23{-1, 30}, },
			{24{-1, 31}, },
			{25{-1, 106}, },
			{26{-1, 32}, },
			{27{-1, 107}, },
			{28{-1, 33}, },
			{29{-1, 10}, {15, 36}, },
			{30{-1, 34}, {20, 56}, },
			{31{-1, 4}, },
		};*/
	private static String[] errorMessages;
/*      {
			"expecting: identifier, EOF",
			"expecting: '('",
			"expecting: EOF",
			"expecting: ')', identifier",
			"expecting: '{'",
			"expecting: ')', ';', ','",
			"expecting: ')'",
			"expecting: ')', ','",
			"expecting: 'var', 'output', 'if', 'while', 'return', '{', '*', identifier",
			"expecting: identifier",
			"expecting: 'input', 'malloc', 'null', '(', '*', '&', integer const, identifier",
			"expecting: 'var', 'output', 'if', 'while', '{', '}', '*', identifier",
			"expecting: '='",
			"expecting: 'var', 'output', 'if', 'while', 'return', '{', '}', '*', identifier",
			"expecting: ';'",
			"expecting: 'var', 'output', 'if', 'else', 'while', 'return', '{', '}', '*', identifier",
			"expecting: ';', ','",
			"expecting: ')', ';', ',', '=', '+', '-', '*', '/', '>', '=='",
			"expecting: '(', ')', ';', ',', '=', '+', '-', '*', '/', '>', '=='",
			"expecting: ')', ';', ',', '=', '=='",
			"expecting: ')', ';', ',', '=', '>', '=='",
			"expecting: ')', ';', ',', '=', '+', '-', '>', '=='",
			"expecting: 'input', 'malloc', 'null', '(', ')', '*', '&', integer const, identifier",
			"expecting: '}'",
			"expecting: 'var', 'output', 'if', 'while', '{', '*', identifier",
			"expecting: 'else'",
		};*/
	private static int[] errors;
/*      {
			0, 1, 2, 0, 0, 3, 4, 0, 5, 6, 7, 8, 0, 4, 9, 9, 10, 1, 1, 10, 11, 10, 12, 13, 13, 14, 14, 15, 15, 14, 13, 13, 13, 14, 8, 5, 16, 17, 17, 17, 10, 10, 9, 17, 18, 14, 19, 20, 21, 17, 17, 17, 10, 10, 14, 15, 11, 12, 10, 15, 15, 15, 10, 13, 6, 17, 17, 22, 17, 10, 10, 10, 10, 10, 10, 6, 6, 23, 15, 10, 14, 14, 18, 17, 7, 6, 7, 20, 21, 17, 17, 17, 17, 24, 24, 0, 14, 23, 17, 17, 10, 1, 1, 15, 13, 25, 25, 25, 13, 0, 7, 10, 10, 24, 6, 6, 13, 24, 24, 25, 25, 24, 25, 
		};*/
	private static int[] lexerState = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	};

	static {
		try {
			DataInputStream s = new DataInputStream(
				new BufferedInputStream(
				Parser.class.getResourceAsStream("parser.dat")));

			// read actionTable
			int length = s.readInt();
			Parser.actionTable = new int[length][][];
			for(int i = 0; i < Parser.actionTable.length; i++) {
				length = s.readInt();
				Parser.actionTable[i] = new int[length][3];
				for(int j = 0; j < Parser.actionTable[i].length; j++) {
					for(int k = 0; k < 3; k++) {
						Parser.actionTable[i][j][k] = s.readInt();
					}
				}
			}

			// read gotoTable
			length = s.readInt();
			gotoTable = new int[length][][];
			for(int i = 0; i < gotoTable.length; i++) {
				length = s.readInt();
				gotoTable[i] = new int[length][2];
				for(int j = 0; j < gotoTable[i].length; j++) {
					for(int k = 0; k < 2; k++) {
						gotoTable[i][j][k] = s.readInt();
					}
				}
			}

			// read errorMessages
			length = s.readInt();
			errorMessages = new String[length];
			for(int i = 0; i < errorMessages.length; i++) {
				length = s.readInt();
				StringBuffer buffer = new StringBuffer();

				for(int j = 0; j < length; j++) {
					buffer.append(s.readChar());
				}
				errorMessages[i] = buffer.toString();
			}

			// read errors
			length = s.readInt();
			errors = new int[length];
			for(int i = 0; i < errors.length; i++) {
				errors[i] = s.readInt();
			}

			s.close();
		} catch(Exception e) {
			throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
		}
	}
}
