
package tip.util;

/**
 * {@code DefaultStringifier} implements the {@link Stringifier} by calling the
 * {@link java.lang.Object#toString()} method.
 * 
 * @author Johnni Winther, jw@brics.dk
 * 
 * @param <T> the type for which the stringifier applies
 */
public class DefaultStringifier<T> implements Stringifier<T> {
	/**
	 * {@inheritDoc}
	 */
	public String toString(T t) {
		return t == null ? "null" : t.toString();
	}
}
