
package tip.util;

/**
 * {@code Stringifiable} defines an interface for declaring the
 * applicability of the {@link Stringifier} interface.
 * 
 * @author Johnni Winther, jw@brics.dk
 * 
 * @param <T> the type for which the stringifier applies
 */
public interface Stringifiable<T> {
	
	/**
	 * Returns a text representation using the {@code stringifier}.
	 * @param stringifier the {@link Stringifier} used
	 * @return a text representation using the {@code stringifier}
	 */
	public String toString(Stringifier<T> stringifier);
}
