
package tip.util;

/**
 * {@code Stringifier} defines an interface for abstracting the {@code toString} method.
 * 
 * @author Johnni Winther, jw@brics.dk
 * 
 * @param <T> the type for which the stringifier applies
 */
public interface Stringifier<T> {
	/**
	 * Returns a textual representation of {@code t}.
	 * @param t the object for which a textual representation is returned
	 * @return a textual representation of {@code t}
	 */
	public String toString(T t);
}
