package tip.cfg;

import java.util.*;

public class UnionFind {
	private UnionFind parent;

	private List<UnionFind> children = new LinkedList<UnionFind>();

	public UnionFind() {
		parent = this;
		children.add(this);
	}

	public UnionFind getParent() {
		return parent;
	}

	public UnionFind getRoot() {
		LinkedList<UnionFind> visited = new LinkedList<UnionFind>();
		UnionFind root = this;
		while (root.parent != root) {
			visited.add(root);
			root = root.parent;
		}
		for (UnionFind e : visited) {
			e.parent = root;
		}
		return root;
	}

	public UnionFind union(UnionFind e) {
		UnionFind rootA = getRoot();
		UnionFind rootB = e.getRoot();
		if (rootA == rootB) {
			return rootA;
		}
		UnionFind root, child;
		if (rootA.children.size() > rootB.children.size()) {
			root = rootA;
			child = rootB;
		} else {
			root = rootB;
			child = rootA;
		}
		root.children.addAll(child.children);
		child.parent = root;
		child.unify(root);
		return root;
	}

	@SuppressWarnings("unused")
	protected void unify(UnionFind root) {

	}

	public boolean isRoot() {
		return parent == this;
	}

	public Collection<UnionFind> getCollection() {
		return getRoot().children;
	}

	@Override
	public String toString() {
		return getRoot().rootToString();
	}

	protected String rootToString() {
		return getCollection().toString();
	}
}
