package tip.display;

import tip.*;
import tip.analysis.*;
import tip.node.*;

public class Precedence extends AnswerAdapter<Integer> {

	@Override
	public Integer caseABinopExp(ABinopExp node) {
		switch (node.getBinop().kindPBinop()) {
		case TIMES:
		case DIVIDE:
			return 2;
		case PLUS:
		case MINUS:
			return 3;
		case EQ:
		case GT:
			return 4;
		}
		throw new InternalCompilerError("Unknown binop : " + node.getBinop());
	}

	@Override @SuppressWarnings("unused")
	public Integer caseADerefExp(ADerefExp node) {
		return 1;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAFunctionCallExp(AFunctionCallExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAFunctionPtrCallExp(AFunctionPtrCallExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAInputExp(AInputExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAIntConstExp(AIntConstExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAMallocExp(AMallocExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseANullExp(ANullExp node) {
		return 0;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAPointerExp(APointerExp node) {
		return 1;
	}

	@Override @SuppressWarnings("unused")
	public Integer caseAVarExp(AVarExp node) {
		return 0;
	}
}
