package tip.display;

import tip.node.*;
import tip.types.Type;

public class TypeCheckingDisplay extends ASTDisplay {
	public TypeCheckingDisplay() {
		super("TypeChecking");
	}

	@Override
	public void defaultOutPExp(PExp node) {
		// add custom data
		Type t = node.getType();
		if (t != null) {
			Type.clearMarks();
			t = t.find();
		}
		addField(".type", t);
		// pop the node from the tree stack
		super.defaultOutPExp(node);
	}
	
	@Override
	public void caseTIdentifier(TIdentifier node) {
    	String label = node.getClass().getSimpleName()
			+ "(\"" + node.getText() + "\")";
    	pushTreeNode(label);
		// add custom data
		Type t = node.getType();
		if (t != null) {
			Type.clearMarks();
			t = t.find();
		}
		addField(".type", t);
		// pop the node from the tree stack
		popTreeNode();
	}
}
