package tip.instructions;

import tip.node.*;

public class Icall extends Instruction {
	private AFuncDecl function;

	public Icall(AFuncDecl function) {
		this.function = function;
	}

	public @Override
	String toAsm() {
		return "call " + function.getName().getText();
	}

	public @Override
	int[] genCode() {
		int[] code = { tip.vm.TipVm.OP_CALL, function.getIndex() };
		return code;
	}

	public @Override
	int getCodeSize() {
		return 2;
	}

}
