package tip.phases;

import tip.instructions.*;
import tip.analysis.*;
import tip.node.*;

public class CodeEmission extends DepthFirstAdapter {
	// Program code
	// public int[] PProgram.code;

	private int codePtr;

	private int[] code;

	public void appendCode(int[] c) {
		for (int element : c) {
			code[codePtr++] = element;
		}
	}

	public @Override
	void inAProgram(AProgram program) {
		program.setCode(new int[tip.vm.TipVm.MEM_SIZE]);
		code = program.getCode();
		// codePtr = 1;
		codePtr = 2;
	}

	public @Override
	void outAProgram(AProgram program) {
		AFuncDecl main = program.getFunctions().getLast();
		code[0] = codePtr; // size of code
		code[1] = main.getIndex();
	}

	public @Override
	void inAFuncDecl(AFuncDecl node) {
		PBody body = node.getBody();

		node.setIndex(codePtr);

		// Function header
		int[] header = { node.getNumLocals(), node.getNumArgs() };
		appendCode(header);

		for (Instruction inst : body.getInstructions()) {
			appendCode(inst.genCode());
		}
	}

}