package tip.phases;

import tip.instructions.*;
import tip.analysis.*;
import tip.node.*;

// Phase to calculate the location of functions and instructions
public class CodePrepare extends DepthFirstAdapter {
	private int codePtr;

	public @Override @SuppressWarnings("unused")
	void inAProgram(AProgram program) {
		codePtr = 2;
	}

	public @Override
	void inAFuncDecl(AFuncDecl node) {
		PBody body = node.getBody();

		node.setIndex(codePtr);

		// Function header
		codePtr += 2;

		// Determine locations & labels
		for (Instruction inst : body.getInstructions()) {
			inst.location = codePtr;
			codePtr += inst.getCodeSize();
		}
	}

}