package tip.phases;

import tip.analysis.*;
import tip.node.*;

public class Resources extends DepthFirstAdapter {
	private int next_local_index;

	public @Override @SuppressWarnings("unused")
	void inAFuncDecl(AFuncDecl function) {
		next_local_index = 0;
	}

	public @Override
	void outAFuncDecl(AFuncDecl function) {
		function.setNumArgs(function.getFormals().size());
		function.setNumLocals(next_local_index - function.getNumArgs());
	}

	public @Override
	void inALocalDecl(ALocalDecl local) {
		local.setIndex(next_local_index++);
	}
}
