package tip.phases;

import tip.instructions.*;
import tip.analysis.*;
import tip.node.*;

public class ShowAsm extends DepthFirstAdapter {
	public @Override
	void inAFuncDecl(AFuncDecl node) {
		PBody body = node.getBody();

		System.out.println(".function " + node.getName());
		System.out.println(".locals " + node.getNumLocals());
		System.out.println(".args " + node.getNumArgs());

		for (Instruction inst : body.getInstructions()) {
			if (inst instanceof Ilabel) {
				System.out.println(inst.toAsm());
			} else {
				System.out.println("    " + inst.location + " " + inst.toAsm());
			}
		}

		System.out.println("");
	}

}