package tip.types;

import tip.*;

public class Int extends Type {
	@Override
	public void unify(Type other) {
		Type r1 = find();
		Type r2 = other.find();

		if (r1 == r2) {
			return;
		}

		if (r2 instanceof Variable) {
			r1.union(r2);
			return;
		}
		if (r2 instanceof Int) {
			r1.union(r2);
			return;
		}

		Type.renameRootVariables();
		Errors.errorMessage("Cannot unify '" + r1.toString() + "' with '"
				+ r2.toString() + "'");
		throw new NotUnifiableException();
	}

	public @Override
	String toString() {
		return "int";
	}
}
