package tip.types;

public class Variable extends Type {
	private char name;

	public Variable() {
		name = '-';
	}

	public void setName(char name) {
		this.name = name;
	}

	@Override
	public void unify(Type other) {
		Type r1 = find();
		Type r2 = other.find();

		if (r1 == r2) {
			return;
		}

		if (r1 instanceof Variable && r2 instanceof Variable) {
			r1.union(r2);
			return;
		}

		if (r1 instanceof Variable) {
			r2.unify(r1);
		} else {
			r1.unify(r2);
		}
	}

	public @Override
	String toString() {
		/*
		 * Type root = find(); if(root.isMarked()){ if( root instanceof Variable
		 * ){ return "'"+name; } return "..."; } root.setMarked(); if( root
		 * instanceof Variable ){ return "'"+name; } return root.toString();
		 */
		Type root = find();
		if (root instanceof Variable) {
			return "'" + name;
		}
		return root.toString();

	}

}
